package edu.sdsc.sirius.dialogs;

// GUI
import java.awt.*;
import java.awt.event.*;
import java.io.File;

import javax.swing.*;
import javax.swing.border.*;

// MBT
import edu.sdsc.mbt.*;
import edu.sdsc.sirius.util.Manager;
import edu.sdsc.sirius.md.*;


public class MDPOVDialog extends JDialog implements DisplayDialog {

//  Add for internationalization
	Locale locale;
	private ResourceBundle reslang;
	reslang = ResourceBundle.getBundle("SiriusLangRes", locale);
	private String[] _M_Symbol = new String[10];
// end

	private JFrame parentFrame;
	private Manager parent;
	private MDPanel mdpanel;
	private StructureComponent structureComponent;
	
	private DisplayDialog itself;

	private Container contentPane;
	private JPanel base = new JPanel();
	
	private JPanel topPanel = new JPanel();
	private JPanel outputPanel = new JPanel();
	
	private Border border1;
	private TitledBorder border2;
	private Border border;
	
	private boolean browse = false;
	
	
	private JTextField startField = new JTextField(30);
	private JTextField endField = new JTextField(30);
	
	private ButtonGroup group = new ButtonGroup();
// 	private JRadioButton allFrames = new JRadioButton("Entire trajectory", true);
_M_Symbol[0] = (String)reslang.getObject("M_Entiretrajectory")
	private JRadioButton allFrames = new JRadioButton(_M_Symbol[0], true);
// 	private JRadioButton partFrames = new JRadioButton("Range of frames", false);
_M_Symbol[0] = (String)reslang.getObject("M_Rangeofframes")
	private JRadioButton partFrames = new JRadioButton(_M_Symbol[0], false);
	
	private JTextField dirname = new JTextField(50);
// 	private JButton dirBrowse = new JButton("Browse...");
_M_Symbol[0] = (String)reslang.getObject("M_Browse")
	private JButton dirBrowse = new JButton(_M_Symbol[0]);
	
	private JButton okButton = new JButton("OK");
// 	private JButton cancelButton = new JButton("Cancel");
_M_Symbol[0] = (String)reslang.getObject("M_Cancel")
	private JButton cancelButton = new JButton(_M_Symbol[0]);
		
	public MDPOVDialog(JFrame f, Manager p, MDPanel s){

// 		super(f, "Export MD trajectory as a set of POV-Ray files", false);
_M_Symbol[0] = (String)reslang.getObject("M_ExportMDtrajectory")
		super(f, _M_Symbol[0], false);

		parentFrame = f;
		parent = p;
		mdpanel = s;
		
		parent.setDisplayDialogStatus(true);
		
		itself = this;
		
		//create the panels
		contentPane = getContentPane();
		contentPane.setLayout(null);
		
		base.setBorder(new BevelBorder(BevelBorder.RAISED));
		base.setBounds(5, 5, 290, 180);
		base.setLayout(null);
		
		topPanel.setBounds(5,5,280,110);
		topPanel.setLayout(null);
		
		border1 = BorderFactory.createEmptyBorder(0,0,0,0);//left offset of the boxes in the box
// 		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), " Frame set to export ");
_M_Symbol[0] = (String)reslang.getObject("M_Framesettoexport")
		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), _M_Symbol[0]);
		border2.setTitleColor(Color.black);
		border2.setTitleFont(new Font("Dialog", 0, 12));
		border = BorderFactory.createCompoundBorder(border1, border2);
		topPanel.setBorder(border);
		
	
		//define the radio buttons
		allFrames.setBounds(25,25,150,20);
		allFrames.setVisible(true);
		allFrames.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				startField.setEnabled(false);
				endField.setEnabled(false);
				startField.setEditable(false);
				endField.setEditable(false);
			}
		});

		partFrames.setBounds(25,50,120,20);
		partFrames.setVisible(true);
		partFrames.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				startField.setEnabled(true);
				endField.setEnabled(true);
				startField.setEditable(true);
				endField.setEditable(true);
				startField.requestFocus();
			}
		});
		
		
		group.add(allFrames);
		group.add(partFrames);
		
		topPanel.add(allFrames);
		topPanel.add(partFrames);
		
		
// 		JLabel startLabel = new JLabel("From:");
_M_Symbol[0] = (String)reslang.getObject("M_From")
		JLabel startLabel = new JLabel(_M_Symbol[0]);
		startLabel.setFont(new Font("Dialog", Font.PLAIN, 11));
		startLabel.setBounds(40,75,40,20);
		startLabel.setVisible(true);
		
		startField.setBounds(80,75,60,19);
		startField.setEditable(false);
		startField.setEnabled(false);
		startField.setVisible(true);
		
// 		JLabel endLabel = new JLabel("To:");
_M_Symbol[0] = (String)reslang.getObject("M_To_3")
		JLabel endLabel = new JLabel(_M_Symbol[0]);
		endLabel.setFont(new Font("Dialog", Font.PLAIN, 11));
		endLabel.setBounds(155,75,30,20);
		endLabel.setVisible(true);
		
		endField.setBounds(190,75,50,19);
		endField.setEditable(false);
		endField.setEnabled(false);
		endField.setVisible(true);

		
		topPanel.add(startLabel);
		topPanel.add(startField);
		topPanel.add(endLabel);
		topPanel.add(endField);
		
		base.add(topPanel);
		
		
		
		//dir location
		outputPanel.setBounds(5,115,280,60);
		outputPanel.setLayout(null);
		
		border1 = BorderFactory.createEmptyBorder(0,0,0,0);//left offset of the boxes in the box
// 		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), " Output directory ");
_M_Symbol[0] = (String)reslang.getObject("M_Outputdirectory_3")
		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), _M_Symbol[0]);
		border2.setTitleColor(Color.black);
		border2.setTitleFont(new Font("Dialog", 0, 12));
		border = BorderFactory.createCompoundBorder(border1, border2);
		outputPanel.setBorder(border);
		
		dirname = new JTextField(100);
		dirname.setBounds(25,25,150,20);
		dirname.setEditable(true);
		dirname.setEnabled(true);
		
		dirBrowse.setBounds(180,25,80,20);
		dirBrowse.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				//get the new directory from the user
				//browse the filesystem. select directories
				browse = true;
				JFileChooser chooser = new JFileChooser(parent.getLastUsedDirectory());
// 				chooser.setApproveButtonText("Browse");
_M_Symbol[0] = (String)reslang.getObject("M_Browse_1")
				chooser.setApproveButtonText(_M_Symbol[0]);
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				int result = chooser.showSaveDialog(parent.getApplicationFrame());
				if (result == JFileChooser.CANCEL_OPTION){
					return;
				}
				File file = chooser.getSelectedFile();
				String name = file.toString();
				dirname.setText(name);
				browse = false;
			}
		});
		
		outputPanel.add(dirname);
		outputPanel.add(dirBrowse);
		
		
		base.add(outputPanel);
		
		//buttons
		okButton.setBounds(50, 190, 80, 25);
		okButton.setVisible(true);
		okButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				process();
			}
		});
		
		cancelButton.setBounds(170, 190, 80, 25);
		cancelButton.setVisible(true);
		cancelButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				setVisible(false);
				parent.setDisplayDialogStatus(false);
				dispose();
			}
		});
		
		
		contentPane.add(base);
		contentPane.add(okButton);
		contentPane.add(cancelButton);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				setVisible(false);
				parent.setDisplayDialogStatus(false);
				dispose();
			}
			
			public void windowDeactivated(WindowEvent e){
				if (browse) return;
				toFront();
			}
		});
				
		setSize(305, 250);
		
		//add this to accommodate both applet and application cases
		if (parentFrame == null){
			setBounds(0, 0, getSize().width, getSize().height);
		}
		else{
		
			//set location
			Dimension d1 = getSize();
			Dimension d2 = parentFrame.getSize();
		
			int x = 5 + DialogConstants.toolbarWidth;
			int y = DialogConstants.level + DialogConstants.toolbarHeight;
		
			setBounds(x + parentFrame.getX(), y + parentFrame.getY(), d1.width, d1.height);
		}

		
		setResizable(false);
		
		setVisible(true);
		


	}
	
	private void process(){
		
		parent.setDisplayDialogStatus(false);
		setVisible(false);
		
		if (dirname.getText().length() == 0){
// 			parent.displayErrorMessage("Output directory name must be specified");
_M_Symbol[0] = (String)reslang.getObject("M_Outputdirectorynam")
			parent.displayErrorMessage(_M_Symbol[0]);
			return;
		}
		
		try{
			
			int start = -1;
			int end = -1;
			
			if (partFrames.isSelected()){
				start = Integer.parseInt(startField.getText());
				end = Integer.parseInt(endField.getText());
			}
			
			String out = dirname.getText();
			
			mdpanel.exportPOV(start, end, out);
			
		}
		catch (Exception ex){
// 			parent.displayErrorMessage("All values must be integers");
_M_Symbol[0] = (String)reslang.getObject("M_Allvaluesmustbeint")
			parent.displayErrorMessage(_M_Symbol[0]);
		}
		finally{
			dispose();
		}
	}
	
	public void processPick(String data, StructureComponent structureComponent){}
	
}
