package edu.sdsc.sirius.builder;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import edu.sdsc.sirius.util.Manager;

import javax.swing.border.*;

public class CustomFragmentPanel extends JPanel implements FragmentGroupPanel {
//  Add for internationalization
	Locale locale;
	private ResourceBundle reslang;
	reslang = ResourceBundle.getBundle("SiriusLangRes", locale);
	private String[] _M_Symbol = new String[10];
// end	
// 	private final String NAME = "Custom fragments";
	private final String NAME = M_Customfragments;
	private Manager parent;
	
	private BuilderPanel builderPanel;
	
	private Vector buttons = new Vector();//ids that belong in this panel
	
	private JPanel main = new JPanel();
	private JPanel bondPanel = new JPanel();
	
	public CustomFragmentPanel(){
				
		setBorder(new EmptyBorder(5,5,5,5));
		setLayout(new BorderLayout());
		
		main.setLayout(new GridLayout(5,4));
		main.setPreferredSize(new Dimension(270, 320));
		
		for (int i = 0; i < 20; i++){
			FragmentRecord record = null;
			if (i < FragmentRegistry.getCustomFragmentRecords().size()){
				record = (FragmentRecord)FragmentRegistry.getCustomFragmentRecords().get(i);
			}
			FragmentButton button = new FragmentButton(record, this );
			main.add(button);
			buttons.add(button);
		}
		
		add(main, BorderLayout.NORTH);

	}
	
	public String getFragmentGroupName(){
		return NAME;
	}
	
	public void setParentApplication(Manager c){
		parent = c;
	}
	
	public Manager getParentApplication(){
		return parent;
	}
	
	public void processButtonClick(String id){
		
		if (id == null) return;
		
		//process click appearance
		for (int i = 0; i < buttons.size(); i++){
			FragmentButton b = (FragmentButton)buttons.get(i);
			if (b.number != id) b.setPressed(false);
		}
		
		builderPanel.deselectButtons(this);
		
		FragmentRegistry.activeFragment = id;
		
	}
	
	public void deselectButtons(){
		for (int i = 0; i < buttons.size(); i++){
			FragmentButton b = (FragmentButton)buttons.get(i);
			b.setPressed(false);
		}
		
	}
	
	public void setBuilderPanel(BuilderPanel builderPanel){
		this.builderPanel = builderPanel;
	}
	
	/**
	 * This method runs through records and adds or removes buttons as necessary
	 *
	 */
	public void updatePanel(){
		
		//remove all buttons first
		for (int i = 0; i < buttons.size(); i++){
			FragmentButton b = (FragmentButton)buttons.get(i);
			main.remove(b);
		}
		
		//then rerun through the records to generate buttons again
		for (int i = 0; i < 20; i++){
			FragmentRecord record = null;
			if (i < FragmentRegistry.getCustomFragmentRecords().size()){
				record = (FragmentRecord)FragmentRegistry.getCustomFragmentRecords().get(i);
			}
			FragmentButton button = new FragmentButton(record, this );
			main.add(button);
			buttons.add(button);
		}
		
		revalidate();
		repaint();
		
	}
}
