package edu.sdsc.sirius.builder;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import edu.sdsc.sirius.util.Manager;

import javax.swing.border.*;

public class GeneralFragmentPanel extends JPanel implements FragmentGroupPanel {
//  Add for internationalization
	Locale locale;
	private ResourceBundle reslang;
	reslang = ResourceBundle.getBundle("SiriusLangRes", locale);
	private String[] _M_Symbol = new String[10];
// end	
// 	private final String NAME = "Common fragments";
	private final String NAME = M_Commonfragments;
	private Manager parent;
	private BuilderPanel builderPanel;
	
	private Vector buttons = new Vector();//ids that belong in this panel
	
	private JPanel main = new JPanel();
	private JPanel bondPanel = new JPanel();
	
	public GeneralFragmentPanel(){
				
		setBorder(new EmptyBorder(5,5,5,5));
		setLayout(new BorderLayout());
		
		main.setLayout(new GridLayout(5,4));
		main.setPreferredSize(new Dimension(270, 320));
		
		for (int i = 0; i < 20; i++){
			FragmentButton button = new FragmentButton((FragmentRecord)FragmentRegistry.getFragmentRecords().get(i), this );
			main.add(button);
			buttons.add(button);
		}
		
		
		add(main, BorderLayout.NORTH);
		
		//add bond order buttons
		bondPanel.setLayout(new GridLayout(1,5));
		bondPanel.setPreferredSize(new Dimension(270, 60));
		
		for (int i = 40; i < 44; i++){
			FragmentButton button = new FragmentButton((FragmentRecord)FragmentRegistry.getFragmentRecords().get(i), this );
			bondPanel.add(button);
			buttons.add(button);
		}
		
		add(bondPanel, BorderLayout.SOUTH);
		
	}
	
	public String getFragmentGroupName(){
		return NAME;
	}
	
	public void setParentApplication(Manager c){
		parent = c;
	}
	
	public Manager getParentApplication(){
		return parent;
	}
	
	public void processButtonClick(String id){
		//process click appearance
		for (int i = 0; i < buttons.size(); i++){
			FragmentButton b = (FragmentButton)buttons.get(i);
			if (b.number != id) b.setPressed(false);
		}
		builderPanel.deselectButtons(this);
		
		FragmentRegistry.activeFragment = id;
		
	}
	
	public void setBuilderPanel(BuilderPanel builderPanel){
		this.builderPanel = builderPanel;
	}
	
	public void deselectButtons(){
		for (int i = 0; i < buttons.size(); i++){
			FragmentButton b = (FragmentButton)buttons.get(i);
			b.setPressed(false);
		}
		
	}
	
	public void updatePanel(){}


}
