package edu.sdsc.sirius.search;

import edu.sdsc.mbt.util.*;
import edu.sdsc.mbt.*;
import edu.sdsc.sirius.dialogs.*;
import edu.sdsc.sirius.dialogs.TableImpl.*;
import edu.sdsc.sirius.io.*;
import edu.sdsc.sirius.util.Manager;
import edu.sdsc.sirius.util.DNAProperties;
import edu.sdsc.sirius.util.FileNameFilter;
import edu.sdsc.sirius.util.IOHandler;
import edu.sdsc.sirius.util.ProteinProperties;

import javax.swing.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.Font;
import java.io.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.pdb.webservices.*;
import java.net.*;

public class BlastPDBServicePanel extends JPanel implements SearchServicePanel {
//  Add for internationalization
	Locale locale;
	private ResourceBundle reslang;
	reslang = ResourceBundle.getBundle("SiriusLangRes", locale);
	private String[] _M_Symbol = new String[10];
// end	
	private String name = "BLAST in PDB";
	private Manager callable;
	
	private Entry currentEntry;
	private int currentEntryIndex = -1;//for composite entries
	
	private JPanel topPanel = new JPanel();
	private JRadioButton check1 = new JRadioButton();
	private JTextField field1 = new JTextField(100);
// 	private JRadioButton check2 = new JRadioButton("Sequence file: ");
	private JRadioButton check2 = new JRadioButton(M_Sequencefile);
	private JTextField field2 = new JTextField(100);
	
	private ButtonGroup group = new ButtonGroup();
	
	private JLabel label3 = new JLabel("E-value cutoff:");
	
	private JComboBox combo;
	
// 	private JButton search = new JButton("Search");
	private JButton search = new JButton(M_Search_1);
// 	private JButton clear = new JButton("Clear");
	private JButton clear = new JButton(M_Clear);
// 	private JButton settings = new JButton("Settings...");
	private JButton settings = new JButton(M_Settings);
// 	private JButton browse = new JButton("Browse...");
	private JButton browse = new JButton(M_Browse);
	
	private JScrollPane scrollPane;

	
	private boolean protein = true;
	
	private String outputData;
	
	private JPanel panel1 = new JPanel();
	private JPanel panel2 = new JPanel();
	private JPanel panel3 = new JPanel();
	

	
	private JEditorPane editorPane = new JEditorPane();
		
	private JPanel buttonPanel = new JPanel();
// 	private JButton loadButton = new JButton("Load");
	private JButton loadButton = new JButton(M_Load_4);
// 	private JButton alignmentButton = new JButton("Alignment");
	private JButton alignmentButton = new JButton(M_Alignment_5);
//	private JButton printButton = new JButton("Print");
// 	private JButton clearButton = new JButton("Clear results");
	private JButton clearButton = new JButton(M_Clearresults);
// 	private JButton outputButton = new JButton("Output...");
	private JButton outputButton = new JButton(M_Output_12);
	
	private Border border1;
	private TitledBorder border2;
	private Border border;
	
	private Vector hitList = new Vector();

	private TableViewPanel resultPanel;
	private HashMap dataToRecord = new HashMap();
	
	
	//variables for table implementation of the result list
	private Vector searchTypes;
	private DataSet set;
	private JPanel thisPanel;
	
	
	public BlastPDBServicePanel(){
		
		setLayout(new BorderLayout());

		searchTypes = new Vector();
// 		searchTypes.add("Name");
		searchTypes.add(M_Name_2);
// 		searchTypes.add("Accession");
		searchTypes.add(M_Accession);
// 		searchTypes.add("Description");
		searchTypes.add(M_Description);
// 		searchTypes.add("Evalue");
		searchTypes.add(M_Evalue);
		
		editorPane.setEditable(false);
		
		thisPanel = this;

		topPanel.setPreferredSize(new Dimension(500, 135));
		topPanel.setLocation(new Point(0,0));
		topPanel.setBounds(0,0,500,135);
		topPanel.setLayout(new GridLayout(3,1));

		
		border1 = BorderFactory.createEmptyBorder(0,0,0,0);//left offset of the boxes in the box
// 		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), " Search parameters ");
		border2 = BorderFactory.createTitledBorder(new EtchedBorder(), M_Searchparameters);
		border2.setTitleColor(Color.black);
// 		border2.setTitleFont(new Font("Dialog", 0, 12));
		border2.setTitleFont(new Font(M_Dialog, 0, 12));
		border = BorderFactory.createCompoundBorder(border1, border2);
		topPanel.setBorder(border);
		
		check1.setForeground(Color.black);
// 		check1.setFont(new Font("Dialog", Font.PLAIN, 12));
		check1.setFont(new Font(M_Dialog, Font.PLAIN, 12));
// 		check1.setText("Click query in a viewer: ");
		check1.setText(M_Clickqueryinaviewe);
		check1.setPreferredSize(new Dimension(150,20));
		check1.setBounds(20,25,150,20);
		check1.setLocation(new Point(20,25));
		check1.setVisible(true);
		check1.setSelected(true);
		check1.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				field2.setEditable(false);
				field2.setEnabled(false);
				field1.setEditable(true);
				field1.setEnabled(true);
			}
		});
		
		Vector types = new Vector();
// 		types.add("Protein");
		types.add(M_Protein_4);
// 		types.add("DNA");
		types.add(M_DNA);
		
		JComboBox typeCombo = new JComboBox(types);
		typeCombo.setPreferredSize(new Dimension(60,20));
		typeCombo.setBounds(10,0,60,20);
		typeCombo.setLocation(new Point(10,0));
		typeCombo.setVisible(true);
		
		JPanel temp1 = new JPanel();
		temp1.setLayout(null);
		temp1.setPreferredSize(new Dimension(70,20));
//		temp1.add(typeCombo);

		field1.setPreferredSize(new Dimension(180,20));
		field1.setBounds(280,25,180,20);
		field1.setLocation(new Point(280,25));
		field1.setEditable(true);
		field1.setEnabled(true);
		field1.setVisible(true);
		field1.addKeyListener(new KeyAdapter(){
			public void keyPressed(KeyEvent k){
				if (k.getKeyCode() == KeyEvent.VK_ENTER){
					search.setEnabled(false);
// 					clear.setText("Stop");
					clear.setText(M_Stop);
					Thread runner = new Thread(){
						public void run(){
							process();
// 							clear.setText("Clear");
							clear.setText(M_Clear);
							search.setEnabled(true);
						}
					};
					runner.start();
					
				}
			}
		});

		panel1.setLayout(new BorderLayout());
		panel1.add(check1, BorderLayout.WEST);
		panel1.add(field1, BorderLayout.CENTER);
//		panel1.add(temp1, BorderLayout.EAST);
		panel1.setBorder(new EmptyBorder(7,7,7,7));

		
		check2.setForeground(Color.black);
// 		check2.setFont(new Font("Dialog", Font.PLAIN, 12));
		check2.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		check2.setPreferredSize(new Dimension(105,20));
		check2.setBounds(20,55,105,20);
		check2.setLocation(new Point(20,55));
		check2.setVisible(true);
		check2.setSelected(false);
		check2.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				field1.setEnabled(false);
				field1.setEditable(false);
				field2.setEnabled(true);
				field2.setEditable(true);
			}
		});
		
		field2.setPreferredSize(new Dimension(230,20));
		field2.setBounds(135,55,230,20);
		field2.setLocation(new Point(135,55));
		field2.setEditable(false);
		field2.setEnabled(false);
		field2.setVisible(true);
		field2.addKeyListener(new KeyAdapter(){
			public void keyPressed(KeyEvent k){
				if (k.getKeyCode() == KeyEvent.VK_ENTER){
					search.setEnabled(false);
// 					clear.setText("Stop");
					clear.setText(M_Stop);
					Thread runner = new Thread(){
						public void run(){
							process();
// 							clear.setText("Clear");
							clear.setText(M_Clear);
							search.setEnabled(true);
						}
					};
					runner.start();
					
				}
			}
		});
		

		browse.setPreferredSize(new Dimension(90,20));
//		browse.setLocation(new Point(380, 55));
		browse.setBounds(10, 0, 90, 20);
		browse.setVisible(true);
		browse.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				check1.setSelected(false);
				field1.setEditable(false);
				field1.setEnabled(false);
				check2.setSelected(true);
				field2.setEditable(true);
				field2.setEnabled(true);
				
				
				JFileChooser chooser = new JFileChooser(callable.getLastUsedDirectory());
				chooser.setApproveButtonText("OK");
				chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
// 				chooser.addChoosableFileFilter( new FileNameFilter("fst", "FASTA format") );
				chooser.addChoosableFileFilter( new FileNameFilter("fst", M_FASTAformat) );
// 				chooser.addChoosableFileFilter( new FileNameFilter("aln", "ALN format") );
				chooser.addChoosableFileFilter( new FileNameFilter("aln", M_ALNformat) );
			
				int result = chooser.showOpenDialog(callable.getApplicationFrame());
				if (result == JFileChooser.CANCEL_OPTION){
					return;
				}
				File filename = chooser.getSelectedFile();
				callable.setLastUsedDirectory(filename.getParent());
				field2.setText(filename.toString());
			}
		});

		panel2.setLayout(new BorderLayout());
		panel2.add(check2, BorderLayout.WEST);
		panel2.add(field2, BorderLayout.CENTER);
		
		JPanel temp = new JPanel();
		temp.setLayout(null);
		temp.setPreferredSize(new Dimension(100,20));
		temp.add(browse);
		panel2.add(temp, BorderLayout.EAST);
		panel2.setBorder(new EmptyBorder(7,7,7,7));
		
		
		label3.setForeground(Color.black);
// 		label3.setFont(new Font("Dialog", Font.PLAIN, 12));
		label3.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		label3.setPreferredSize(new Dimension(80,20));
		label3.setBounds(0,5,80,20);
		label3.setLocation(new Point(0,5));
		label3.setVisible(true);
		
		Vector number = new Vector();
		number.add("10");
		number.add("1.0");
		number.add("0.1");
		number.add("0.01");
		number.add("0.001");
		
		//combo box with number of results
		combo = new JComboBox(number);
		combo.setPreferredSize(new Dimension(50,20));
		combo.setBounds(85,5,50,20);
		combo.setLocation(new Point(85,5));
		combo.setVisible(true);

		
		search.setPreferredSize(new Dimension(70,25));
		search.setLocation(new Point(0, 0));
		search.setBounds(0, 0, 70, 25);
		search.setVisible(true);
		search.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				search.setEnabled(false);
// 				clear.setText("Stop");
				clear.setText(M_Stop);
				settings.setEnabled(false);
				Thread runner = new Thread(){
					public void run(){
						process();
// 						clear.setText("Clear");
						clear.setText(M_Clear);
						search.setEnabled(true);
						settings.setEnabled(true);
					}
				};
				runner.start();
				
			}
		});
		
		clear.setPreferredSize(new Dimension(60,25));
		clear.setLocation(new Point(80, 0));
		clear.setBounds(80, 0, 60, 25);
		clear.setVisible(true);
		clear.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
// 				if (clear.getText().equals("Stop")){
				if (clear.getText().equals(M_Stop)){
					//search is in progress, cancel it
					/**
					 * TODO
					 */
					return;
				}
				
				
				field1.setText("");
				field2.setText("");
				combo.setSelectedIndex(0);
			}
		});
		
		settings.setPreferredSize(new Dimension(90,25));
		settings.setLocation(new Point(150, 0));
		settings.setBounds(150, 0, 90, 25);
		settings.setVisible(true);
		settings.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				//check current settings
				//get display dialog status first
				boolean status = callable.getDisplayDialogStatus();
				if (status) return;
				Thread runner = new Thread(){
					public void run(){
						BlastSettingsDialog d = new BlastSettingsDialog(callable.getApplicationFrame(), callable);
					}
				};
				runner.start();
			}
		});
		
		group.add(check1);
		group.add(check2);
		
		JPanel panel3a = new JPanel();
		panel3a.setLayout(null);
		panel3a.setPreferredSize(new Dimension(230, 30));
		panel3a.add(search);
		panel3a.add(clear);
//		panel3a.add(settings);
		
		JPanel panel3b = new JPanel();
		panel3b.setLayout(null);
		panel3b.setPreferredSize(new Dimension(135, 30));
		panel3b.add(label3);
		panel3b.add(combo);
		
		panel3.setLayout(new BorderLayout());
		panel3.add(panel3a, BorderLayout.WEST);
		panel3.add(panel3b, BorderLayout.EAST);
		panel3.setBorder(new EmptyBorder(3,3,3,7));
		
		
		topPanel.add(panel1);
		topPanel.add(panel2);
		topPanel.add(panel3);
		
//		editorPane.setEditable(false);
		scrollPane = new JScrollPane(editorPane);
		
		buttonPanel.setPreferredSize(new Dimension(500, 45));
//		buttonPanel.setLocation(new Point(0,0));
//		buttonPanel.setBounds(0,0,500,100);
		buttonPanel.setLayout(null);
		
		loadButton.setPreferredSize(new Dimension(60,25));
		loadButton.setLocation(new Point(10, 10));
		loadButton.setBounds(10, 10, 60, 25);
		loadButton.setVisible(true);
		loadButton.setEnabled(false);
		loadButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				Thread runner = new Thread(){
					public void run(){
						load();
					}
				};
				runner.start();
			}
		});
		
		alignmentButton.setPreferredSize(new Dimension(90,25));
		alignmentButton.setLocation(new Point(80, 10));
		alignmentButton.setBounds(80, 10, 90, 25);
		alignmentButton.setVisible(true);
		alignmentButton.setEnabled(false);
		alignmentButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
// 				if (alignmentButton.getText().equals("Back")){
				if (alignmentButton.getText().equals(M_Back_4)){
					//it's showing the abstract, go back
					thisPanel.remove(scrollPane);
					thisPanel.add(resultPanel, BorderLayout.CENTER);
					revalidate();
// 					alignmentButton.setText("Alignment");
					alignmentButton.setText(M_Alignment_5);
					editorPane.setText("");
					repaint();
					clearButton.setEnabled(true);
					outputButton.setEnabled(true);
				}
				else{
					viewAlignment();
				}
			}
		});
		
/*		printButton.setPreferredSize(new Dimension(100,25));
		printButton.setLocation(new Point(260, 10));
		printButton.setBounds(260, 10, 100, 25);
		printButton.setVisible(true);
		printButton.setEnabled(false);
		printButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
// 				System.out.println("Print");
				System.out.println(M_Print_7);
			}
		});
*/
		clearButton.setPreferredSize(new Dimension(100,25));
		clearButton.setLocation(new Point(180, 10));
		clearButton.setBounds(180, 10, 100, 25);
		clearButton.setVisible(true);
		clearButton.setEnabled(false);
		clearButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
		        thisPanel.remove(resultPanel);
		        resultPanel = null;
		        outputData = null;
		        set = null;
		        thisPanel.add(scrollPane, BorderLayout.CENTER);

		        revalidate();
		        repaint();
				loadButton.setEnabled(false);
				alignmentButton.setEnabled(false);
//				printButton.setEnabled(false);
				clearButton.setEnabled(false);
				outputButton.setEnabled(false);
			}
		});

		outputButton.setPreferredSize(new Dimension(90,25));
		outputButton.setLocation(new Point(290, 10));
		outputButton.setBounds(290, 10, 90, 25);
		outputButton.setVisible(true);
		outputButton.setEnabled(false);
		outputButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (outputData != null && outputData.length() > 0){
					//save it to a file
					IOHandler.saveTextFile(outputData, callable, null);
				}

			}
		});

		
		buttonPanel.add(loadButton);
		buttonPanel.add(alignmentButton);
		buttonPanel.add(clearButton);
		buttonPanel.add(outputButton);
		
		this.add(topPanel, BorderLayout.NORTH);
		this.add(scrollPane, BorderLayout.CENTER);
		this.add(buttonPanel, BorderLayout.SOUTH);
		
		
	}
	
	private void process(){
		
		
		
		try{
			

        	//get the sequence
			String sequence = null;
			
//			InputParams params = new InputParams();
			if (check1.isSelected()){
				if (currentEntry == null){
// 					callable.displayErrorMessage("Nothing has been selected: No query sequence");
					callable.displayErrorMessage(M_Nothinghasbeensele);
					return;
				}
				
				if (currentEntry instanceof StructureEntry){
					
					//derive a sequence from the structure
					StringBuffer buffer = new StringBuffer();
					Structure structure = ((StructureEntry)currentEntry).getStructure();
					StructureMap map = structure.getStructureMap();
					for (int i = 0; i < map.getResidueCount(); i++){
						Residue r = map.getResidue(i);
						if (ProteinProperties.isAminoAcid(r.getCompoundCode())){
							buffer.append(AminoAcidInfo.getLetterFromCode(r.getCompoundCode()));
						}
						else if (DNAProperties.isNucleicAcid(r.getCompoundCode())){
							buffer.append(r.getCompoundCode());//it's already single letter
						}
					}
					
					sequence = buffer.toString();
				}
				else if (currentEntry instanceof SequenceEntry){
					//get the sequence directly
					String temp = null;
					if (currentEntryIndex == -1){
						temp = ((SequenceEntry)currentEntry).getSequence().getSequence();
					}
					else{
						temp = ((SequenceEntry)currentEntry).getSequence(currentEntryIndex).getSequence();
					}
					
					Pattern pattern = Pattern.compile("-");
					Matcher matcher = pattern.matcher(temp);
					String temp2 = matcher.replaceAll("");

					Pattern pattern2 = Pattern.compile("\\*");
					Matcher matcher2 = pattern.matcher(temp2);
					sequence = matcher.replaceAll("");
				}
			}
			else{
				//file option
				
				if (field2.getText().length() == 0){
// 					callable.displayErrorMessage("Nothing has been selected: No query sequence");
					callable.displayErrorMessage(M_Nothinghasbeensele);
					return;
				}
				
				String filename = field2.getText();
				Entry e = null;
				if (filename.endsWith("aln")){
					e = (new AlnEntryLoader()).load(filename, -1);
				}
				else if (filename.endsWith("fst") || filename.endsWith("fasta")){
					e = (new FastaEntryLoader()).load(filename, -1);
				}
				
				if (e == null){
// 					callable.displayErrorMessage("Unable to load selected file. Please try again.");
					callable.displayErrorMessage(M_Unabletoloadselect);
					return;
				}
				
				sequence = ((SequenceEntry)e).getSequence(0).getSequence();

			}
			
///			System.out.println("sequence = " + sequence);
			
			if (sequence == null || sequence.length() == 0){
// 				callable.displayErrorMessage("Query sequence is empty. Please check query selection and try again.");
				callable.displayErrorMessage(M_Querysequenceisemp);
				return;
			}
			
			//clean up the previous stuff
			if (resultPanel != null){
		        thisPanel.remove(resultPanel);
		        thisPanel.add(scrollPane, BorderLayout.CENTER);
		        resultPanel = null;
		        
		        loadButton.setEnabled(false);
		        alignmentButton.setEnabled(false);
		        clearButton.setEnabled(false);
		        outputButton.setEnabled(false);
		        
		        
		        revalidate();
		        repaint();
			}

        	hitList.clear();
        	dataToRecord.clear();
        	set = null;

        	
        	PdbWebServiceServiceLocator locator = new PdbWebServiceServiceLocator();
		    String output = null;

        	try {
        		String _url = "http://www.pdb.org/pdb/services/pdbws";
        		URL url = new URL(_url);
        		PdbWebService p = locator.getpdbws(url);
//       		System.out.println("Blasting... ");

//				call the blast program on the PDB server using these parameters
        		output = p.blastPDB(sequence, Double.parseDouble((String)combo.getSelectedItem()), "BLOSUM62" , "html");

        	}
        	catch (Exception e) {
        		e.printStackTrace();
        	}	

		    
        	
        	
		    //each item is the complete result for one blast search
		    //just take the first element
		    if (output == null || output.length() == 0){
// 		    	callable.displayErrorMessage("BLAST search produced no results.");
		    	callable.displayErrorMessage(M_BLASTsearchproduce);
		    	return;
		    }
		    
		    outputData = output;
		    //parse the output
		    
//		    System.out.println(output);
		    String content = null;
		    String header = null;
		    String alignments = null;
// 		    int index = output.indexOf("Sequences producing significant alignments");
		    int index = output.indexOf(M_Sequencesproducing);
		    if ( index != -1){
		    	String temp = output.substring(index);
		    	content = temp.substring(temp.indexOf("\n")).trim();
		    }
		    else{
// 		    	callable.displayErrorMessage("BLAST search produced no results.");
		    	callable.displayErrorMessage(M_BLASTsearchproduce);
		    	return;
		    }
		    
		    int i = content.indexOf("</PRE>");
		    if (i != -1){
		    	header = content.substring(0, i-1);
		    	String temp = content.substring(i);
		    	alignments = temp.substring(0, temp.indexOf("Database:"));
		    }
		    else{
// 		    	callable.displayErrorMessage("BLAST search produced no results.");
		    	callable.displayErrorMessage(M_BLASTsearchproduce);
		    	return;
		    }
		    
//		    System.out.println("header = " + header);
		    
		    set = new DataSet();
		    
		    //parse header
			Pattern pattern = Pattern.compile("^(\\S{4}):\\S:(\\S+?)\\|.+\\/a>\\s+?(\\S+)");
		    int count = 1;
		    StringTokenizer tok = new StringTokenizer(header, "\n", false);
		    while (tok.hasMoreTokens()){
		    	String line = tok.nextToken();
		    		
	    		BlastResultRecord record = new BlastResultRecord();
				DataBlock block = new DataBlock();
				
//				System.out.println("line = " + line);
	    		
				Matcher matcher = pattern.matcher(line);
				if (matcher.matches()){
//					System.out.println("Match");
		    		block.id = new Integer(count).toString();
					block.setEntryId(matcher.group(1));
					record.name = matcher.group(1);
					
					block.setName(matcher.group(1));
					record.description = matcher.group(2);
					
					block.setDescription(matcher.group(2));
					record.evalue = matcher.group(3);
					
					block.setEvalue(matcher.group(3));

		    		dataToRecord.put(block, record);
		    		hitList.add(record);
		    		set.addData(block);
		    		
//		    		System.out.println("set size = " + set.size() + " with last block name = " + block.getName());
		    		
//		    		System.out.println("Added " + block);
		    		
			    	count++;

				}
				else{
//					System.out.println("no match");
					continue;
				}

		    }
		    
		    if (set.size() == 0){
// 		    	callable.displayErrorMessage("No matches have been found.");
		    	callable.displayErrorMessage(M_Nomatcheshavebeenf);
		    	return;
		    }
		    
		    StringBuffer buffer = new StringBuffer();
		    
		    //preprocess alignments by replacing all start record character sequences with $, which are then used
		    //by the StringTokenizer to split up the input
		    StringTokenizer ttt = new StringTokenizer(alignments, "\n", false);
		    while (ttt.hasMoreTokens()){
		    	String token = ttt.nextToken();
		    	if (token.indexOf("PRE>") > -1){
		    		continue;
		    	}
		    	int ii = token.indexOf("</a>");
		    	if ( ii > -1){
		    		buffer.append(token.substring(ii+3));
		    	}
		    	else{
				    buffer.append(token);
		    	}
			    buffer.append("\n");
			    
		    }
		    
		    //process alignments
		    StringTokenizer t = new StringTokenizer(buffer.toString(), ">", false);
		    int counter = 0;
		    while (t.hasMoreTokens()){
		    	try{
			    	String tt = t.nextToken();
			    	((BlastResultRecord)hitList.get(counter)).alignment = tt;
			    	counter++;
		    	}
		    	catch (Exception e){
		    		break;
		    	}
		    }
		    
		    searchTypes = new Vector();
			searchTypes.add("PDB ID");
// 			searchTypes.add("Matched chain");
			searchTypes.add(M_Matchedchain);
			searchTypes.add("E-value");

		    
	        resultPanel = new TableViewPanel(this, set, callable, searchTypes, TableViewPanel.FIRST_COLUMN_NARROW, false);
	        this.remove(scrollPane);
	        this.add(resultPanel, BorderLayout.CENTER);

	        revalidate();
	        repaint();
	        
	        if (hitList.size() > 0){
	        	loadButton.setEnabled(true);
	        	alignmentButton.setEnabled(true);
//	        	printButton.setEnabled(true);
	        	clearButton.setEnabled(true);
	        	outputButton.setEnabled(true);
	        }
	        
		}
		catch (Exception ex){
// 			callable.displayExceptionMessage("Unable to run BLAST search", ex);
			callable.displayExceptionMessage(M_UnabletorunBLASTse, ex);
			search.setEnabled(true);
			settings.setEnabled(true);
// 			clear.setText("Clear");
			clear.setText(M_Clear);
        	loadButton.setEnabled(false);
        	alignmentButton.setEnabled(false);
        	clearButton.setEnabled(false);
        	outputButton.setEnabled(false);
        	
        	hitList.clear();
		}
	}
	
	public String getSearchServiceName(){
		return name;
	}
	
	public void setParentApplication(Manager c){
		callable = c;
	}
	
	/**
	 * A temporary solution for now: index denotes a specific sequence within a composite entry
	 * @param entry
	 * @param index
	 */
	public void processClick(StructureComponent component, Entry entry, int index){
		//get the name from the entry
		
		/**
		 * TODO later add a more complicated analysis, to look for descriptive lines in a parsed pdb file, etc.
		 */
		this.currentEntry = entry;
		this.currentEntryIndex = index;
		if (entry == null){
			field1.setText("");
		}
		else{
			if (entry instanceof SequenceEntry){
				if (index != -1){
					Sequence s = ((SequenceEntry)entry).getSequence(index);
					field1.setText(s.getName());
				}
				else{
					Sequence s = ((SequenceEntry)entry).getSequence();
					field1.setText(s.getName());
				}
			}
			else{
				field1.setText(entry.getName());
			}
			
		}
	}
	
	public void setFocus(){
		field1.requestFocus();
	}
	
	private void viewAlignment(){
		if (resultPanel != null){
			int index = resultPanel.getSelectedRows()[0];
			if (index == -1){
// 				callable.displayMessage("Nothing is selected. Choose a result and try again");
				callable.displayMessage(M_NothingisselectedC);
				return;
			}
			
//			DataBlock block = resultPanel.getDataBlock(index);
			BlastResultRecord record = (BlastResultRecord)hitList.get(index);
			try{
				editorPane.setContentType("text/html");
				StringBuffer buffer = new StringBuffer();
				buffer.append("<pre><font face=\"Courier New, Courier, mono\">");
				buffer.append((String)record.alignment);
				buffer.append("</font></pre>");
				editorPane.setText(buffer.toString());
				
		        thisPanel.remove(resultPanel);
				thisPanel.add(scrollPane, BorderLayout.CENTER);
				scrollPane.getViewport().setViewPosition(new Point(0,0));
				scrollPane.revalidate();
				scrollPane.repaint();
				
// 				alignmentButton.setText("Back");
				alignmentButton.setText(M_Back_4);
				clearButton.setEnabled(false);
				outputButton.setEnabled(false);
			}
			catch (Exception ex){
// 				callable.displayMessage("Alignment is unavailable.");
				callable.displayMessage(M_Alignmentisunavail);
				return;
			}
			
		}
	}
	
	private void load(){
		if (resultPanel != null){
			
			int[] indices = resultPanel.getSelectedRows();
			if (indices.length == 0){
// 				callable.displayMessage("Nothing is selected. Choose a result and try again");
				callable.displayMessage(M_NothingisselectedC);
				return;
			}
			
			if (indices.length > 1){
// 				callable.displayMessage("Please load one structure at a time.");
				callable.displayMessage(M_Pleaseloadonestruc);
				return;
			}
			
			try{

                //get the ids for selected items
				for (int i = 0; i < indices.length; i++){
					if (indices[i] >= hitList.size()){
// 						callable.displayMessage("No structure corresponds to the selected item.");
						callable.displayMessage(M_Nostructurecorresp);
						continue;
					}
					
//					DataBlock block = resultPanel.getDataBlock(indices[i]);
					BlastResultRecord record = (BlastResultRecord)hitList.get(indices[i]);
					
					String id = record.name;
					
					callable.doRcsbLoad(id);
				}
			}
			catch (Exception ex){
// 				callable.displayMessage("Unable to load one or more structures.");
				callable.displayMessage(M_Unabletoloadoneorm);
				return;
			}
			
		}
	}

	public final Entry getCurrentEntry() {
		return currentEntry;
	}

	public final void setCurrentEntry(Entry currentEntry) {
		this.currentEntry = currentEntry;
	}

	
	
}
