package edu.sdsc.sirius.md;

import javax.swing.*;
import javax.swing.border.*;

import edu.sdsc.mbt.viewables.*;
import edu.sdsc.sirius.io.*;
import edu.sdsc.sirius.util.*;
import edu.sdsc.sirius.dialogs.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;

import edu.sdsc.mbt.*;

import java.nio.ByteOrder;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.util.prefs.Preferences;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.zip.*;

import javax.imageio.*;
import javax.imageio.stream.ImageOutputStream;

import javax.swing.event.*;
import javax.swing.filechooser.FileFilter;

import edu.sdsc.mbt.util.*;
import edu.sdsc.sirius.ray.*;

public class MDPanel extends JDialog implements CancelEventHandler {
//  Add for internationalization
	Locale locale;
	private ResourceBundle reslang;
	reslang = ResourceBundle.getBundle("SiriusLangRes", locale);
	private String[] _M_Symbol = new String[10];
// end	
	private Manager callable;
	private StructureDocument structureDocument;
	private JFrame parent;
	
	private int width = 380;
	private int height = 465;
	
	private JPanel base = new JPanel();
	private JPanel coordPanel = new JPanel();
	
	private MDPanel thisObject;
	
	private String ptrajPath = "a";
	
	private String[] symbols = new String[]{ "--", "\\", "|", "/" };
	
	private ParameterSet currentParameterSet;//created when parameter file is read, but loaded and displayed only with coordinates
	
	private Vector frameReference = new Vector();//each position references the position of the frame within its file: for dcd - it's byte offset
	private Vector fileMap;//Files in the same order as frames - referenced for dynamic loading
	private Vector currentFrameSet;
	private Vector chargeSet;//if there are charges in each frame, they are populated
	
	private Vector frameOffsets;//number of frames preceding each trajectory file
	
	public static int frameBufferSize = 50;
	private Structure structure;
	private Entry currentEntry;
	
	private int currentFrame = 0;//frame number in the set that corresponds to the current display (1 when the first frame has been loaded
	//or when a reset has been performed)
	
	public static final int CONTROLLER_AMBER = 0;
	public static final int CONTROLLER_CHARMM = 1;
	
	private int totalFrames = 0;
	
	private final ImageIcon forward = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/image/forward.gif"));
	private final ImageIcon backward = new ImageIcon(getClass().getResource("/edu/sdsc/sirius/image/backward.gif"));

	private CancelDialog cc;
	
	
	private JLabel parfileLabel;
	private JLabel titleLabel;
	private JLabel atomsLabel;
	private JLabel fileLabel;
	private JLabel framesLabel;
	
	private JLabel parfileLabelValue;
	private JLabel titleLabelValue;
	private JLabel atomsLabelValue;
	private JLabel fileLabelValue;
	private JLabel framesLabelValue;

	private JPanel playPanel = new JPanel();
// 	private JButton playButton = new JButton("Play");
	private JButton playButton = new JButton(M_Play);
// 	private JButton stopButton = new JButton("Stop");
	private JButton stopButton = new JButton(M_Stop);
// 	private JButton resetButton = new JButton("Reset");
	private JButton resetButton = new JButton(M_Reset_4);
	private JButton stepForwardButton = new JButton();
	private JButton stepBackButton = new JButton();
	
	private JLabel frameCounter = new JLabel();
	private JTextField frameCounterField;
	
	private JSlider progress;
	
	private boolean buffer = false;
	
	private JPanel speedPanel = new JPanel();
	private JSlider speed;
	
	private boolean[] rmsdMask;
	
	private boolean loadSolvent = false;
	
	private boolean loadingCompleted = false;
	private boolean loadedFirstFrame = false;
	
// 	private JCheckBox replay = new JCheckBox("Play in a loop");
	private JCheckBox replay = new JCheckBox(M_Playinaloop);
	
	private int frameSpeed = 5;
	
	private Thread player;
	
	private JPanel rmsdPanel = new JPanel();
//	private JLabel rmsdLabel = new JLabel("RMSD:");
	private JLabel rmsdLabelValue = new JLabel();
	private JLabel rmsd = new JLabel("RMSD:");
	
// 	private JLabel etotLabel = new JLabel("Total energy:");
	private JLabel etotLabel = new JLabel(M_Totalenergy);
	private JLabel etotLabelValue = new JLabel("");
	
// 	private JLabel ektotLabel = new JLabel("Kinetic energy:");
	private JLabel ektotLabel = new JLabel(M_Kineticenergy);
	private JLabel ektotLabelValue = new JLabel("");
	
// 	private JLabel eptotLabel = new JLabel("Potential energy:");
	private JLabel eptotLabel = new JLabel(M_Potentialenergy);
	private JLabel eptotLabelValue = new JLabel("");
	
	private boolean rmsdBeingUpdated = false;
	private boolean computeRMSD = false;
	
	private Vector currentRMSDFrames = null;
	
	private boolean energyAvailable = false;
	private boolean EXsynch = true;//energy and coordinate records are at the same steps in simulation
	
	private boolean rmsdAvailable = false;//whenever there is more than one frame
	
	private int EXratio = -1;//in case the user set different step recording gaps for E and coordinates
	private int XEratio = -1;
	
	private int[] rate = new int[10];
	
	private JMenuBar menuBar = new JMenuBar();
// 	private JMenuItem menuFileOpenOut = new JMenuItem("Open MD output file...");
	private JMenuItem menuFileOpenOut = new JMenuItem(M_OpenMDoutputfile);
// 	private JMenuItem menuFileOpenPar = new JMenuItem("Open parameter file...");
	private JMenuItem menuFileOpenPar = new JMenuItem(M_Openparameterfile);
// 	private JMenuItem menuFileOpenCoord = new JMenuItem("Open coordinate/trajectory file...");
	private JMenuItem menuFileOpenCoord = new JMenuItem(M_Opencoordinatetraj);
// 	private JMenuItem menuFileOpenPDB = new JMenuItem("Load concatenated PDB file...");
	private JMenuItem menuFileOpenPDB = new JMenuItem(M_LoadconcatenatedPD);
// 	private JMenuItem menuFileSaveParam = new JMenuItem("Save parameter file as PDB...");
	private JMenuItem menuFileSaveParam = new JMenuItem(M_Saveparameterfilea);
// 	private JMenuItem menuFileSave = new JMenuItem("Save trajectory as...");
	private JMenuItem menuFileSave = new JMenuItem(M_Savetrajectoryas);
// 	private JMenuItem menuFileVideo = new JMenuItem("Export trajectory as video...");
	private JMenuItem menuFileVideo = new JMenuItem(M_Exporttrajectoryas);
// 	private JMenuItem menuFileExportPOV = new JMenuItem("Save trajectory as a set of POV-Ray files...");
	private JMenuItem menuFileExportPOV = new JMenuItem(M_Savetrajectoryasas);
// 	private JMenuItem menuFileClear = new JMenuItem("Clear data");
	private JMenuItem menuFileClear = new JMenuItem(M_Cleardata);
// 	private JMenuItem menuFileClose = new JMenuItem("Close MD panel");
	private JMenuItem menuFileClose = new JMenuItem(M_CloseMDpanel);
	
// 	private JCheckBoxMenuItem menuDataSolvent = new JCheckBoxMenuItem("Do not load solvent");
	private JCheckBoxMenuItem menuDataSolvent = new JCheckBoxMenuItem(M_Donotloadsolvent);
// 	private JCheckBoxMenuItem menuDataBuffer = new JCheckBoxMenuItem("Use frame buffering");
	private JCheckBoxMenuItem menuDataBuffer = new JCheckBoxMenuItem(M_Useframebuffering);
// 	private JMenuItem menuDataRMSD = new JMenuItem("Compute RMSD graph...");
	private JMenuItem menuDataRMSD = new JMenuItem(M_ComputeRMSDgraph_1);
	
// 	private JCheckBoxMenuItem menuDataShowRMSD = new JCheckBoxMenuItem("Show RMSD graph");
	private JCheckBoxMenuItem menuDataShowRMSD = new JCheckBoxMenuItem(M_ShowRMSDgraph);
// 	private JCheckBoxMenuItem menuDataShowEnergy = new JCheckBoxMenuItem("Show energy graph");
	private JCheckBoxMenuItem menuDataShowEnergy = new JCheckBoxMenuItem(M_Showenergygraph);
// 	private JCheckBoxMenuItem menuDataShowTemp = new JCheckBoxMenuItem("Show temperature graph");
	private JCheckBoxMenuItem menuDataShowTemp = new JCheckBoxMenuItem(M_Showtemperaturegra);
// 	private JCheckBoxMenuItem menuDataSS = new JCheckBoxMenuItem("Real-time secondary structure update");
	private JCheckBoxMenuItem menuDataSS = new JCheckBoxMenuItem(M_Realtimesecondarys);
// 	private JCheckBoxMenuItem menuDataCenter = new JCheckBoxMenuItem("Keep view centered");
	private JCheckBoxMenuItem menuDataCenter = new JCheckBoxMenuItem(M_Keepviewcentered);
	
	boolean computeSS = false;
	boolean centerView = false;
	
	private Vector currentDataFrames;//data from MD out file. not necessarily directly correspond to frames, since step size may be different
	
	private File[] fileObjects;//File objects each mdcrd file. Energies are read in one sweep (they don't take much memory anyway)
	private HashMap frameCounts = new HashMap();//specifies how many frames each file contains: InputStreamReader -> Integer
	private HashMap dcdHeaders = new HashMap();//File -> DCDHeader
	private String prmtop;//full name of the prmtop file
	
	private HashMap byteChannels = new HashMap();
	private HashMap byteBuffers = new HashMap();//FileChannel -> ByteBuffer
	
	private HashMap auxByteChannels = new HashMap();
	private HashMap auxByteBuffers = new HashMap();//FileChannel -> ByteBuffer

	private Controller controller;
	private HashMap dcdHeaderSizes = new HashMap();//File -> Integer size of header in bytes (added to offset to get the read start)
	
	private EnergyPanel energyPanel;
	private TemperaturePanel tempPanel;
	private RMSDPanel rmsdGraphPanel;
	
	public static final int COORD_RST = 0;
	public static final int COORD_MDCRD = 1;
	public static final int COORD_DCD = 2;
	public static final int COORD_PDB = 3;
	
	public int dataType = 0;
	
	public MDPanel(JFrame p, StructureDocument c){
// 		super(p, "Molecular Dynamics Panel", false);
		super(p, M_MolecularDynamicsP, false);
		
		this.structureDocument = c;
		this.callable = this.structureDocument.parent;
		this.parent = p;
		
		thisObject = this;
		
		WindowAdapter closer = new WindowAdapter(){
			public void windowClosing( WindowEvent event ){
				//save the position of the frame
				setVisible(false);
				
				callable.closeMDPanel();
			}
			
		};
		addWindowListener( closer );
		
		cc = new CancelDialog(callable.getApplicationFrame(), this);
		
		//speed settings: sleep time for each slider position
		rate[0] = 500;
		rate[1] = 250;
		rate[2] = 100;
		rate[3] = 70;
		rate[4] = 50;
		rate[5] = 40;
		rate[6] = 30;
		rate[7] = 20;
		rate[8] = 10;
		rate[9] = 5;
		
		String os = System.getProperty("os.name");
		if (!os.startsWith("Win")){
			ptrajPath = StylesPreferences.ptrajDirectory + File.separator + "ptraj";
		}
		
		//position the window
		Dimension dim = getToolkit().getScreenSize();
		
		//position the panel next to the main window on the right
		//if it ends up being wider than screen, fit it to the width of the screen
		if ((parent.getX() + parent.getWidth() + width) > dim.getWidth()){
			setBounds(dim.width - width, parent.getY(), width, height);
		}
		else{
			setBounds(parent.getX() + parent.getWidth(), parent.getY(), width, height);
		}
		
		base.setLayout(null);
		base.setBounds(5,5,width,height);
		base.setBorder(new BevelBorder(BevelBorder.RAISED));
		
		
		coordPanel.setLayout(null);
		coordPanel.setBounds(5,5,360,160);
// 		coordPanel.setBorder(createTitledBorder("Loaded data"));
		coordPanel.setBorder(createTitledBorder(M_Loadeddata));
		
// 		parfileLabel = new JLabel("Parameter file:");
		parfileLabel = new JLabel(M_Parameterfile);
		parfileLabel.setBounds(30, 25, 90, 20);
// 		parfileLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		parfileLabel.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		parfileLabel.setEnabled(false);
		
		parfileLabelValue = new JLabel("");
		parfileLabelValue.setBounds(150, 25, 200, 20);
// 		parfileLabelValue.setFont(new Font("Dialog", Font.PLAIN, 12));
		parfileLabelValue.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		
// 		fileLabel = new JLabel("Coordinate file:");
		fileLabel = new JLabel(M_Coordinatefile);
		fileLabel.setBounds(30, 50, 90, 20);
// 		fileLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		fileLabel.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		fileLabel.setEnabled(false);
		
		fileLabelValue = new JLabel("");
		fileLabelValue.setBounds(150, 50, 200, 20);
// 		fileLabelValue.setFont(new Font("Dialog", Font.PLAIN, 12));
		fileLabelValue.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		
// 		titleLabel = new JLabel("Structure title:");
		titleLabel = new JLabel(M_Structuretitle);
		titleLabel.setBounds(30, 75, 90, 20);
// 		titleLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		titleLabel.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		titleLabel.setEnabled(false);

		titleLabelValue = new JLabel("");
		titleLabelValue.setBounds(150, 75, 200, 20);
// 		titleLabelValue.setFont(new Font("Dialog", Font.PLAIN, 12));
		titleLabelValue.setFont(new Font(M_Dialog, Font.PLAIN, 12));

// 		atomsLabel = new JLabel("Atom count:");
		atomsLabel = new JLabel(M_Atomcount_1);
		atomsLabel.setBounds(30, 100, 90, 20);
// 		atomsLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		atomsLabel.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		atomsLabel.setEnabled(false);

		atomsLabelValue = new JLabel("");
		atomsLabelValue.setBounds(150, 100, 90, 20);
// 		atomsLabelValue.setFont(new Font("Dialog", Font.PLAIN, 12));
		atomsLabelValue.setFont(new Font(M_Dialog, Font.PLAIN, 12));


// 		framesLabel = new JLabel("Frame count:");
		framesLabel = new JLabel(M_Framecount);
		framesLabel.setBounds(30, 125, 90, 20);
// 		framesLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		framesLabel.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		framesLabel.setEnabled(false);
		
		framesLabelValue = new JLabel("");
		framesLabelValue.setBounds(150, 125, 160, 20);
// 		framesLabelValue.setFont(new Font("Dialog", Font.PLAIN, 12));
		framesLabelValue.setFont(new Font(M_Dialog, Font.PLAIN, 12));

		coordPanel.add(parfileLabel);
		coordPanel.add(parfileLabelValue);
		coordPanel.add(titleLabel);
		coordPanel.add(titleLabelValue);
		coordPanel.add(atomsLabel);
		coordPanel.add(atomsLabelValue);
		coordPanel.add(fileLabel);
		coordPanel.add(fileLabelValue);
		coordPanel.add(framesLabel);
		coordPanel.add(framesLabelValue);
		
		
		playPanel.setLayout(null);
		playPanel.setBounds(5,165,360,120);
// 		playPanel.setBorder(createTitledBorder("Play MD Trajectory"));
		playPanel.setBorder(createTitledBorder(M_PlayMDTrajectory));
		
		progress = new JSlider(JSlider.HORIZONTAL, 0, 100, 0);
		progress.setBounds(25,35,210,25);
		progress.setVisible(true);
		progress.setPaintTicks(true);
		progress.setSnapToTicks(false);
		progress.putClientProperty("JSlider.isFilled", Boolean.TRUE);
		progress.setMajorTickSpacing(10);
		progress.setEnabled(false);
		
		progress.addMouseListener(new MouseAdapter(){
			public void mouseReleased(MouseEvent e){
				if (!loadingCompleted || play){
					updateProgress();
					return;
				}
			
				//get the current frame and reset currentFrame to this value
				int position = progress.getValue();//this value is in percetage points
				int frame = Math.round( (float)((double)position*(double)currentFrameSet.size()) /100);
				if (frame == 0) frame = 1;
				
				currentFrame = frame;
				if (controller != null) controller.reset();
				frameCounterField.setText(new Integer(frame).toString());
				step(true);
				
			}
		});
		
		progress.addMouseMotionListener(new MouseMotionAdapter(){
			public void mouseDragged(MouseEvent e){
				if (!loadingCompleted || play) return;
				
				//get the current position of the slider
				int position = progress.getValue();//this value is in percentage points
				int frame = Math.round( (float)((double)position*(double)currentFrameSet.size()) /100);
				if (frame == 0) frame = 1;
				frameCounterField.setText(new Integer(frame).toString());
				
			}
			
		});
		

		playPanel.add(progress);
		
		//buttons
		playButton.setBounds(25, 75, 60, 20);
		playButton.setEnabled(false);
		playButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				stopButton.setEnabled(true);
				resetButton.setEnabled(true);
				frameSpeed = speed.getValue();
				
				if (stopped){
					restart();
				}
				else{
					play();
				}
				playButton.setEnabled(false);
				stepForwardButton.setEnabled(false);
				stepBackButton.setEnabled(false);
			}
		});
		
		stopButton.setBounds(95, 75, 60, 20);
		stopButton.setEnabled(false);
		stopButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				stop();
				stopButton.setEnabled(false);
				playButton.setEnabled(true);
				stepForwardButton.setEnabled(true);
				if (currentFrame > 1 && controller == null) stepBackButton.setEnabled(true);
			}
		});
		
		resetButton.setBounds(165, 75, 65, 20);
		resetButton.setEnabled(false);
		resetButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				reset();
				resetButton.setEnabled(false);
				playButton.setEnabled(true);
				stopButton.setEnabled(false);
				stepForwardButton.setEnabled(true);
				stepBackButton.setEnabled(false);
			}
		});
		
		stepBackButton.setBounds(250, 75, 40, 20);
		stepBackButton.setEnabled(false);
		stepBackButton.setIcon(backward);
		stepBackButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				step(false);
			}
		});
		
		stepForwardButton.setBounds(300, 75, 40, 20);
		stepForwardButton.setEnabled(false);
		stepForwardButton.setIcon(forward);
		stepForwardButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				resetButton.setEnabled(true);
				step(true);
			}
		});

// 		frameCounter = new JLabel("Frame");
		frameCounter = new JLabel(M_Frame_3);
		frameCounter.setBounds(245, 30, 40, 20);
// 		frameCounter.setFont(new Font("Dialog", Font.PLAIN, 12));
		frameCounter.setFont(new Font(M_Dialog, Font.PLAIN, 12));
		frameCounter.setEnabled(false);
		
		frameCounterField = new JTextField(20);
		frameCounterField.setBounds(290, 30, 50, 20);
		frameCounterField.setEnabled(false);
		frameCounterField.setEditable(false);
		frameCounterField.setText("0");
		frameCounterField.addKeyListener(new KeyAdapter(){
			public void keyPressed(KeyEvent e){
				if (e.getKeyCode() == KeyEvent.VK_ENTER){
					if (controller != null && !loadingCompleted){
						frameCounterField.setText(new Integer(currentFrame).toString());
						return;
					}
					
					try{
						int f = Integer.parseInt(frameCounterField.getText());
						if (f < 0){
// 							callable.displayErrorMessage("Frame number must be a positive integer");
							callable.displayErrorMessage(M_Framenumbermustbea);
							return;
						}
						
						skip(f);
					}
					catch (NumberFormatException ex){
// 						callable.displayErrorMessage("Frame number must be a positive integer");
						callable.displayErrorMessage(M_Framenumbermustbea);
					}
				}
			}
		});
		
		playPanel.add(playButton);
		playPanel.add(stopButton);
		playPanel.add(resetButton);
		playPanel.add(stepForwardButton);
		playPanel.add(stepBackButton);
		playPanel.add(frameCounter);
		playPanel.add(frameCounterField);
		
		rmsdPanel.setLayout(null);
		rmsdPanel.setBounds(5,285,260,120);
// 		rmsdPanel.setBorder(createTitledBorder("Parameters of the run"));
		rmsdPanel.setBorder(createTitledBorder(M_Parametersoftherun));

		rmsd.setBounds(25,25,100,20);
		rmsd.setEnabled(false);
		
		rmsdLabelValue.setBounds(160, 25, 70, 20);
		rmsdLabelValue.setHorizontalAlignment(SwingConstants.RIGHT);
		rmsdLabelValue.setText("");
		
		rmsdPanel.add(rmsd);
//		rmsdPanel.add(rmsdLabel);
		rmsdPanel.add(rmsdLabelValue);
		
		
		etotLabel.setBounds(25,50,100,20);
		etotLabel.setEnabled(false);
		etotLabelValue.setBounds(160, 50, 70, 20);
		etotLabelValue.setHorizontalAlignment(SwingConstants.RIGHT);
		rmsdPanel.add(etotLabel);
		rmsdPanel.add(etotLabelValue);
		
		ektotLabel.setBounds(25,70,100,20);
		ektotLabel.setEnabled(false);
		ektotLabelValue.setBounds(160, 70, 70, 20);
		ektotLabelValue.setHorizontalAlignment(SwingConstants.RIGHT);
		rmsdPanel.add(ektotLabel);
		rmsdPanel.add(ektotLabelValue);
		
		eptotLabel.setBounds(25,90,100,20);
		eptotLabel.setEnabled(false);
		eptotLabelValue.setBounds(160, 90, 70, 20);
		eptotLabelValue.setHorizontalAlignment(SwingConstants.RIGHT);
		rmsdPanel.add(eptotLabel);
		rmsdPanel.add(eptotLabelValue);
		
		
		speedPanel.setLayout(null);
		speedPanel.setBounds(265,285,100,120);
// 		speedPanel.setBorder(createTitledBorder("Speed"));
		speedPanel.setBorder(createTitledBorder(M_Speed));

		speed = new JSlider(JSlider.VERTICAL, 1, 10, 5);
		speed.setBounds(25,25,25,80);
		speed.setVisible(true);
		speed.setPaintTicks(true);
		speed.setSnapToTicks(true);
//		speed.putClientProperty("JSlider.isFilled", Boolean.TRUE);
		speed.setMajorTickSpacing(1);
		speed.setEnabled(false);
		speed.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e){
				frameSpeed = speed.getValue();
			}
		});

		speedPanel.add(speed);

		
		
		base.add(coordPanel);
		base.add(playPanel);
		base.add(rmsdPanel);
		base.add(speedPanel);
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(createMenuBar(), BorderLayout.NORTH);
		getContentPane().add(base, BorderLayout.CENTER);
		
		
		setSize(width, height);
		setResizable(false);

		setVisible(true);

	}
	
	private void readPDBFile(){
		
		File file = fileObjects[0];
		
		if (file == null) return;

		Thread runner = new Thread(){
			public void run(){
				readFirstFrame();//call this method to wait for the input data to arrive
			}
		};
		runner.start();
		
		fileLabel.setEnabled(true);
		//get the file name
		int index = file.toString().lastIndexOf(File.separator);
		if (index > 0){
			fileLabelValue.setText(file.toString().substring(index+1));
		}
		else{
			fileLabelValue.setText(file.toString());
		}

		try{
			
			BufferedReader reader = null;
			
			int itemCount = currentParameterSet.atomCount*3;

			currentFrameSet = new Vector();
			
			String line = null;
			
			for (int k = 0; k < fileObjects.length; k++){
				reader = new BufferedReader(getReader(fileObjects[k]));
				
				try{
					int lineCount = 0;
					double[] data = new double[itemCount];
					int dataCount = 0;
					while ((line = reader.readLine()) != null){
						if (line.startsWith("ATOM") || line.startsWith("HETATM")){
							//read coordinates
							data[dataCount++] = Double.parseDouble( line.substring(30,38).trim());
							data[dataCount++] = Double.parseDouble( line.substring(38,46).trim());
							data[dataCount++] = Double.parseDouble( line.substring(46,54).trim());
							
							lineCount++;
						}
						
						if (line.startsWith("END")){
							currentFrameSet.add(data);
							dataCount = 0;
							data = new double[itemCount];
							lineCount = 0;
							
							//update the frame count
// 							framesLabelValue.setText("Loading (" + currentFrameSet.size() + ")");
							framesLabelValue.setText(M_Loading_3 + currentFrameSet.size() + ")");

							if (currentFrameSet.size() == 1){
								//wait until the loading is done, then proceed with loading frames
								while (true){
									Thread.sleep(2);
									if (loadedFirstFrame) break;
								}
							}
							
							continue;
						}
							
					
						if (lineCount == 500){
							lineCount = 0;
							Thread.sleep(1);
						}
					}
					
				}	
				catch (Exception e){
					e.printStackTrace();
					continue;
				}
			}
				
			
			loadingCompleted = true;
			framesLabelValue.setText(new Integer(currentFrameSet.size()).toString());
		}
		catch (Exception ex){
			ex.printStackTrace();
		}
		
	
	}
	
	/**
	 * This method is called from a separate thread of the event handler
	 * @param reader
	 */
	private void readMDFile(){
		
		if (currentParameterSet == null){
// 			callable.displayErrorMessage("Parameter file must be loaded before the MD trajectory file");
			callable.displayErrorMessage(M_Parameterfilemustb);
			return;
		}
		
		File file = fileObjects[0];
		
		if (file == null) return;

		Thread runner = new Thread(){
			public void run(){
				readFirstFrame();//call this method to wait for the input data to arrive
			}
		};
		runner.start();
		
		fileLabel.setEnabled(true);
		//get the file name
		int index = file.toString().lastIndexOf(File.separator);
		if (index > 0){
			fileLabelValue.setText(file.toString().substring(index+1));
		}
		else{
			fileLabelValue.setText(file.toString());
		}

		try{
			
			BufferedReader reader = null;
			int factor = 0;
			if (currentParameterSet.box > 0) factor = 3;//three more values per frame for box parameters
			
			int itemCount = currentParameterSet.atomCount*3 + factor;//total number of values for each frame in the file
			
			int limitNoSolvent = (currentParameterSet.solventStartAtom-1)*3;//number of values that should be read if no solvent loaded
			boolean solventPresent = false;

			currentFrameSet = new Vector();
			for (int k = 0; k < fileObjects.length; k++){
				reader = new BufferedReader(getReader(fileObjects[k]));
				
				String line = reader.readLine();//may or may not have data
				
				double[] data = null;
				if (loadSolvent){
					data = new double[itemCount];//initialization of the first set of coordinates
				}
				else{
					if (currentParameterSet.solventStartResidue > 1){
						solventPresent = true;
						data = new double[limitNoSolvent];//initialization of the first set of coordinates
					}
					else{
						//there is no solvent anyway
						data = new double[itemCount];
					}
				}


				int lineCount = 0;
				int i = 0;//counter of read blocks of coordinates
				int dataCount = 0;
				while ((line = reader.readLine()) != null){
					try{
						for (int j = 0; j < 10; j++){
							if (loadSolvent || !solventPresent){
								data[dataCount] = Double.parseDouble(line.substring(j*8, (j+1)*8).trim());
								dataCount++;
							}
							else{
								//check if there is solvent
								if (solventPresent && i < limitNoSolvent){
									data[dataCount] = Double.parseDouble(line.substring(j*8, (j+1)*8).trim());
									dataCount++;
								}
								else{
									line.substring(j*8, (j+1)*8);//to throw the exception if the line is too short (otherwise, blanks may be counted)
								}
							}
							i++;
							if (i == itemCount){
								currentFrameSet.add(data);
								
								//update the frame count
// 								framesLabelValue.setText("Loading (" + currentFrameSet.size() + ")");
								framesLabelValue.setText(M_Loading_3 + currentFrameSet.size() + ")");
								
								if (loadSolvent || !solventPresent){
									data = new double[itemCount];
								}
								else{
									data = new double[limitNoSolvent];
								}
								
								if (currentFrameSet.size() == 1){
									//wait until the loading is done, then proceed with loading frames
									while (true){
										Thread.sleep(2);
										if (loadedFirstFrame) break;
									}
								}
								
								dataCount = 0;
								i = 0;
							}
						}
						
						if (lineCount == 500){
							lineCount = 0;
							Thread.sleep(1);
						}
					}
					catch (StringIndexOutOfBoundsException e){
						continue;
					}
					catch (ArrayIndexOutOfBoundsException e){
//						e.printStackTrace();
						continue;
					}
					catch (Exception e){
//						e.printStackTrace();
						continue;
					}
					
					lineCount++;
				}
				
			}
			
			
			loadingCompleted = true;
			framesLabelValue.setText(new Integer(currentFrameSet.size()).toString());
		}
		catch (Exception ex){
			ex.printStackTrace();
		}
		
	}
	
	
	private void readDCDFile(){
		
		if (currentParameterSet == null){
// 			callable.displayErrorMessage("Parameter file must be loaded before the MD trajectory file");
			callable.displayErrorMessage(M_Parameterfilemustb);
			return;
		}
		
		DCDHeader referenceHeader = null;
		totalFrames = 0;
		dcdHeaders = new HashMap();
		for (int i = 0; i < fileObjects.length; i++){
			DCDHeader header = MDUtils.getDCDHeader(fileObjects[i]);
			dcdHeaders.put(fileObjects[i], header);
			totalFrames += header.frameCount;
			if (i == 0) referenceHeader = header;
		}
		
		if (referenceHeader.qcryst != 0){
			currentParameterSet.box = 1;
		}
		
		
		if (referenceHeader.atomCount != currentParameterSet.atomCount){
// 			callable.displayErrorMessage("Selected DCD file(s) doesn't match the loaded PSF or PDB file.");
			callable.displayErrorMessage(M_SelectedDCDfilesdo);
			return;
		}

		File file = fileObjects[0];
		
		Thread runner = new Thread(){
			public void run(){
				readFirstFrame();//call this method to wait for the input data to arrive
			}
		};
		runner.start();
		
		fileLabel.setEnabled(true);
		//get the file name
		int index = file.toString().lastIndexOf(File.separator);
		if (index > 0){
			fileLabelValue.setText(file.toString().substring(index+1));
		}
		else{
			fileLabelValue.setText(file.toString());
		}

		try{
			
			int factor = 0;
			if (currentParameterSet.box > 0) factor = 3;//three more values per frame for box parameters
//			System.out.println("currentParameterSet box = " + currentParameterSet.box);
			
			int itemCount = currentParameterSet.atomCount*3 + factor;//total number of values for each frame in the file
			int limitNoSolvent = (currentParameterSet.solventStartAtom-1)*3 + factor;//number of values that should be read if no solvent loaded
			boolean solventPresent = false;
			
			currentFrameSet = new Vector();

			
			DCDHeader h = MDUtils.getDCDHeader(fileObjects[0]);
			double[] data = null;
			float[] charges = null;
			if (h.qcg > 0){
				//there are charges
				charges = new float[currentParameterSet.atomCount];//initialization of the first set of coordinates
			}

			if (loadSolvent){
				data = new double[itemCount];//initialization of the first set of coordinates
			}
			else{
				if (currentParameterSet.solventStartResidue > 1){
					solventPresent = true;
					data = new double[limitNoSolvent];//initialization of the first set of coordinates
				}
				else{
					//there is no solvent anyway
					data = new double[itemCount];
				}
			}
			
			
				
			
			int counter = 1;

			for (int k = 0; k < fileObjects.length; k++){
				
				MappedByteBuffer byteBuffer = getByteBuffer(fileObjects[k]);
				DCDHeader currentHeader = (DCDHeader)dcdHeaders.get(fileObjects[k]);
				
				int offset = currentHeader.headerSize;
				byteBuffer.position(offset);
				
				for (int f = 0; f < currentHeader.frameCount; f++){
					
					int i = 0;
					
					int dataCount = 0;
					
					//check for qcryst
					if (currentHeader.qcryst > 0){
						int v = byteBuffer.getInt();
//						System.out.println("reading qcryst: v = " + v);
						int reads = v/8;
						for (int vv = 0; vv < reads; vv++){
							byteBuffer.getDouble();
						}
						int vvv = byteBuffer.getInt();
					}
					
					//first, read all X's for this frame
					int a = byteBuffer.getInt();
					for (int j = 0; j < currentParameterSet.atomCount; j++){
						float c = byteBuffer.getFloat();
						if (loadSolvent || !solventPresent){
							data[dataCount] = (double)c;
							dataCount += 3;//fast forward to the next X
							i++;
						}
						else{
							//check if there is solvent
							if (solventPresent && i < limitNoSolvent){
								data[dataCount] = (double)c;
								dataCount += 3;
								i++;
							}
						}
					}
					int aa = byteBuffer.getInt();
					
					dataCount = 1;
					
					i = 0;
					//read Y records
					byteBuffer.getInt();
					for (int j = 0; j < currentParameterSet.atomCount; j++){
						float c = byteBuffer.getFloat();
						if (loadSolvent || !solventPresent){
							data[dataCount] = (double)c;
							dataCount += 3;//fast forward to the next Y
							i++;
						}
						else{
							//check if there is solvent
							if (solventPresent && i < limitNoSolvent){
								data[dataCount] = (double)c;
								dataCount += 3;
								i++;
							}
						}
					}
					byteBuffer.getInt();
					
					//read Z records
					i = 0;
					dataCount = 2;
					byteBuffer.getInt();
					for (int j = 0; j < currentParameterSet.atomCount; j++){
						float c = byteBuffer.getFloat();
						if (loadSolvent || !solventPresent){
							data[dataCount] = (double)c;
							dataCount += 3;//fast forward to the next Z
							i++;
						}
						else{
							//check if there is solvent
							if (solventPresent && i < limitNoSolvent){
								data[dataCount] = (double)c;
								dataCount += 3;
								i++;
							}
						}
					}
					byteBuffer.getInt();
					
					i = 0;
					if (currentHeader.qcg > 0){
						int bbb = byteBuffer.getInt();
//						System.out.println("reading qcg at " + bbb);
						for (int j = 0; j < currentParameterSet.atomCount; j++){
							charges[i] = byteBuffer.getFloat();
							i++;
						}
						int aaa = byteBuffer.getInt();
//						System.out.println("aaa = " + aaa);
					}
					
//					System.out.println("recorded " + i + " z values");

					if (currentFrameSet.size() >= counter){
						currentFrameSet.set(counter-1, data);
						if (charges != null) chargeSet.set(counter-1, charges);
					}
					else{
						currentFrameSet.add(data);
						if (charges != null) chargeSet.add(charges);
					}
					
					if (currentFrameSet.size() == 1){
						//wait for the first frame loader to finish
						while (true){
							try{
								Thread.sleep(5);
								if (loadedFirstFrame) break;
							}
							catch (InterruptedException ex){
								break;
							}
						}
						
					}
					
					//update the frame count
// 					if (!loadingCompleted) framesLabelValue.setText("Loading (" + counter + ")");
					if (!loadingCompleted) framesLabelValue.setText(M_Loading_3 + counter + ")");
					counter++;
					
					if (loadSolvent || !solventPresent){
						data = new double[itemCount];
					}
					else{
						data = new double[limitNoSolvent];
					}
					
				}
				
			}
			
			loadingCompleted = true;
			framesLabelValue.setText(new Integer(currentFrameSet.size()).toString());
			
		}
		catch (Exception ex){
			ex.printStackTrace();
		}
		
	
	}
	
	public Vector getCurrentFrameSet(){
		return currentFrameSet;
	}
	
	private void readFirstFrame(){

		while (true){
			
			if (currentFrameSet != null && currentFrameSet.size() > 0) break;
			
			try{
				Thread.sleep(10);
			}
			catch (InterruptedException e){
				e.printStackTrace();
				break;
			}
			
		}
		
		//since we are here, there is the first frame
		
		Vector atoms = currentParameterSet.atoms;
		//check for solvent flags
		if (!loadSolvent && currentParameterSet.solventStartResidue > -1){
			int left = currentParameterSet.solventStartAtom - 1;//size of atoms to be left
			int remove = atoms.size() - left;
			int count = 0;
			currentParameterSet.solventAtoms.clear();
			for (int i = atoms.size()-1; i >= 0; i--){
				currentParameterSet.solventAtoms.insertElementAt(atoms.get(i), 0);
				atoms.remove(i);
				count++;
				if (count == remove) break;
			}
		}
		else{
			//if load with solvent, check whether the atoms list is complete
			//it may have been trimmed down in the previous load
			if (atoms.size() < currentParameterSet.atomCount){
				//add solvent atoms
				atoms.addAll(currentParameterSet.solventAtoms);
				currentParameterSet.solventAtoms.clear();//to keep things consistent
			}
		}
		
		atoms.trimToSize();
		
//		System.out.println("atoms size = " + atoms.size());
		
		//this is a trajectory file: read the first snapshot and load the structure
		//then load the remaining frames, get frame count and display the playback controls
		
		//read the first chunk of coordinates and load the structure
		//then determine the total number of frames
		//store coordinates in a vector of arrays (length of arrays is known from the prmtop file)
		
		titleLabel.setEnabled(true);
		atomsLabel.setEnabled(true);
		framesLabel.setEnabled(true);
		
		titleLabelValue.setText(currentParameterSet.title);
		atomsLabelValue.setText(new Integer(atoms.size()).toString());
		
		double[] initial = (double[])currentFrameSet.get(0);
		float[] charges = null;
		if (chargeSet != null && chargeSet.size() > 0){
			charges = (float[])chargeSet.get(0);
		}
		
		//load the structure from this set
		//go through the atoms and assign coordinates
		int j = 0;//coordinate counter
		for (int i = 0; i < atoms.size(); i++){
			((Atom)atoms.get(i)).coordinate[0] = initial[j++];
			((Atom)atoms.get(i)).coordinate[1] = initial[j++];
			((Atom)atoms.get(i)).coordinate[2] = initial[j++];
			
			if (charges != null){
//				System.out.println("charges = " + charges[i]);
				((Atom)atoms.get(i)).partialCharge = charges[i];
			}
		}
		
		int max = initial.length;
//		System.out.println("X = " + initial[max-3] + ", Y = " + initial[max-2] + ", Z = " + initial[max-1]);

		
		//now use the atom list to create the new StructureEntry
		Hashtable components = new Hashtable();
		components.put(StructureComponentRegistry.TYPE_ATOM, atoms);
		
		
		
		if (currentParameterSet.bonds.size() > 0){
			//check whether bonds need to be trimmed down
			for (int i = currentParameterSet.bonds.size()-1; i >= 0; i--){
				Bond bond = (Bond)currentParameterSet.bonds.get(i);
				if (!atoms.contains(bond.getAtom(0)) || !atoms.contains(bond.getAtom(1))){
					currentParameterSet.bonds.remove(bond);
				}
			}
			
			components.put(StructureComponentRegistry.TYPE_BOND, currentParameterSet.bonds);
		}
		
		structure = IOHandler.getStructure(components, currentParameterSet.title);
		
		if (structure == null){
// 			callable.displayErrorMessage("Unable to load structure");
			callable.displayErrorMessage(M_Unabletoloadstruct_1);
			return;
		}
		
		StructureEntry entry = new StructureEntry();
		entry.setStructure(structure);
		entry.setName(currentParameterSet.title);
		
		currentEntry = entry;
		
		//load the new entry
		callable.addEntry(entry, true, true);
		
		loadedFirstFrame = true;

		progress.setEnabled(true);
		playButton.setEnabled(true);
		stepForwardButton.setEnabled(true);
		stepBackButton.setEnabled(false);
		speed.setEnabled(true);
		
		currentFrame = 1;
		frameCounter.setEnabled(true);
		frameCounterField.setEnabled(true);
		frameCounterField.setText("1");
		frameCounterField.setEditable(true);
		
		//check whether energy graph is requested
		if (menuDataShowEnergy.isSelected()){
			if (energyAvailable){
				openEnergyPanel();
			}
			else{
// 				System.out.println("no energy records available");
				System.out.println(M_noenergyrecordsava);
			}
		}
		
	}
	
	private synchronized void updateRMSDMask(int flag, String set, boolean selection){
		
		if (currentParameterSet == null) return;
		
		Structure structure = (Structure)callable.getStructureViewer().getLoadedStructures().get(0);
		StructureStyles styles = structure.getStructureMap().getStructureStyles();
		
		//just in case rmsd is selected or may be selected in the future, check what computation option is chosen
		if (flag == MDRMSDDialog.USE_ALL_EXCEPT_SOLVENT){
			//set up a mask array
			if (currentParameterSet == null) return;
			rmsdMask = new boolean[currentParameterSet.atoms.size()*3];//for fast lookup, a flag for each coordinate
			if (currentParameterSet.solventStartAtom > -1){
				//check whether this value is beyond the number of loaded atoms (solvent is actually loaded)
				int k = 0;
				if (currentParameterSet.solventStartAtom < currentParameterSet.atoms.size()){
					for (int i = 0; i < currentParameterSet.solventStartAtom - 1; i++){
						Atom a = (Atom)currentParameterSet.atoms.get(k);
						if (selection){
							if (styles.isSelected(a)){
								rmsdMask[k++] = true;
								rmsdMask[k++] = true;
								rmsdMask[k++] = true;
							}
							else{
								rmsdMask[k++] = false;
								rmsdMask[k++] = false;
								rmsdMask[k++] = false;
							}
						}
						else{
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
						}
					}
					for (int i = currentParameterSet.solventStartAtom - 1; i < currentParameterSet.atoms.size(); i++){
						rmsdMask[k++] = false;
						rmsdMask[k++] = false;
						rmsdMask[k++] = false;
					}
				}
				else{
					//solvent has not been loaded, so all masked values are set to true
					for (int i = 0; i < currentParameterSet.atoms.size(); i++){
						Atom a = (Atom)currentParameterSet.atoms.get(k);
						if (selection){
							if (styles.isSelected(a)){
								rmsdMask[k++] = true;
								rmsdMask[k++] = true;
								rmsdMask[k++] = true;
							}
							else{
								rmsdMask[k++] = false;
								rmsdMask[k++] = false;
								rmsdMask[k++] = false;
							}
						}
						else{
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
						}
					}
				}
			}
			else{
				//all true if no solvent loaded
				if (currentParameterSet != null){
					int k = 0;
					rmsdMask = new boolean[currentParameterSet.atoms.size()*3];//for fast lookup, a flag for each coordinate
					for (int i = 0; i < currentParameterSet.atoms.size(); i++){
						Atom a = (Atom)currentParameterSet.atoms.get(i);
						if (selection){
							if (styles.isSelected(a)){
								rmsdMask[k++] = true;
								rmsdMask[k++] = true;
								rmsdMask[k++] = true;
							}
							else{
								rmsdMask[k++] = false;
								rmsdMask[k++] = false;
								rmsdMask[k++] = false;
							}
						}
						else{
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
						}
					}
				}
			}
		}
		else if (flag == MDRMSDDialog.USE_ALL_HEAVY_ATOMS_EXCEPT_SOLVENT){

			rmsdMask = new boolean[currentParameterSet.atoms.size()*3];//for fast lookup, a flag for each coordinate
			int k = 0;
			for (int i = 0; i < currentParameterSet.atoms.size(); i++){
				if (currentParameterSet.solventStartAtom > 1 && i >= currentParameterSet.solventStartAtom - 1){
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					continue;
				}
				
				Atom a = (Atom)currentParameterSet.atoms.get(i);
				if (a.element != 1){
					if (selection){
						if (styles.isSelected(a)){
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;

						}
						else{
							rmsdMask[k++] = false;
							rmsdMask[k++] = false;
							rmsdMask[k++] = false;
						}
					}
					else{
						rmsdMask[k++] = true;
						rmsdMask[k++] = true;
						rmsdMask[k++] = true;
					}
				}
				else{
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
				}
			}
		}
		else if (flag == MDRMSDDialog.USE_BACKBONE_ATOMS){

			rmsdMask = new boolean[currentParameterSet.atoms.size()*3];//for fast lookup, a flag for each coordinate
			int k = 0;
			for (int i = 0; i < currentParameterSet.atoms.size(); i++){
				if (currentParameterSet.solventStartAtom > 1 && i >= currentParameterSet.solventStartAtom - 1){
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					continue;
				}
				
				Atom a = (Atom)currentParameterSet.atoms.get(i);
				if (a.backbone){
					if (selection){
						if (styles.isSelected(a)){
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;

						}
						else{
							rmsdMask[k++] = false;
							rmsdMask[k++] = false;
							rmsdMask[k++] = false;
						}
					}
					else{
						rmsdMask[k++] = true;
						rmsdMask[k++] = true;
						rmsdMask[k++] = true;
					}
				}
				else{
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
				}
			}
		}
		else if (flag == MDRMSDDialog.USE_CA_ATOMS){

			rmsdMask = new boolean[currentParameterSet.atoms.size()*3];//for fast lookup, a flag for each coordinate
			int k = 0;
			for (int i = 0; i < currentParameterSet.atoms.size(); i++){
				if (currentParameterSet.solventStartAtom > 1 && i >= currentParameterSet.solventStartAtom - 1){
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					continue;
				}
				
				Atom a = (Atom)currentParameterSet.atoms.get(i);
				if (a.name.equals("CA")){
					if (selection){
						if (styles.isSelected(a)){
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;

						}
						else{
							rmsdMask[k++] = false;
							rmsdMask[k++] = false;
							rmsdMask[k++] = false;
						}
					}
					else{
						rmsdMask[k++] = true;
						rmsdMask[k++] = true;
						rmsdMask[k++] = true;
					}
				}
				else{
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
				}
			}
		}
		else if (flag == MDRMSDDialog.USE_DEFINED_SET){
			
			Vector atomset = (Vector)callable.getStructureViewer().getAtomSets().get(set);
			
			//since atom sets can contain both residues and atoms, process it to make sure we have a uniform Atom list
			Vector list = new Vector();
			for (int i = 0; i < atomset.size(); i++){
				try{
					Atom a = (Atom)atomset.get(i);
					list.add(a);
				}
				catch (ClassCastException ex){
					Residue r = (Residue)atomset.get(i);
					for (int j = 0; j < r.getAtomCount(); j++){
						Atom aa = r.getAtom(j);
						list.add(aa);
					}
				}
			}
			
			//test whether this set is actually part of the MD structure
			Atom aa = (Atom)list.get(0);
			if (aa.structure != structure){
// 				callable.displayErrorMessage("Selected atom set contains atoms that are not part of the simulated structure");
				callable.displayErrorMessage(M_Selectedatomsetcon);
				return;
			}
			
			rmsdMask = new boolean[currentParameterSet.atoms.size()*3];//for fast lookup, a flag for each coordinate
			int k = 0;
			for (int i = 0; i < currentParameterSet.atoms.size(); i++){
				Atom a = (Atom)currentParameterSet.atoms.get(i);
				if (list.contains(a)){
					if (selection){
						if (styles.isSelected(a)){
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
							rmsdMask[k++] = true;
						}
						else{
							rmsdMask[k++] = false;
							rmsdMask[k++] = false;
							rmsdMask[k++] = false;
						}
					}
					else{
						rmsdMask[k++] = true;
						rmsdMask[k++] = true;
						rmsdMask[k++] = true;
					}
				}
				else{
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
					rmsdMask[k++] = false;
				}
			}
		}
		else{
			//assume rmsd for all
			if (currentParameterSet != null){
				rmsdMask = new boolean[currentParameterSet.atoms.size()*3];//for fast lookup, a flag for each coordinate
				for (int i = 0; i < rmsdMask.length; i++){
					rmsdMask[i] = true;
				}
			}
		}
		
	}
	
	private boolean play = false;
	private boolean reset = false;
	private boolean stopped = false;
	
	public void play(){
		
		//take care of the frames
		final int frames = currentFrameSet.size();

		play = true;
		stopped = false;
		
		//play
		player = new Thread(){
			public void run(){
				while (true){
					
					//for debugging purposes
//					try{
//						Thread.sleep(1);
//					}
//					catch (InterruptedException ex){}
					
					//walk through the frames and update coordinates accordingly
					
					//currentFrame is the current position of the system within the frame set
					//in order to play further, next frame should be available
					try{
						//convert speed setting to sleep span for the thread
						int sleeptime = rate[frameSpeed-1];
						
						Thread.sleep(sleeptime);

						if (!play){
							//stop until play is true (set from the outside thread)
							while (true){
								if (play) break;
								if (reset) break;
								try{
									Thread.sleep(100);
								}
								catch (InterruptedException ex){}
							}
						}
						
						if (fileMap == null){
							//it's a single file situation
							if (currentFrame >= currentFrameSet.size()){//we need to wait
								
								//first check whether the loading is done: if so, just bail out
								if (loadingCompleted) break;
								
								while (true){
									try{
										if (currentFrameSet.get(currentFrame) != null) break;//next frame is available
									}
									catch (Exception r){}
									Thread.sleep(10);
								}
							}
						}
						else{
							boolean stepOut = false;
							while (true){
								try{
									if (loadingCompleted && currentFrame == currentFrameSet.size()){
										play = false;
										stopped = true;
										stepOut = true;
//										updateProgress();
										break;//finish of the run
									}
									if (currentFrameSet.get(currentFrame) != null) break;
								}
								catch (Exception r){}
								Thread.sleep(10);
								
							}
							if (stepOut) break;

						}
						
//						double[] out = null;
						if (reset){
							break;
						}
						else{
							
							currentFrame++;//advance to the next frame
							
							double[] coords = (double[])currentFrameSet.get(currentFrame-1);
							float[] charges = null;
							if (chargeSet != null && chargeSet.size() >= currentFrame){
								charges = (float[])chargeSet.get(currentFrame - 1);
							}
							callable.getStructureViewer().updateCoordinates(structure, coords, charges, computeSS, centerView);
							
							//update the counter
							frameCounterField.setText((new Integer(currentFrame)).toString());
							
							if (rmsdGraphPanel != null){
								try{
									double rmsdV = ((Double)currentRMSDFrames.get(currentFrame-1)).doubleValue();
									String mark = StringUtils.getFormattedNumber(rmsdV, 3);
									rmsdLabelValue.setText(mark);
								}
								catch (Exception e){}
								rmsdGraphPanel.updateMarker(currentFrame);
							}

							if (energyAvailable){
								if (EXsynch){
									double[] s = (double[])currentDataFrames.get(currentFrame-1);
									String tot = StringUtils.getFormattedNumber(s[3],3);
									etotLabelValue.setText(tot);
									String ktot = StringUtils.getFormattedNumber(s[4],3);
									ektotLabelValue.setText(ktot);
									String ptot = StringUtils.getFormattedNumber(s[5],3);
									eptotLabelValue.setText(ptot);
									
									if (energyPanel != null) energyPanel.updateMarker(currentFrame);
									if (tempPanel != null) tempPanel.updateMarker(currentFrame);

								}
							}
							
							if (fileMap != null && fileMap.size() > 0){
								//we are dealing with a multifile situation, so null the frames behind
								if (currentFrame > 60){
									currentFrameSet.setElementAt(null, currentFrame-10);
									if (chargeSet != null && chargeSet.size() > (currentFrame - 10)) chargeSet.setElementAt(null, currentFrame - 10);
								}
								
							}

						}
						
						updateProgress();
						
						
					}
					catch (Exception ex){
//						ex.printStackTrace();
						continue;
					}
				}
				
//				updateProgress();
///				playButton.setEnabled(true);
				stopButton.setEnabled(false);
				
				if (reset){
					reset = false;
					frameCounterField.setText("1");
				}
				else{
					frameCounterField.setText((new Integer(currentFrameSet.size())).toString());
				}

			}
		};
		player.start();
				
	}
	
	public void step(boolean forward){
		
		if (currentFrame >= currentFrameSet.size()){
			if (loadingCompleted){
				currentFrame = 1;//all done, rewind to the start
			}
			else{
				//we need to wait if it's forward step
				if (forward){
					while (true){
						if (fileMap == null){
							//it's a single file situation
							if (currentFrame >= currentFrameSet.size()-1){//we need to wait
								
								//first check whether the loading is done: if so, just bail out
								if (loadingCompleted) break;
								
								while (true){
									try{
										if (currentFrameSet.get(currentFrame) != null) break;
										Thread.sleep(10);

									}
									catch (Exception r){}
								}
							}
						}
						else{
							boolean stepOut = false;
							while (true){
								try{
									if (loadingCompleted && currentFrame >= currentFrameSet.size()-1){
//										currentFrame = 1;
										play = false;
										stopped = true;
										stepOut = true;
										break;//finish of the run
									}
									if (currentFrameSet.get(currentFrame) != null) break;
									Thread.sleep(10);

								}
								catch (Exception r){}
								
							}
							if (stepOut) break;

						}
					}
				}
				
				if (forward){
					currentFrame++;
				}
				else{
					currentFrame--;
				}

			}
			
		}
		else{
			if (forward) {
				currentFrame++;
			}
			else{
				currentFrame--;
			}
		}
		
		if (currentFrame <= 1){
			stepBackButton.setEnabled(false);
			resetButton.setEnabled(false);
			currentFrame = 1;
		}
		else{
			if (controller == null) stepBackButton.setEnabled(true);
		}

		
		double[] coords = (double[])currentFrameSet.get(currentFrame-1);//advance to the next frame first
		float[] charges = null;
		if (chargeSet != null && chargeSet.size() >= currentFrame){
			charges = (float[])chargeSet.get(currentFrame - 1);
		}
		
		if (coords != null) callable.getStructureViewer().updateCoordinates(structure, coords, charges, computeSS, centerView);
		
		//update the counter
		frameCounterField.setText((new Integer(currentFrame)).toString());
		updateProgress();
		
		if (rmsdGraphPanel != null){
			try{
				double rmsdV = ((Double)currentRMSDFrames.get(currentFrame-1)).doubleValue();
				String mark = StringUtils.getFormattedNumber(rmsdV, 3);
				rmsdLabelValue.setText(mark);
			}
			catch (Exception e){}

			rmsdGraphPanel.updateMarker(currentFrame);
		}

		if (energyAvailable){
			if (EXsynch){
				double[] s = (double[])currentDataFrames.get(currentFrame-1);
				String tot = StringUtils.getFormattedNumber(s[3],3);
				etotLabelValue.setText(tot);
				String ktot = StringUtils.getFormattedNumber(s[4],3);
				ektotLabelValue.setText(ktot);
				String ptot = StringUtils.getFormattedNumber(s[5],3);
				eptotLabelValue.setText(ptot);
				
				if (energyPanel != null) energyPanel.updateMarker(currentFrame);
			}
		}

		if (fileMap != null && fileMap.size() > 0){
			if (forward){
				//we are dealing with a multifile situation, so null the frames behind
				if (currentFrame > 60){
					currentFrameSet.setElementAt(null, currentFrame-10);
					if (chargeSet != null && chargeSet.size() > (currentFrame - 10)) chargeSet.setElementAt(null, currentFrame - 10);
				}
			}
		}

		
	}
	
	private void skip(int frame){

		//frame is a 1-based index
		//check if the frame in question is available
		boolean wait = false;
		if (currentFrameSet.size() >= frame){
			if (currentFrameSet.get(frame-1) == null){
				wait = true;
			}
		}
		else{
			//loading is not done yet
			wait = true;
		}
		
		if (wait){
			while (true){
				try{
					Thread.sleep(5);
					
					if (currentFrameSet.size() >= frame && currentFrameSet.get(frame-1) != null) break;
					
					if (loadingCompleted) break;
				}
				catch (InterruptedException ex){}
			}
		}
		
		if (currentFrameSet.size() < frame || currentFrameSet.get(frame-1) == null){
// 			callable.displayErrorMessage("Entered frame number is invalid");
			callable.displayErrorMessage(M_Enteredframenumber);
			frameCounterField.setText(new Integer(currentFrame).toString());
			return;
		}

		currentFrame = frame;

		if (currentFrame > 1 && controller == null) stepBackButton.setEnabled(true);
		
		
		double[] coords = (double[])currentFrameSet.get(currentFrame-1);
		float[] charges = null;
		if (chargeSet != null && chargeSet.size() >= currentFrame){
			charges = (float[])chargeSet.get(currentFrame - 1);
		}
		
		if (coords != null) callable.getStructureViewer().updateCoordinates(structure, coords, charges, computeSS, centerView);
		
		//update the counter
		frameCounterField.setText((new Integer(currentFrame)).toString());
		updateProgress();
		
		if (rmsdGraphPanel != null){
			try{
				double rmsdV = ((Double)currentRMSDFrames.get(currentFrame-1)).doubleValue();
				String mark = StringUtils.getFormattedNumber(rmsdV, 3);
				rmsdLabelValue.setText(mark);
			}
			catch (Exception e){}

			rmsdGraphPanel.updateMarker(currentFrame);
		}

		if (energyAvailable){
			if (EXsynch){
				double[] s = (double[])currentDataFrames.get(currentFrame-1);
				String tot = StringUtils.getFormattedNumber(s[3],3);
				etotLabelValue.setText(tot);
				String ktot = StringUtils.getFormattedNumber(s[4],3);
				ektotLabelValue.setText(ktot);
				String ptot = StringUtils.getFormattedNumber(s[5],3);
				eptotLabelValue.setText(ptot);
				
				if (energyPanel != null) energyPanel.updateMarker(currentFrame);
			}
		}

		if (fileMap != null && fileMap.size() > 0){
			//we are dealing with a multifile situation, so null the frames behind
			if (currentFrame > 55){
				currentFrameSet.setElementAt(null, currentFrame-5);
				if (chargeSet != null && chargeSet.size() > (currentFrame - 5)) chargeSet.setElementAt(null, currentFrame - 5);
			}
		}

		playButton.setEnabled(true);
		if (currentFrame > 1){
			resetButton.setEnabled(true);
			stepForwardButton.setEnabled(true);
			if (controller == null) stepBackButton.setEnabled(true);
		}
		else{
			stepBackButton.setEnabled(false);
		}
	}
	
	public void stop(){
		play = false;
		stopped = true;
	}
	
	public void restart(){
		play = true;
		stopped = false;
	}
	
	public void reset(){
		reset = true;
		if (controller != null) controller.reset();
		play = false;
		stopped = false;
		currentFrame = 1;
		
		double[] coords = (double[])currentFrameSet.get(0);
		float[] charges = null;
		if (chargeSet != null && chargeSet.size() > 0){
			charges = (float[])chargeSet.get(0);
		}
		
		if (currentDataFrames != null && currentDataFrames.size() > 0){
			double[] s = (double[])currentDataFrames.get(0);
			etotLabelValue.setText("");
			ektotLabelValue.setText("");
			eptotLabelValue.setText("");
			
			String tot = StringUtils.getFormattedNumber(s[3],3);
			etotLabelValue.setText(tot);
			
			String ktot = StringUtils.getFormattedNumber(s[4],3);
			ektotLabelValue.setText(ktot);
			
			String ptot = StringUtils.getFormattedNumber(s[5],3);
			eptotLabelValue.setText(ptot);

		}
		
		if (player == null || !player.isAlive()){
			reset = false;
		}
		
		updateProgress();

		if (energyPanel != null) energyPanel.updateMarker(currentFrame);
		if (rmsdLabelValue.isEnabled()) rmsdLabelValue.setText("0.000");
		if (rmsdGraphPanel != null){
			rmsdGraphPanel.updateMarker(currentFrame);
		}

		//once the array is done, update the structure
		callable.getStructureViewer().updateCoordinates(structure, coords, charges, computeSS, centerView);
		
		frameCounterField.setText("1");
	}
	
	private void updateProgress(){
		
///		System.out.println("currentFrame = " + currentFrame);
		
		if (currentFrameSet == null){
			progress.setValue(0);
		}
		else{
			int total = 100;
			if (dcdHeaders != null && dcdHeaders.size() > 0){
				total = totalFrames;
			}
			else{
				total = currentFrameSet.size();
			}
			int percent = 0;
			if (currentFrame > 1) percent = (int)((100*currentFrame)/total);
			progress.setValue(percent);
		}
		progress.revalidate();
		progress.repaint();
	}
	
	public void resetEntry(Entry entry){
		if (currentEntry == entry){
			//clear all, but no need to unload the entry - it's being done elsewhere (that's why this method is called)
			if (controller != null){
				controller.stop();
				controller = null;
			}
			
			callable.removeCloseListener(currentEntry);
			
			currentParameterSet = null;
			chargeSet = null;
			currentFrameSet = null;
			structure = null;
			if (frameOffsets != null) frameOffsets.clear();
			
			dcdHeaders = null;
			totalFrames = 0;
			
			progress.setEnabled(false);
			playButton.setEnabled(false);
			stopButton.setEnabled(false);
			resetButton.setEnabled(false);
			
			speed.setEnabled(false);
			stepForwardButton.setEnabled(false);
			stepBackButton.setEnabled(false);
			
			play = false;
			stopped = false;
			currentEntry = null;
			frameCounter.setEnabled(false);
			frameCounterField.setEnabled(false);
			frameCounterField.setText("0");
			frameCounterField.setEditable(false);
			currentFrame = 0;
			
			frameReference.clear();
			frameCounts.clear();
			if (fileMap != null) fileMap.clear();
			fileObjects = null;
			
			titleLabelValue.setText("");
			atomsLabelValue.setText("");
			fileLabelValue.setText("");
			framesLabelValue.setText("");
			parfileLabelValue.setText("");
			
			parfileLabel.setEnabled(false);
			titleLabel.setEnabled(false);
			atomsLabel.setEnabled(false);
			fileLabel.setEnabled(false);
			framesLabel.setEnabled(false);
			
			rmsdBeingUpdated = false;

			rmsd.setEnabled(false);
			rmsdLabelValue.setText("");
			
			etotLabel.setEnabled(false);
			etotLabelValue.setText("");
			etotLabel.setEnabled(false);
			etotLabelValue.setText("");
			ektotLabel.setEnabled(false);
			ektotLabelValue.setText("");
			eptotLabel.setEnabled(false);
			eptotLabelValue.setText("");
			
			EXsynch = true;
			
			loadingCompleted = false;
			loadedFirstFrame = false;

			energyAvailable = false;
			currentDataFrames = null;
			
			rmsdAvailable = false;
			
			Set keys = byteChannels.keySet();
			Iterator it = keys.iterator();
			while (it.hasNext()){
				File file = (File)it.next();
				FileChannel channel = (FileChannel)byteChannels.get(file);
				try{
					channel.close();
				}
				catch (Exception ex){}
				channel = null;
			}
			byteChannels.clear();
			byteBuffers.clear();
			
			keys = auxByteChannels.keySet();
			it = keys.iterator();
			while (it.hasNext()){
				File file = (File)it.next();
				FileChannel channel = (FileChannel)auxByteChannels.get(file);
				try{
					channel.close();
				}
				catch (Exception ex){}
				channel = null;
			}
			auxByteChannels.clear();
			auxByteBuffers.clear();

			closeEnergyPanel(false);
			closeRMSDPanel(false);
			closeTempPanel(false);
			
			if (rmsdGraphPanel != null){
				rmsdGraphPanel.closePanel();
			}

			
			System.gc();
			
			updateProgress();
		}
	}
	
	private void readOutfile(BufferedReader r, File f){
		
			final BufferedReader reader = r;
			final File file = f;
			
			frameOffsets = new Vector();
			
			try{
				String path = file.getAbsolutePath();
				String dir = "";
				int index = path.lastIndexOf(File.separator);
				if (index > 0){
					dir = path.substring(0, index) + File.separator;
				}
				
				File parfile = null;
				File mdfile = null;
				
				int coordinateSteps = -1;
				int energySteps = -1;
				
				boolean checkSteps = false;
				
				boolean record = false;
				
				currentDataFrames = new Vector();//stores data in double[]'s
				
				double[] snapshot = new double[7];
				boolean start = true;
				boolean restart = false;
				
				String line = null;
				boolean firstFrame = true;
				while ((line = reader.readLine()) != null){
					if (line.indexOf("PARM:") > 0){
						int pos = line.indexOf("PARM:");
						prmtop = dir + line.substring(pos+5).trim();
						parfile = new File(prmtop);
					}
					
					if (line.indexOf("MDCRD:") > 0){
						int pos = line.indexOf("MDCRD:");
						mdfile = new File(dir + line.substring(pos+6).trim());
					}
					
// 					if (line.startsWith(" Here is the input file:")){
					if (line.startsWith(M_Hereistheinputfile)){
						checkSteps = true;
					}
					
					//match the step size for coordinates and for energy records
					if (checkSteps){
						Pattern pattern = Pattern.compile("^.+ntwx=(\\d+).+$");
						Matcher matcher = pattern.matcher(line);
						if (matcher.matches()){
							coordinateSteps = Integer.parseInt(matcher.group(1));
							if (energySteps > -1) checkSteps = false;
						}

						pattern = Pattern.compile("^.+ntpr=(\\d+).+$");
						matcher = pattern.matcher(line);
						if (matcher.matches()){
							energySteps = Integer.parseInt(matcher.group(1));
							if (coordinateSteps > -1) checkSteps = false;
						}
						
						pattern = Pattern.compile("^.+irest=(\\d+).+$");
						matcher = pattern.matcher(line);
						if (matcher.matches()){
							int re = Integer.parseInt(matcher.group(1));
							restart = (re == 1);
						}

					}
					
					if (line.startsWith("   4.  RESULTS")) record = true;
					
					//start working through the actual data records
					if (record){
						if (line.startsWith(" NSTEP =")){
							if (start){
								start = false;
							}
							else{
								if (!restart && firstFrame){
									firstFrame = false;
								}
								else{
									currentDataFrames.add(snapshot);
									energyAvailable = true;
									snapshot = new double[7];
								}
							}
							
							Pattern pattern = Pattern.compile("^.+NSTEP =\\s+(\\S+)\\s+TIME\\(PS\\) =\\s+(\\S+)\\s+TEMP\\(K\\) =\\s+(\\S+)\\s+.+$");
							Matcher matcher = pattern.matcher(line);
							if (matcher.matches()){
								snapshot[0] = Double.parseDouble(matcher.group(1));
								snapshot[1] = Double.parseDouble(matcher.group(2));
								snapshot[2] = Double.parseDouble(matcher.group(3));
							}
						}
						
						if (line.startsWith(" Etot   =")){
							Pattern pattern = Pattern.compile("^.+Etot\\s+?=\\s+(\\S+)\\s+EKtot\\s+?=\\s+(\\S+)\\s+EPtot\\s+?=\\s+(\\S+)\\s*.+$");
							Matcher matcher = pattern.matcher(line);
							if (matcher.matches()){
								snapshot[3] = Double.parseDouble(matcher.group(1));
								snapshot[4] = Double.parseDouble(matcher.group(2));
								snapshot[5] = Double.parseDouble(matcher.group(3));
							}
						}
						
						snapshot[6] = 0;//since there is only one trajectory file
						
					}
					
					if (line.startsWith("      A V E R A G E S   ")){
						currentDataFrames.add(snapshot);//add the last frame
						record = false;
					}
					
					if (currentDataFrames.size() > 0){
						double[] s = (double[])currentDataFrames.get(0);
						etotLabel.setEnabled(true);
						ektotLabel.setEnabled(true);
						eptotLabel.setEnabled(true);
						
						String tot = StringUtils.getFormattedNumber(s[3],3);
						etotLabelValue.setText(tot);
						
						String ktot = StringUtils.getFormattedNumber(s[4],3);
						ektotLabelValue.setText(ktot);
						
						String ptot = StringUtils.getFormattedNumber(s[5],3);
						eptotLabelValue.setText(ptot);
						
					}
					
				}
				
				
				if (coordinateSteps != energySteps){
					EXsynch = false;
				}
				
				String initialPar = null;
				if (!parfile.exists()){
					initialPar = parfile.toString();
					parfile = new File(initialPar + ".gz");
				}
				
				if (!parfile.exists()){
// 					callable.displayErrorMessage("Parameter file could not be found. Make sure it's in the same directory with the output file");
					callable.displayErrorMessage(M_Parameterfilecould);
					return;
				}
				
//				System.out.println("parfile = " + parfile);
				
				String initialMD = null;
				//first check whether the file is there
				//check whether it's actually gzipped
				if (!mdfile.exists()){
					initialMD = mdfile.toString();
					mdfile = new File(initialMD + ".gz");
				}
				

				if (!mdfile.exists()){
// 					callable.displayErrorMessage("MD Coordinate file is not found. Make sure it is in the same directory with the output file.");
					callable.displayErrorMessage(M_MDCoordinatefileis);
					return;
				}
				
//				System.out.println("mdfile = " + mdfile);
				
//				System.out.println("data frames = " + currentDataFrames.size());
				
				//load files
				currentParameterSet = MDUtils.readParameterFile(parfile);
				
//				System.out.println("currentParameterSet = " + currentParameterSet);
				
				if (currentParameterSet != null){
					//get the file name
					parfileLabel.setEnabled(true);
					int index2 = parfile.toString().lastIndexOf(File.separator);
					if (index2 > 0){
						parfileLabelValue.setText(parfile.toString().substring(index2+1));
					}
					else{
						parfileLabelValue.setText(parfile.toString());
					}
				}
				else{
// 					callable.displayErrorMessage("Unable to read parameter file.");
					callable.displayErrorMessage(M_Unabletoreadparame);
					return;
				}
				
				
				fileLabel.setEnabled(true);
				//get the file name
				int index2 = mdfile.toString().lastIndexOf(File.separator);
				if (index2 > 0){
					fileLabelValue.setText(mdfile.toString().substring(index2+1));
				}
				else{
					fileLabelValue.setText(mdfile.toString());
				}
				
				dataType = COORD_MDCRD;

				
				
				boolean buffer = false;
				//check whether it's a really big file
				if (mdfile.length() > 200000000){
// 					if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), "The selected trajectory file is over 200 MBytes. Would you like to load it using memory buffering?", 
					if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), M_Theselectedtraject, 
// 							"Loading confirmation", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
							M_Loadingconfirmatio, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
						buffer = true;
					}
				}
				
				fileObjects = new File[1];
				fileObjects[0] = mdfile;
				frameOffsets.add(new Integer(0));//since there is only one file
				
				if (buffer){
					currentFrameSet = new Vector();
					currentRMSDFrames = new Vector();
					
					Thread runner = new Thread(){
						public void run(){
							readFirstFrame();//call this method to wait for the input data to arrive
						}
					};
					runner.start();


					Thread runner2 = new Thread(){
						public void run(){
							if (controller == null) controller = new MDController();
							controller.setStop(false);
							controller.readFiles();
						}
					};
					runner2.start();
					return;
				}
				
				if (mdfile.toString().endsWith("gz")){
					try{
///						BufferedReader reader2 = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(mdfile))));
						fileObjects = new File[]{ mdfile };
						readMDFile();
					}
					catch (Exception ex){
						ex.printStackTrace();
						return;
					}
				}
				else{
					try{
						fileObjects = new File[]{ mdfile };
						readMDFile();
					}
					catch (Exception ex){
						ex.printStackTrace();
						return;
					}
				}
			}
			catch (Exception e){
				e.printStackTrace();
			}
			
	}
	
	private void readOutFiles(File[] files) throws IllegalArgumentException {
		
		try{
			
			frameOffsets = new Vector();
			
			String path = files[0].getAbsolutePath();
			String dir = "";
			int index = path.lastIndexOf(File.separator);
			if (index > 0){
				dir = path.substring(0, index) + File.separator;
			}
			
			File parfile = null;
			File mdfile = null;
			
			Vector mdFiles = new Vector();
			
			int coordinateSteps = -1;
			int energySteps = -1;
			
			currentDataFrames = new Vector();//stores data in double[]'s
			
			
			
			BufferedReader reader = null;
			
//			System.err.println("outfiles = " + files.length);
			
			for (int i = 0; i < files.length; i++){
				
				frameOffsets.add(new Integer(currentDataFrames.size()));
//				System.out.println("Added to frameOffsets: " + currentDataFrames.size());

				boolean checkSteps = false;
				String line = null;
				boolean record = false;
				
				double[] snapshot = new double[7];//the last entry is the index of the corresponding trajectory file in fileObjects[]
				boolean restart = false;
				
				//start reading the first file:
				boolean start = true;
				while (true){
					if (files[i].toString().endsWith("out.gz")){
						reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(files[i]))));
						break;
					}
					else if (files[i].toString().endsWith("out")){
						reader = new BufferedReader(new java.io.FileReader(files[i]));
						break;
					}
					else{
						i++;
						if (i == files.length){
// 							throw new IllegalArgumentException("Not out files");
							throw new IllegalArgumentException(M_Notoutfiles);
						}
					}
				}
				
//				System.err.println("reading from " + files[i]);
				
				//reader should now be defined
				
				boolean firstFrame = true;
				while ((line = reader.readLine()) != null){
					if (line.indexOf("PARM:") > 0){
						int pos = line.indexOf("PARM:");
						File temp = new File(dir + line.substring(pos+5).trim());
						if (parfile == null){
							parfile = temp;
						}
						else{
							//compare to the previously read parfile
							if (!parfile.toString().equals(temp.toString())){
// 								callable.displayErrorMessage("Output files refer to different parameter files. Check the data and try again.");
								callable.displayErrorMessage(M_Outputfilesreferto);
								return;
							}
						}
						
						String initialPar = null;
						if (!parfile.exists()){
							initialPar = parfile.toString();
							parfile = new File(initialPar + ".gz");
							
						}
						
						if (!parfile.exists()){
// 							callable.displayErrorMessage("Parameter file could not be found. Make sure it's in the same directory with the output file");
							callable.displayErrorMessage(M_Parameterfilecould);
							return;
						}
						
						prmtop = parfile.toString();
					}
					
					if (line.indexOf("MDCRD:") > 0){
						int pos = line.indexOf("MDCRD:");
						mdfile = new File(dir + line.substring(pos+6).trim());
						
						//first check whether the file is there
						//check whether it's actually gzipped
						if (!mdfile.exists()){
							String initialMD = mdfile.toString();
							mdfile = new File(initialMD + ".gz");
						}
						
						mdFiles.add(mdfile);
	
					}
					
// 					if (line.startsWith(" Here is the input file:")){
					if (line.startsWith(M_Hereistheinputfile)){
//						System.err.println("Starting energy check");
						checkSteps = true;
					}
					
					//match the step size for coordinates and for energy records
					if (checkSteps){
						Pattern pattern = Pattern.compile("^.+ntwx=(\\d+).+$");
						Matcher matcher = pattern.matcher(line);
						if (matcher.matches()){
							coordinateSteps = Integer.parseInt(matcher.group(1));
						}
	
						pattern = Pattern.compile("^.+ntpr=(\\d+).+$");
						matcher = pattern.matcher(line);
						if (matcher.matches()){
							energySteps = Integer.parseInt(matcher.group(1));
							if (coordinateSteps > -1) checkSteps = false;
						}

						pattern = Pattern.compile("^.+irest=(\\d+).+$");
						matcher = pattern.matcher(line);
						if (matcher.matches()){
							int re = Integer.parseInt(matcher.group(1));
							restart = (re == 1);
						}
					}
					
					
					if (line.startsWith("   4.  RESULTS")) record = true;
					
					
					//start working through the actual data records
					if (record){
						if (line.startsWith(" NSTEP =")){
							if (start){
								start = false;
							}
							else{
								if (!restart && firstFrame){
									firstFrame = false;
									continue;
								}
								else{
									currentDataFrames.add(snapshot);
									energyAvailable = true;
									snapshot = new double[7];
								}
							}
							
							Pattern pattern = Pattern.compile("^.+NSTEP =\\s+(\\S+)\\s+TIME\\(PS\\) =\\s+(\\S+)\\s+TEMP\\(K\\) =\\s+(\\S+)\\s+.+$");
							Matcher matcher = pattern.matcher(line);
							if (matcher.matches()){
								snapshot[0] = Double.parseDouble(matcher.group(1));
								snapshot[1] = Double.parseDouble(matcher.group(2));
								snapshot[2] = Double.parseDouble(matcher.group(3));
							}
						}
						
						if (line.startsWith(" Etot   =")){
							Pattern pattern = Pattern.compile("^.+Etot\\s+?=\\s+(\\S+)\\s+EKtot\\s+?=\\s+(\\S+)\\s+EPtot\\s+?=\\s+(\\S+)\\s*.+$");
							Matcher matcher = pattern.matcher(line);
							if (matcher.matches()){
								snapshot[3] = Double.parseDouble(matcher.group(1));
								snapshot[4] = Double.parseDouble(matcher.group(2));
								snapshot[5] = Double.parseDouble(matcher.group(3));
							}
						}
						
						snapshot[6] = mdFiles.indexOf(mdfile);
						
					}
					
					if (line.startsWith("      A V E R A G E S   ")){
						currentDataFrames.add(snapshot);//add the last frame
						record = false;
					}
					
					
					
					if (currentDataFrames.size() > 0){
						double[] s = (double[])currentDataFrames.get(0);
						etotLabel.setEnabled(true);
						ektotLabel.setEnabled(true);
						eptotLabel.setEnabled(true);
						
						String tot = StringUtils.getFormattedNumber(s[3],3);
						etotLabelValue.setText(tot);
						
						String ktot = StringUtils.getFormattedNumber(s[4],3);
						ektotLabelValue.setText(ktot);
						
						String ptot = StringUtils.getFormattedNumber(s[5],3);
						eptotLabelValue.setText(ptot);
						
					}
					
				}
				
				if (coordinateSteps != energySteps){
					EXsynch = false;
				}
				
				


				reader.close();
				
			}
			
			//at this point, currentDataFrames should contain all energy values for the entire run
						
			//load files
			currentParameterSet = MDUtils.readParameterFile(parfile);
			
			if (currentParameterSet != null){
				//get the file name
				parfileLabel.setEnabled(true);
				int index2 = parfile.toString().lastIndexOf(File.separator);
				if (index2 > 0){
					parfileLabelValue.setText(parfile.toString().substring(index2+1));
				}
				else{
					parfileLabelValue.setText(parfile.toString());
				}
			}
			else{
// 				callable.displayErrorMessage("Parameters could not be read.");
				callable.displayErrorMessage(M_Parameterscouldnot);
				return;
			}
			
			fileObjects = new File[mdFiles.size()];
			
			//now run through the md files and populate the array
			//along the way, check the size of the entire trajectory
			long totalSize = 0;
			for (int i = 0; i < mdFiles.size(); i++){
				fileObjects[i] = (File)mdFiles.get(i);
				totalSize += fileObjects[i].length();
			}
			
			dataType = COORD_MDCRD;
			
			if (totalSize > 200000000){
// 				if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), "The selected trajectory is over 200 MBytes. Would you like to load it using memory buffering?", 
				if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), M_Theselectedtraject_1, 
// 						"Loading confirmation", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
						M_Loadingconfirmatio, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
					buffer = true;
				}
			}

			
			if (buffer){
				Thread runner = new Thread(){
					public void run(){
						readFirstFrame();//call this method to wait for the input data to arrive
					}
				};
				runner.start();
				
				fileLabel.setEnabled(true);
				
				//get the file name
				int index2 = files[0].toString().lastIndexOf(File.separator);
				if (index2 > 0){
					fileLabelValue.setText(files[0].toString().substring(index2+1));
				}
				else{
					fileLabelValue.setText(files[0].toString());
				}

				currentFrameSet = new Vector();
				currentRMSDFrames = new Vector();
				
//				updateRMSDMask();

				Thread runner2 = new Thread(){
					public void run(){
						if (controller == null) controller = new MDController();
						controller.setStop(false);
						controller.readFiles();
					}
				};
				runner2.start();
			}
			else{
				//read all files in a single pass
				Thread runner2 = new Thread(){
					public void run(){
						readMDFile();
					}
				};
				runner2.start();
			}
			
			
			
		}
		catch (Exception e){
			e.printStackTrace();
		}
		

	}
	
	private JMenuBar createMenuBar(){
		
		menuBar = new JMenuBar();
		
// 		JMenu menuFile = new JMenu("File");
		JMenu menuFile = new JMenu(M_File);
//		menuFile.setMnemonic('f');
		menuFileOpenOut.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				
				//open MD output file
				final JFileChooser jFileChooser = new JFileChooser(callable.getLastUsedDirectory());
				jFileChooser.setMultiSelectionEnabled(true);
				//amber md output type
				javax.swing.filechooser.FileFilter structureFilter = new javax.swing.filechooser.FileFilter( ){

					public boolean accept( File file ){
						if ( file.toString().endsWith("out") ) return true;
						if ( file.toString().endsWith("out.gz") ) return true;
						if ( file.isDirectory() ) return true;
						return false;
					}
					
					public String getDescription( ){
						return "AMBER MD output file";
					}
				};
				
				jFileChooser.addChoosableFileFilter( structureFilter );
				
				int returnVal = jFileChooser.showOpenDialog( callable.getApplicationFrame() );
				if ( returnVal == JFileChooser.APPROVE_OPTION ){
					Thread runner = new Thread(){
						public void run(){
							
							//check whether there is already something loaded
							if (structure != null){
								
// 								if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), "A structure is currently loaded. Delete it and load the new entry?", 
								if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), M_Astructureiscurren, 
// 										"Loading confirmation", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
										M_Loadingconfirmatio, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
									//delete the currently loaded structure
									//keep the current parameter set, however
									if (currentEntry != null){
										structureDocument.removeEntry(currentEntry);
										callable.removeCloseListener(currentEntry);
									}
								}
								else{
									return;
								}
							}

							//get the filename and read the out file
							File[] files = jFileChooser.getSelectedFiles( );
							//save the used directory
							String dir = files[0].getParentFile().toString();
							callable.setLastUsedDirectory(dir);

							if (files.length == 1){
								if (files[0].toString().endsWith("out")){
									try{
										BufferedReader reader = new BufferedReader(new java.io.FileReader(files[0]));
										readOutfile(reader, files[0]);
									}
									catch (Exception ex){
										ex.printStackTrace();
										return;
									}
	
								}
								else if (files[0].toString().endsWith("out.gz")){
									try{
										BufferedReader reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(files[0]))));
										readOutfile(reader, files[0]);
									}
									catch (Exception ex){
										ex.printStackTrace();
										return;
									}
								}
							}
							else{
								//parse multiple file selection
								try{
									//display the array of files in a dialog to allow the user to arrange the files in the correct order
									//the dialog will call readUpdatedFileList()
									MDFileListerDialog d = new MDFileListerDialog(parent, thisObject, callable, files, MDFileListerDialog.TYPE_OUT);
								}
								catch (Exception e){
									e.printStackTrace();
								}
							}
						}
					};
					runner.start();
				}
				
				
				
				
			}
		});
		
		menuFileOpenPar.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				//open file chooser dialog to get the parameter file
				final JFileChooser jFileChooser = new JFileChooser(callable.getLastUsedDirectory());
				final Vector types = MDUtils.parameterFileTypes;
				javax.swing.filechooser.FileFilter defaultFilter = null;
				
				for (int i = 0; i < types.size(); i++){
					final FileType type = (FileType)types.get(i);
					final String n = type.extension;
					//take care of the upper and lower case extensions
//					for (int j = 0; j < 2; j++){
					javax.swing.filechooser.FileFilter structureFilter = new javax.swing.filechooser.FileFilter( ){
							private FileEntryLoader fsLoader = null;
							private String fslName = null;
		
							// public FileFilter( ) // anonymous constructor
							{
								fslName = n;
							}
		
							public boolean accept( File file ){
								if ( file.toString().endsWith(fslName) ) return true;
								if ( file.isDirectory() ) return true;
								return false;
							}
							
							public String getDescription( ){
								return type.description;
							}
						};
						
						jFileChooser.addChoosableFileFilter( structureFilter );
						
					}
					
//				}

				int returnVal = jFileChooser.showOpenDialog( callable.getApplicationFrame() );
				if ( returnVal == JFileChooser.APPROVE_OPTION ){
					Thread runner = new Thread(){
						public void run(){
							//check whether anything is loaded
							if (currentParameterSet != null){
								
// 								if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), "A parameter set is currently loaded. Delete it and load the new entry?", 
								if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), M_Aparametersetiscur, 
// 										"Loading confirmation", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
										M_Loadingconfirmatio, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
									//delete the currently loaded structure
									//keep the current parameter set, however
									ParameterSet cp = currentParameterSet;
									if (currentEntry != null){
										structureDocument.removeEntry(currentEntry);
										callable.removeCloseListener(currentEntry);
									}
								
									currentParameterSet = cp;
								}
								else{
									return;
								}
								
							}
							
							
							//get the filename and read the parameter file
							File file = jFileChooser.getSelectedFile( );

							currentParameterSet = MDUtils.readParameterFile(file);
							
							if (currentParameterSet != null){
								//get the file name
								parfileLabel.setEnabled(true);
								int index = file.toString().lastIndexOf(File.separator);
								if (index > 0){
									parfileLabelValue.setText(file.toString().substring(index+1));
								}
								else{
									parfileLabelValue.setText(file.toString());
								}
							}
							else{
// 								callable.displayErrorMessage("Unable to read parameter file.");
								callable.displayErrorMessage(M_Unabletoreadparame);
								return;
							}
							
							prmtop = file.toString();
							
							//save the used directory
							String dir = file.getParentFile().toString();
							callable.setLastUsedDirectory(dir);

						}
					};
					runner.start();
				}
			}
		});
		
		menuFileOpenCoord.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				final JFileChooser jFileChooser = new JFileChooser(callable.getLastUsedDirectory());
				jFileChooser.setMultiSelectionEnabled(true);
				javax.swing.filechooser.FileFilter structureFilter = new javax.swing.filechooser.FileFilter( ){
					private FileEntryLoader fsLoader = null;
					private String fslName = null;

					public boolean accept( File file ){
						if ( file.toString().endsWith("rst") ) return true;
						if ( file.toString().endsWith("crd") ) return true;
						if ( file.toString().endsWith("inpcrd") ) return true;
						if ( file.toString().endsWith("restrt") ) return true;
						if ( file.toString().endsWith("mdcrd")) return true;
						if ( file.toString().endsWith("mdcrd.gz")) return true;
						if ( file.toString().endsWith("dcd")) return true;
						
						if ( file.isDirectory() ) return true;
						return false;
					}
					
					public String getDescription( ){
// 						return "Coordinate/trajectory files";
						return M_Coordinatetrajecto;
					}
				};
				
				jFileChooser.addChoosableFileFilter( structureFilter );
						
				int returnVal = jFileChooser.showOpenDialog( callable.getApplicationFrame() );
				if ( returnVal == JFileChooser.APPROVE_OPTION ){
					Thread runner = new Thread(){
						public void run(){
							
							//get the filename and read the parameter file
							File[] files = jFileChooser.getSelectedFiles( );
							
							if (currentParameterSet == null){
// 								callable.displayErrorMessage("Parameter file must be loaded before the coordinates");
								callable.displayErrorMessage(M_Parameterfilemustb_1);
								return;
							}

							
							//check whether there is already something loaded
							if (structure != null){
								
// 								if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), "A structure is currently loaded. Delete it and load the new entry?", 
								if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), M_Astructureiscurren, 
// 										"Loading confirmation", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
										M_Loadingconfirmatio, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
									//delete the currently loaded structure
									//keep the current parameter set, however
									ParameterSet cp = currentParameterSet;
									
									String parfile = parfileLabelValue.getText();
									if (currentEntry != null){
										structureDocument.removeEntry(currentEntry);
										callable.removeCloseListener(currentEntry);
									}
								
									currentParameterSet = cp;
									parfileLabelValue.setText(parfile);
								}
								else{
									return;
								}
							}
							
							//save the used directory
							String dir = files[0].getParentFile().toString();
							callable.setLastUsedDirectory(dir);

							
							if (files.length == 1){
								
								//check the format
								
								if (files[0].toString().endsWith("dcd") || files[0].toString().endsWith("DCD") || files[0].toString().endsWith("dcd.gz")){
									dataType = COORD_DCD;
								}
								else{
									//read the text file
									try{
										BufferedReader reader = null;
										if (files[0].toString().endsWith("gz")){
											reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(files[0]))));
										}
										else{
											reader = new BufferedReader(new FileReader(files[0]));
										}
									
									
										String line1 = reader.readLine();
										String line2 = reader.readLine();
										String line3 = reader.readLine();
									
										if (line2.length() < 80){
											//this should be a rst file
											double d = -1;
											if (line2.trim().indexOf(" ") > -1){
												d = Double.parseDouble(line2.substring(0, line2.indexOf(" ")).trim());
											}
											else{
												d = Double.parseDouble(line2.trim());
											}
											for (int i = 0; i < 6; i++){
												String n = line3.substring(i*12, (i+1)*12).trim();
												double dd = Double.parseDouble(n);
											}
											dataType = COORD_RST;
										}
										else{
											for (int i = 0; i < 10; i++){
												String n = line2.substring(i*8, (i+1)*8).trim();
												double d = Double.parseDouble(n);
											}
											dataType = COORD_MDCRD;
										}
									
									}
									catch (Exception e){
										e.printStackTrace();
// 										callable.displayErrorMessage("Unable to read coordinate file. Please check the format");
										callable.displayErrorMessage(M_Unabletoreadcoordi);
										return;
									}
								
									
									
								}
								
								//load the coordinates and the StructureEntry
								if (dataType == COORD_RST){
									
									//only a snapshot with one set of coordinates is present
									Vector atoms = currentParameterSet.atoms;
									CoordinateSet coordinateSet = MDUtils.readCoordinateFile(files[0], currentParameterSet.atomCount);

									
									
									//if atom count is given in the coordinate file, compare to the prmtop
									if (coordinateSet.atomCount > -1 && coordinateSet.atomCount != currentParameterSet.atomCount){
// 										callable.displayErrorMessage("Restart/trajectory file has number of atoms different from that in the loaded parameter file");
										callable.displayErrorMessage(M_Restarttrajectoryf);
										return;
									}
									
									fileLabel.setEnabled(true);
									//get the file name
									int index = files[0].toString().lastIndexOf(File.separator);
									if (index > 0){
										fileLabelValue.setText(files[0].toString().substring(index+1));
									}
									else{
										fileLabelValue.setText(files[0].toString());
									}
									
									//check for solvent flags
									if (!loadSolvent && currentParameterSet.solventStartAtom > -1){
										//check if there are solvent atoms to begin with
										int left = currentParameterSet.solventStartAtom - 1;//size of atoms to be left
										int remove = atoms.size() - left;
										int count = 0;
										currentParameterSet.solventAtoms.clear();
										for (int i = atoms.size()-1; i >= 0; i--){
											currentParameterSet.solventAtoms.insertElementAt(atoms.get(i), 0);
											atoms.remove(i);
											count++;
											if (count == remove) break;
										}
									}
									else{
										//if load with solvent, check whether the atoms list is complete
										//it may have been trimmed down in the previous load
										if (atoms.size() < currentParameterSet.atomCount){
											//add solvent atoms
											atoms.addAll(currentParameterSet.solventAtoms);
											currentParameterSet.solventAtoms.clear();//to keep things consistent
										}
									}
									
									atoms.trimToSize();
									


									//go through the atoms and assign coordinates
									int j = 0;//coordinate counter
									for (int i = 0; i < atoms.size(); i++){
										Atom a = (Atom)atoms.get(i);
										a.coordinate = new double[]{ coordinateSet.coordinates[j++], coordinateSet.coordinates[j++], coordinateSet.coordinates[j++] };
									}
									
									//now use the atom list to create the new StructureEntry
									Hashtable components = new Hashtable();
									components.put(StructureComponentRegistry.TYPE_ATOM, atoms);
									
									if (currentParameterSet.bonds.size() > 0){
										//check whether bonds need to be trimmed down
										for (int i = currentParameterSet.bonds.size()-1; i >= 0; i--){
											Bond bond = (Bond)currentParameterSet.bonds.get(i);
											if (!atoms.contains(bond.getAtom(0)) || !atoms.contains(bond.getAtom(1))){
												currentParameterSet.bonds.remove(bond);
											}
										}
										
										components.put(StructureComponentRegistry.TYPE_BOND, currentParameterSet.bonds);
									}

									
									structure = IOHandler.getStructure(components, coordinateSet.title);
//									System.out.println("structure = " + structure);
									
									if (structure == null){
// 										callable.displayErrorMessage("Unable to load structure");
										callable.displayErrorMessage(M_Unabletoloadstruct_1);
										return;
									}
									
									StructureEntry entry = new StructureEntry();
									entry.setStructure(structure);
									entry.setName(coordinateSet.title);
									callable.displayWaitScreen();
									
									titleLabel.setEnabled(true);
									atomsLabel.setEnabled(true);
									framesLabel.setEnabled(true);
									titleLabelValue.setText(currentParameterSet.title);
									atomsLabelValue.setText(new Integer(atoms.size()).toString());
									framesLabelValue.setText("1");
									
									currentEntry = entry;
									
									//load the new entry
									callable.addEntry(entry, true, true);
									callable.removeWaitScreen();
									
								}
								else if (dataType == COORD_MDCRD){
									fileObjects = new File[]{ files[0] };
									try{
										readMDFile();
									}
									catch (Exception ex){
										ex.printStackTrace();
										return;
									}
								}
								else if (dataType == COORD_DCD){
									fileObjects = new File[]{ files[0] };
									
									currentFrameSet = new Vector();
									chargeSet = new Vector();
									
									if (buffer){
										Thread runner = new Thread(){
											public void run(){
												readFirstFrame();//call this method to wait for the input data to arrive
											}
										};
										runner.start();

										fileLabel.setEnabled(true);
										
										//get the file name
										int index2 = files[0].toString().lastIndexOf(File.separator);
										if (index2 > 0){
											fileLabelValue.setText(files[0].toString().substring(index2+1));
										}
										else{
											fileLabelValue.setText(files[0].toString());
										}
										
										try{
											Thread runner2 = new Thread(){
												public void run(){
													if (controller == null) controller = new DCDController();
													controller.setStop(false);
													controller.readFiles();
												}
											};
											runner2.start();
											
										}
										catch (Exception e){
											e.printStackTrace();
											return;
										}
									}
									else{
										Thread runner = new Thread(){
											public void run(){
												readDCDFile();
											}
										};
										runner.start();
										
									}
									
								}
								
							}
							else{
								try{
									//display the array of files in a dialog to allow the user to arrange the files in the correct order
									//the dialog will call readUpdatedFileList()
									MDFileListerDialog d = new MDFileListerDialog(parent, thisObject, callable, files, MDFileListerDialog.TYPE_COORD);
								}
								catch (Exception e){
									e.printStackTrace();
								}
							}
							
						}
					};
					runner.start();
				}
			}
		});
		
		menuFileOpenPDB.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				
				final JFileChooser jFileChooser = new JFileChooser(callable.getLastUsedDirectory());
				jFileChooser.setMultiSelectionEnabled(true);
				javax.swing.filechooser.FileFilter structureFilter = new javax.swing.filechooser.FileFilter( ){
					private FileEntryLoader fsLoader = null;
					private String fslName = null;

					public boolean accept( File file ){
						if ( file.toString().endsWith("pdb") ) return true;
						
						if ( file.isDirectory() ) return true;
						return false;
					}
					
					public String getDescription( ){
// 						return "Concatenated PDB files";
						return M_ConcatenatedPDBfil;
					}
				};
				
				jFileChooser.addChoosableFileFilter( structureFilter );
						
				int returnVal = jFileChooser.showOpenDialog( callable.getApplicationFrame() );
				if ( returnVal == JFileChooser.APPROVE_OPTION ){
					Thread runner = new Thread(){
						public void run(){
							
							//get the filename and read the parameter file
							File[] files = jFileChooser.getSelectedFiles( );
							
							//check whether there is already something loaded
							if (structure != null){
								
// 								if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), "A structure is currently loaded. Delete it and load the new entry?", 
								if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), M_Astructureiscurren, 
// 										"Loading confirmation", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
										M_Loadingconfirmatio, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
									//delete the currently loaded structure
									//keep the current parameter set, however
									ParameterSet cp = currentParameterSet;
									String parfile = parfileLabelValue.getText();
									if (currentEntry != null){
										structureDocument.removeEntry(currentEntry);
										callable.removeCloseListener(currentEntry);
									}
								
									currentParameterSet = cp;
									parfileLabelValue.setText(parfile);
								}
								else{
									return;
								}
							}
							
							
							
							//save the used directory
							String dir = files[0].getParentFile().toString();
							callable.setLastUsedDirectory(dir);

							//first, read it as parameter file
							currentParameterSet = MDUtils.readParameterFile(files[0]);
							
							if (currentParameterSet != null){
								//get the file name
								parfileLabel.setEnabled(true);
								int index = files[0].toString().lastIndexOf(File.separator);
								if (index > 0){
									parfileLabelValue.setText(files[0].toString().substring(index+1));
								}
								else{
									parfileLabelValue.setText(files[0].toString());
								}
							}
							else{
// 								callable.displayErrorMessage("Unable to read parameter file");
								callable.displayErrorMessage(M_Unabletoreadparame_1);
								return;
							}

							//now feed the file to the pdb reader
							fileObjects = files;
							dataType = COORD_PDB;
							readPDBFile();
							
							
						}
					};
					runner.start();
				}
				
				
			}
		});
		
		menuFileSaveParam.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JFileChooser chooser = new JFileChooser(callable.getLastUsedDirectory());
// 				chooser.setDialogTitle("Save trajectory");
				chooser.setDialogTitle(M_Savetrajectory_2);

				chooser.setDialogType(JFileChooser.SAVE_DIALOG);

				
// 				FileFilter pdb = new FileNameFilter("pdb", "PDB format");
				FileFilter pdb = new FileNameFilter("pdb", M_PDBformat);
				
				chooser.addChoosableFileFilter( pdb );
				
				chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				int result = chooser.showSaveDialog(callable.getApplicationFrame());
				if (result == JFileChooser.CANCEL_OPTION){
					return;
				}
				
				File filename = chooser.getSelectedFile();
				String fname = filename.toString();
				
				int dot = fname.lastIndexOf(".");

				//get the desired file type
				FileFilter filter = chooser.getFileFilter();
				
				
				if (dot <= 0){
					//no extension supplied
					fname += "." + filter.toString();
				}
				
//				System.out.println("fname = " + fname);
				//if typed name doesn't match selected format, go with the typed/formed string anyway
				//respect user's judgement :)
					
				File ff = new File(fname);
				if (ff.exists()){
					if (ff.isDirectory()){
// 						callable.displayErrorMessage("Selected destination is a directory");
						callable.displayErrorMessage(M_Selecteddestinatio);
						return;

					}
					if (!ff.canWrite()){
// 						callable.displayErrorMessage("Selected file is not writable");
						callable.displayErrorMessage(M_Selectedfileisnotw);
						return;
					}
				}
				
				String path = ff.getPath();
				String fsep = File.separator;
				int separatorIndex = path.lastIndexOf(fsep);
				if (separatorIndex < 1){
					//entered file is in the current directory
					File currentDir = new File(".");
					if (!currentDir.canWrite()){
// 						callable.displayErrorMessage("Current directory is not writable");
						callable.displayErrorMessage(M_Currentdirectoryis);
					}
				}
				else{
					//entered file is in another directory
					String out_dir = path.substring(0,separatorIndex);
					File outDir = new File(out_dir);
					if (!outDir.canWrite()){
// 						callable.displayErrorMessage("Output directory is not writable");
						callable.displayErrorMessage(M_Outputdirectoryisn);
					}
				}
				
				//save the used directory
				String dir = ff.getParentFile().toString();
				callable.setLastUsedDirectory(dir);
				try{
					IOHandler.savePdb(structure, fname, callable, null, false, false);
				}
				catch (Exception ex){
// 					callable.displayExceptionMessage("Exception saving parameter file", ex);
					callable.displayExceptionMessage(M_Exceptionsavingpar, ex);
				}
			}
		});
		
		menuFileSave.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				
				Thread runner = new Thread(){
					public void run(){
						//get the file name and desired format first
						JFileChooser chooser = new JFileChooser(callable.getLastUsedDirectory());
// 						chooser.setDialogTitle("Save trajectory");
						chooser.setDialogTitle(M_Savetrajectory_2);

						chooser.setDialogType(JFileChooser.SAVE_DIALOG);

						
// 						FileFilter pdb = new FileNameFilter("mdcrd", "AMBER MDCRD format");
						FileFilter pdb = new FileNameFilter("mdcrd", M_AMBERMDCRDformat);
						
						chooser.addChoosableFileFilter( pdb );
// 						chooser.addChoosableFileFilter( new FileNameFilter("dcd", "DCD binary format") );
						chooser.addChoosableFileFilter( new FileNameFilter("dcd", M_DCDbinaryformat) );
						chooser.setFileFilter(pdb);
						
						chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
						int result = chooser.showSaveDialog(callable.getApplicationFrame());
						if (result == JFileChooser.CANCEL_OPTION){
							return;
						}
						
						File filename = chooser.getSelectedFile();
						String fname = filename.toString();
						
						int dot = fname.lastIndexOf(".");

						//get the desired file type
						FileFilter filter = chooser.getFileFilter();
						
						
						if (dot <= 0){
							//no extension supplied
							fname += "." + filter.toString();
						}
						
//						System.out.println("fname = " + fname);
						//if typed name doesn't match selected format, go with the typed/formed string anyway
						//respect user's judgement :)
							
						File ff = new File(fname);
						if (ff.exists()){
							if (ff.isDirectory()){
// 								callable.displayErrorMessage("Selected destination is a directory");
								callable.displayErrorMessage(M_Selecteddestinatio);
								return;

							}
							if (!ff.canWrite()){
// 								callable.displayErrorMessage("Selected file is not writable");
								callable.displayErrorMessage(M_Selectedfileisnotw);
								return;
							}
						}
						
						String path = ff.getPath();
						String fsep = File.separator;
						int separatorIndex = path.lastIndexOf(fsep);
						if (separatorIndex < 1){
							//entered file is in the current directory
							File currentDir = new File(".");
							if (!currentDir.canWrite()){
// 								callable.displayErrorMessage("Current directory is not writable");
								callable.displayErrorMessage(M_Currentdirectoryis);
							}
						}
						else{
							//entered file is in another directory
							String out_dir = path.substring(0,separatorIndex);
							File outDir = new File(out_dir);
							if (!outDir.canWrite()){
// 								callable.displayErrorMessage("Output directory is not writable");
								callable.displayErrorMessage(M_Outputdirectoryisn);
							}
						}
						
						//save the used directory
						String dir = ff.getParentFile().toString();
						callable.setLastUsedDirectory(dir);

						//file either doesn't exist or is writable - we are good to go

						try{
							if (filter.toString().equals("mdcrd")){
								//save ascii file with the trajectory
								PrintWriter printer = new PrintWriter(new FileWriter(ff));
								printer.println("");//first blank line
								
								//read the entire trajectory from the source file(s) just like when rmsd is calculated
								//null the temporary array as soon as the data is written to avoid memory issues
								//check the files
								int atomCount = currentParameterSet.atomCount;
								
								
								callable.displayWaitScreen();

								if (dataType == COORD_DCD){
									//it's a binary case
									try{
										
										double[] data = new double[atomCount*3];
										for (int i = 0; i < fileObjects.length; i++){
											File file = fileObjects[i];
											DCDHeader currentHeader = (DCDHeader)dcdHeaders.get(file);
											MappedByteBuffer byteBuffer = getAuxByteBuffer(file);
											
											int offset = currentHeader.headerSize;
											byteBuffer.position(offset);
											
											for (int f = 1; f <= currentHeader.frameCount; f++){

												int dataCount = 0;
												int k = 0;
												
												if (currentHeader.qcryst > 0){
													int v = byteBuffer.getInt();
													int reads = v/8;
													for (int vv = 0; vv < reads; vv++){
														byteBuffer.getDouble();
													}
													int vvv = byteBuffer.getInt();
												}
												
												//first, read all X's for this frame
												int a = byteBuffer.getInt();
												for (int j = 0; j < currentParameterSet.atomCount; j++){
													float c = byteBuffer.getFloat();
													data[dataCount] = (double)c;
													dataCount += 3;//fast forward to the next X
													k++;
												}
												int aa = byteBuffer.getInt();
												
												dataCount = 1;
												
												k = 0;
												//read Y records
												byteBuffer.getInt();
												for (int j = 0; j < currentParameterSet.atomCount; j++){
													float c = byteBuffer.getFloat();
													data[dataCount] = (double)c;
													dataCount += 3;//fast forward to the next X
													k++;
												}
												byteBuffer.getInt();
												
												//read Z records
												k = 0;
												dataCount = 2;
												byteBuffer.getInt();
												for (int j = 0; j < currentParameterSet.atomCount; j++){
													float c = byteBuffer.getFloat();
													data[dataCount] = (double)c;
													dataCount += 3;//fast forward to the next X
													k++;
												}
												byteBuffer.getInt();
												
												if (currentHeader.qcg > 0){
													int bbb = byteBuffer.getInt();
													for (int j = 0; j < currentParameterSet.atomCount; j++){
														byteBuffer.getFloat();
													}
													int aaa = byteBuffer.getInt();
												}

												
												//finished populating the current frame of coordinates
												//save it to a file
												int chunk = 0;//up to 10 in the line
												for (int z = 0; z < data.length; z++){
													String number = StringUtils.getFormattedNumber(data[z], 3);
													printer.print(StringUtils.leftPadded(number, 8, " "));
													chunk++;
													
													if (chunk == 10){
														chunk = 0;
														printer.print("\n");
													}
												}
												if (chunk != 0){
													printer.print("\n");//skip to new line for new frame unless this was the last entry on the line
												}
												
												
												dataCount = 0;
												k = 0;


												data = new double[atomCount*3];
												
											}
											
										}
										
									}
									catch (Exception exx){
										exx.printStackTrace();
									}
									
								}
								else if (dataType == COORD_MDCRD){
									//amber format
									try{
										
										int factor = 0;
										if (currentParameterSet.box > 0) factor = 3;//three more values per frame for box parameters
										int itemCount = currentParameterSet.atomCount*3 + factor;//total number of values for each frame in the file
										int limitNoSolvent = (currentParameterSet.solventStartAtom-1)*3 + factor;//number of values that should be read if no solvent loaded
										boolean solventPresent = false;


										double[] data = null;
										int size = -1;//size of the data array
										if (loadSolvent){
											data = new double[itemCount];//initialization of the first set of coordinates
											size = itemCount;
										}
										else{
											if (currentParameterSet.solventStartResidue > 1){
												solventPresent = true;
												data = new double[limitNoSolvent];//initialization of the first set of coordinates
												size = limitNoSolvent;
											}
											else{
												//there is no solvent anyway
												data = new double[itemCount];
												size = itemCount;
											}
										}
										
										if (!loadSolvent && solventPresent){
// 											callable.displayMessage("The trajectory file will not contain solvent. The corresponding parameter file needs to be saved for consistency");
											callable.displayMessage(M_Thetrajectoryfilew);
										}


									
										for (int i = 0; i < fileObjects.length; i++){
											BufferedReader reader = null;
											
											if (fileObjects[i].toString().endsWith("gz")){
												reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(fileObjects[i]))));
											}
											else{
												reader = new BufferedReader(new InputStreamReader(new FileInputStream(fileObjects[i])));
											}
											
											String line = reader.readLine();//may or may not have data
											
											int k = 0;//counter of read blocks of coordinates
											int dataCount = 0;

											while ((line = reader.readLine()) != null){
												try{
													for (int j = 0; j < 10; j++){
														if (loadSolvent || !solventPresent){
															data[dataCount] = Double.parseDouble(line.substring(j*8, (j+1)*8).trim());
															dataCount++;
														}
														else{
															//check if there is solvent
															if (solventPresent && k < limitNoSolvent){
																data[dataCount] = Double.parseDouble(line.substring(j*8, (j+1)*8).trim());
																dataCount++;
															}
														}
														k++;
														if (k == itemCount){
															//finished populating the current frame of coordinates
															//save it to a file
															int chunk = 0;//up to 10 in the line
															for (int z = 0; z < data.length; z++){
																String number = StringUtils.getFormattedNumber(data[z], 3);
																printer.print(StringUtils.leftPadded(number, 8, " "));
																chunk++;
																
																if (chunk == 10){
																	chunk = 0;
																	printer.print("\n");
																}
															}
															if (chunk != 0){
																printer.print("\n");//skip to new line for new frame unless this was the last entry on the line
															}
															
															dataCount = 0;
															k = 0;
															
														}
														
													}
													
												}
												catch (StringIndexOutOfBoundsException ee){
													continue;
												}
												catch (ArrayIndexOutOfBoundsException ee){
													ee.printStackTrace();
													continue;
												}
												catch (Exception ee){
													ee.printStackTrace();
													continue;
												}
											}			
										}
									}
									catch (Exception exx){
										exx.printStackTrace();
									}
									
									//end of amber format (MD) processing
								}
								else if (dataType == COORD_PDB){
									
									BufferedReader reader = null;
									
									String line = null;
									for (int k = 0; k < fileObjects.length; k++){
										reader = new BufferedReader(getReader(fileObjects[k]));
										
										try{
											int lineCount = 0;
											double[] data = new double[atomCount*3];
											int dataCount = 0;
											while ((line = reader.readLine()) != null){
												if (line.startsWith("ATOM") || line.startsWith("HETATM")){
													//read coordinates
													data[dataCount++] = Double.parseDouble( line.substring(30,38).trim());
													data[dataCount++] = Double.parseDouble( line.substring(38,46).trim());
													data[dataCount++] = Double.parseDouble( line.substring(46,54).trim());
													lineCount++;
												}
												
												if (line.startsWith("END")){
													//finished populating the current frame of coordinates
													//save it to a file
													int chunk = 0;//up to 10 in the line
													for (int z = 0; z < data.length; z++){
														String number = StringUtils.getFormattedNumber(data[z], 3);
														printer.print(StringUtils.leftPadded(number, 8, " "));
														chunk++;
														
														if (chunk == 10){
															chunk = 0;
															printer.print("\n");
														}
													}
													if (chunk != 0){
														printer.print("\n");//skip to new line for new frame unless this was the last entry on the line
													}
													
													
													dataCount = 0;
													data = new double[atomCount*3];
													lineCount = 0;
													
													continue;
												}
													
											
												if (lineCount == 500){
													lineCount = 0;
													Thread.sleep(1);
												}
											}
											
										}	
										catch (Exception exx){
											exx.printStackTrace();
											continue;
										}
									}

									
									
									
									//end of concatenated PDB processing
									
									
								}

								printer.close();

			
								callable.removeWaitScreen();
							}
							else if (filter.toString().equals("dcd")){
			
			
							}
							else{
// 								callable.displayErrorMessage("Unknown file format is selected.");
								callable.displayErrorMessage(M_Unknownfileformati);
							}
							
						}
						catch (Exception ex){
// 							callable.displayExceptionMessage("Exception when saving a trajectory", ex);
							callable.displayExceptionMessage(M_Exceptionwhensavin_1, ex);
						}
					}
				};
				runner.start();
				
			}
		});
		
		menuFileClear.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if (controller != null){
					controller.stop();
					controller = null;
				}
				currentParameterSet = null;
				currentFrameSet = null;
				structure = null;
				chargeSet = null;
				
				progress.setEnabled(false);
				playButton.setEnabled(false);
				stopButton.setEnabled(false);
				resetButton.setEnabled(false);
				stepForwardButton.setEnabled(false);
				stepBackButton.setEnabled(false);
				speed.setEnabled(false);
				
				dcdHeaders = null;
				totalFrames = 0;
				
				play = false;
				stopped = false;
				if (currentEntry != null){
					callable.removeCloseListener(currentEntry);
					structureDocument.removeEntry(currentEntry);
				}
				
				frameCounter.setEnabled(false);
				frameCounterField.setEnabled(false);
				frameCounterField.setText("0");
				frameCounterField.setEditable(false);
				currentFrame = 0;
				
				titleLabelValue.setText("");
				atomsLabelValue.setText("");
				fileLabelValue.setText("");
				framesLabelValue.setText("");
				parfileLabelValue.setText("");
				
				parfileLabel.setEnabled(false);
				titleLabel.setEnabled(false);
				atomsLabel.setEnabled(false);
				fileLabel.setEnabled(false);
				framesLabel.setEnabled(false);
				
				rmsd.setEnabled(false);
				rmsdLabelValue.setText("");
				
				energyAvailable = false;
				currentDataFrames = null;
				
				rmsdAvailable = false;
				currentRMSDFrames = null;

				etotLabel.setEnabled(false);
				etotLabelValue.setText("");
				etotLabel.setEnabled(false);
				etotLabelValue.setText("");
				ektotLabel.setEnabled(false);
				ektotLabelValue.setText("");
				eptotLabel.setEnabled(false);
				eptotLabelValue.setText("");
				
				loadingCompleted = false;
				loadedFirstFrame = false;
				
				rmsdBeingUpdated = false;
				fileObjects = null;
				if (fileMap != null) fileMap.clear();
				
				frameReference.clear();
				frameCounts.clear();
				
				closeEnergyPanel(false);
				closeRMSDPanel(false);
				closeTempPanel(false);
				
				Set keys = byteChannels.keySet();
				Iterator it = keys.iterator();
				while (it.hasNext()){
					File file = (File)it.next();
					FileChannel channel = (FileChannel)byteChannels.get(file);
					try{
						channel.close();
					}
					catch (Exception ex){}
					channel = null;
				}
				byteChannels.clear();
				byteBuffers.clear();
				
				keys = auxByteChannels.keySet();
				it = keys.iterator();
				while (it.hasNext()){
					File file = (File)it.next();
					FileChannel channel = (FileChannel)auxByteChannels.get(file);
					try{
						channel.close();
					}
					catch (Exception ex){}
					channel = null;
				}
				auxByteChannels.clear();
				auxByteBuffers.clear();

				if (rmsdGraphPanel != null){
					rmsdGraphPanel.closePanel();
				}
				
				EXsynch = true;
				
				currentEntry = null;
				
				System.gc();
				
			}
		});
		
		menuFileVideo.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if (currentFrameSet == null || currentFrameSet.size() == 0){
// 					callable.displayErrorMessage("No trajectory is loaded. Nothing to export");
					callable.displayErrorMessage(M_Notrajectoryisload);
					return;
				}
				
				DisplayDialog d = callable.getDisplayDialog();
				if (d == null){
					if (buffer && !loadingCompleted){
// 						callable.displayErrorMessage("You must play the trajectory at least once when using buffering in order to export video");
						callable.displayErrorMessage(M_Youmustplaythetraj);
						return;
					}
					
					Thread runner = new Thread(){
						public void run(){
							callable.setDisplayDialogStatus(true, new MDVideoDialog(callable.getApplicationFrame(), callable, thisObject));
						}
					};
					runner.start();
				}

			}
		});
		
		menuFileExportPOV.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if (currentFrameSet == null || currentFrameSet.size() == 0){
// 					callable.displayErrorMessage("No trajectory is loaded. Nothing to export");
					callable.displayErrorMessage(M_Notrajectoryisload);
					return;
				}
				
				DisplayDialog d = callable.getDisplayDialog();
				if (d == null){
					if (buffer && !loadingCompleted){
// 						callable.displayErrorMessage("You must play the trajectory at least once when using buffering in order to export video");
						callable.displayErrorMessage(M_Youmustplaythetraj);
						return;
					}
					
					Thread runner = new Thread(){
						public void run(){
							callable.setDisplayDialogStatus(true, new MDPOVDialog(callable.getApplicationFrame(), callable, thisObject));
						}
					};
					runner.start();
				}

			}
		});

		
		menuFileClose.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				setVisible(false);
				callable.closeMDPanel();
			}
		});

		menuFile.add(menuFileOpenOut);
		menuFile.add(new JSeparator());
		menuFile.add(menuFileOpenPar);
		menuFile.add(menuFileOpenCoord);
		menuFile.add(menuFileOpenPDB);
		menuFile.add(new JSeparator());
		menuFile.add(menuFileVideo);
		menuFile.add(menuFileExportPOV);
//		menuFile.add(menuFileSave);
		menuFile.add(new JSeparator());
		menuFile.add(menuFileClear);
		
// 		JMenu menuData = new JMenu("Data");
		JMenu menuData = new JMenu(M_Data_2);
		menuDataSolvent.setSelected(!loadSolvent);
		menuDataSolvent.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				loadSolvent = !menuDataSolvent.isSelected();
			}
		});
		
		menuDataBuffer.setSelected(buffer);
		menuDataBuffer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				buffer = menuDataBuffer.isSelected();
			}
		});
		
		
		menuDataRMSD.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				while (true){
					if (!rmsdBeingUpdated){
						break;
					}
					
					try{
						Thread.sleep(10);
					}
					catch (Exception ex){}
				}
				
				//display rmsd dialog
				DisplayDialog d = callable.getDisplayDialog();
				if (d == null){
					Thread runner = new Thread(){
						public void run(){
							callable.setDisplayDialogStatus(true, new MDRMSDDialog(callable.getApplicationFrame(), 
									callable, thisObject, callable.getStructureViewer()));
						}
					};
					runner.start();
				}
				
			}
		});
		
		menuDataShowEnergy.setSelected(false);
		menuDataShowEnergy.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if (menuDataShowEnergy.isSelected()){
					if (energyAvailable){
						openEnergyPanel();
					}
				}
				else{
					closeEnergyPanel(true);
				}
			}
		});
		
		menuDataShowTemp.setSelected(false);
		menuDataShowTemp.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if (menuDataShowTemp.isSelected()){
					if (energyAvailable){
						openTempPanel();
					}
				}
				else{
					closeTempPanel(true);
				}
			}
		});

		
		menuDataSS.setSelected(computeSS);
		menuDataSS.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if (menuDataSS.isSelected()){
					computeSS = menuDataSS.isSelected();
				}
			}
		});
		
		menuDataCenter.setSelected(centerView);
		menuDataCenter.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				centerView = menuDataCenter.isSelected();
			}
		});
		
		menuData.add(menuDataRMSD);
		menuData.add(new JSeparator());
		menuData.add(menuDataShowEnergy);
		menuData.add(menuDataShowTemp);
		menuData.add(menuDataCenter);
		menuData.add(menuDataSS);
		menuData.add(new JSeparator());
		menuData.add(menuDataSolvent);
		menuData.add(menuDataBuffer);
		
// 		JMenu menuSetup = new JMenu("Tools");
		JMenu menuSetup = new JMenu(M_Tools);
// 		JMenuItem menuSetupAmber = new JMenuItem("Prepare Amber simulation...");
		JMenuItem menuSetupAmber = new JMenuItem(M_PrepareAmbersimula);
		menuSetupAmber.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				DisplayDialog d = callable.getDisplayDialog();
				if (d == null){
					Thread runner = new Thread(){
						public void run(){
							callable.setDisplayDialogStatus(true, new MDSetupDialog(callable.getApplicationFrame(), callable));
						}
					};
					runner.start();
				}
			}
		});
		
// 		JMenuItem menuSetupNamd = new JMenuItem("Prepare NAMD simulation...");
		JMenuItem menuSetupNamd = new JMenuItem(M_PrepareNAMDsimulat_1);
		menuSetupNamd.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				DisplayDialog d = callable.getDisplayDialog();
				if (d == null){
					Thread runner = new Thread(){
						public void run(){
							callable.setDisplayDialogStatus(true, new NAMDSetupDialog(callable.getApplicationFrame(), callable));
						}
					};
					runner.start();
				}
			}
		});

		
		menuSetup.add(menuSetupAmber);
		menuSetup.add(menuSetupNamd);
		
		/**
		 * TODO clustering
		 */
		
		//clustering of trajectory frames
// 		JMenuItem menuSetupCluster = new JMenuItem("Cluster analysis...");
		JMenuItem menuSetupCluster = new JMenuItem(M_Clusteranalysis);
		menuSetupCluster.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				
				//now prepare the input files for ptraj
				String arch = System.getProperty("os.arch");
				String pt = StylesPreferences.ptrajDirectory + File.separator + "ptraj";
				File ff = new File(pt);
				if (ff.exists()){
					ptraj = true;
				}
				
				if (!ptraj){
// 					callable.displayErrorMessage("Ptraj is not available on this system");
					callable.displayErrorMessage(M_Ptrajisnotavailabl);
					return;
				}

				
				//open MD output file
				final JFileChooser jFileChooser = new JFileChooser(callable.getLastUsedDirectory());
				jFileChooser.setMultiSelectionEnabled(true);
				//amber md output type
				javax.swing.filechooser.FileFilter structureFilter = new javax.swing.filechooser.FileFilter( ){

					public boolean accept( File file ){
						if ( file.toString().endsWith("mdcrd") ) return true;
						if ( file.toString().endsWith("mdcrd.gz") ) return true;
						if ( file.toString().endsWith("dcd") ) return true;
						if ( file.isDirectory() ) return true;
						return false;
					}
					
					public String getDescription( ){
// 						return "MD trajectory file";
						return M_MDtrajectoryfile;
					}
				};
				
				jFileChooser.addChoosableFileFilter( structureFilter );
				
				int returnVal = jFileChooser.showOpenDialog( callable.getApplicationFrame() );
				if ( returnVal == JFileChooser.APPROVE_OPTION ){
					Thread runner = new Thread(){
						public void run(){
							
							//get the filename and read the out file
							File[] files = jFileChooser.getSelectedFiles( );
							//save the used directory
							String dir = files[0].getParentFile().toString();
							callable.setLastUsedDirectory(dir);
							
							//check files
							for (int i = 0; i < files.length; i++){
								File f = files[i];
								if (!f.toString().endsWith("mdcrd") && !f.toString().endsWith("mdcrd.gz") && !f.toString().endsWith("dcd")){
// 									callable.displayErrorMessage("All selected files must be MD trajectories");
									callable.displayErrorMessage(M_Allselectedfilesmu);
									return;
								}
							}
							
							
							//we need to determine which trajectories to analyze
							//it doesn't matter whether there is one or more files,
							//since there are additional options that are specified in the same
							//dialog

							try{
								//display the array of files in a dialog to allow the user to arrange the files in the correct order
								//the dialog will call readUpdatedFileList()
								ClusterMDFileListerDialog d = new ClusterMDFileListerDialog(parent, thisObject, callable, files);
							}
							catch (Exception e){
								e.printStackTrace();
							}
						}
					};
					runner.start();
				
				}
				
			}
		});
		
		JMenuItem menuSetupProcessCluster = new JMenuItem("Process clustering files");
		menuSetupProcessCluster.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if (clusterBasename == null) return;
				
				//here we rename all average and representative structure files to add the pdb extension
				
				try{
					File baseFile = new File(clusterBasename);
					String base = baseFile.getName();
//					System.out.println("clusterBasename = " + clusterBasename);
					
					//form the txt output file name
					String n = clusterBasename + ".txt";
					File f = new File(n);
//					System.out.println("f = " + f);
					
					String dirName = f.getParent();
					
//					System.out.println("dirName = " + dirName);
					File dir = new File(dirName);
					File[] files = dir.listFiles();
//					System.out.println("files = " + files.length);
					
					if (files.length == 0) return;
					
					for (int i = 0; i < files.length; i++){
						File file = files[i];
						if (file.getName().startsWith(base + ".avg")){
							file.renameTo(new File(file.toString() + ".pdb"));
						}
						else if (file.getName().startsWith(base + ".rep")){
							file.renameTo(new File(file.toString() + ".pdb"));
						}
					}
					
					callable.displayMessage("Completed processing clustering results");
					
				}
				catch (Exception ec){
					callable.displayExceptionMessage("Exception processing clustering files", ec);
				}
				
				clusterBasename = null;
			}
		});
		
		
		
		
		menuSetup.add(new JSeparator());
		menuSetup.add(menuSetupCluster);
		menuSetup.add(menuSetupProcessCluster);
		
		menuBar.add(menuFile);
		menuBar.add(menuData);
		menuBar.add(menuSetup);
		
		return menuBar;
		
	}
	
	private boolean ptraj = false;
	
	private String clusterBasename;
	
	/**
	 * This method calls ptraj to create clusters of frames based on mutual rmsd.
	 * The order of trajectory files is presumed to already be correct
	 */
	public void clusterTrajectoryFiles(Vector tFiles, String number, String basename, String outdir, String prmtop, boolean protein){
		
//		System.out.println(tFiles);
//		System.out.println("number = " + number);
///		System.out.println("basename = " + basename);
//		System.out.println("outdir  = " + outdir);
		
		clusterBasename = outdir + File.separator + basename;
		
		try{
//			callable.displayWaitScreen();
			
			String home = System.getProperty("user.home");
			PrintWriter printer = new PrintWriter(new FileWriter(home + File.separator + ".ptraj.in"));
			for (int i = 0; i < tFiles.size(); i++){
				String name = (String)tFiles.get(i);
				printer.println("trajin " + name);
			}
			
			printer.println("strip :WAT");//get rid of water by default
			printer.println("strip :HOH");
			printer.println("strip :TIP3");
			printer.println("strip :SOD");
			printer.println("strip :CLA");//different water/ion notations used in NAMD
			
			//now add the options
			printer.print("cluster out " + outdir + File.separator + basename + 
					" representative pdb average pdb Bayesian clusters " + number + " rms mass ");
			if (protein){
				printer.println("@CA");
			}
			else{
				printer.println("@P");//DNA/RNA
			}
			printer.println("go");
			printer.flush();
			printer.close();
			
//			System.out.println(ptrajPath + " " + prmtop + " " + home + File.separator + ".ptraj.in");
			
			
//			callable.displayMessage(ptrajPath + " " + prmtop + " " + home + File.separator + ".ptraj.in");
// 			JOptionPane.showInputDialog(parent, "Enter the command below in a terminal window", "Command", 
			JOptionPane.showInputDialog(parent, M_Enterthecommandbel, M_Command_1, 
					JOptionPane.INFORMATION_MESSAGE, null, null, ptrajPath + " " + prmtop + " " + home + File.separator + ".ptraj.in");			
			
/*			
			//now let's start the ptraj process with the input file created
			Runtime rt = Runtime.getRuntime();
			System.out.println("rt = " + rt);
			Process process = rt.exec(ptrajPath + " " + prmtop + " " + home + File.separator + ".ptraj.in");
//			Process process = rt.exec("date");
			InputStream in = process.getInputStream();
			BufferedReader reader = new BufferedReader(new InputStreamReader(in));
			String line = null;
			int i = 0;
			while ((line = reader.readLine()) != null){
				i++;
				System.out.println(line);
			}
	        in.close();
	        reader.close();
			process.waitFor();
			process.exitValue();
			process.destroy();
*/			
			
//			callable.removeWaitScreen();
			
		}
		catch (Exception ex){
			callable.removeWaitScreen();
			callable.displayExceptionMessage("Exception clustering trajectory frames", ex);
			return;
		}
		
		
		
	}
	
	public void exportVideo(int s, int e, int rate, String fname){

		if (e < s){
// 			callable.displayErrorMessage("Incorrect range: first frame is after the last one");
			callable.displayErrorMessage(M_Incorrectrangefirs);
			return;
		}
		
		if (s < 1) s = 1;

		final int start = s;
		final int end = e;
		final int framerate = rate;
		final String filename = fname;
		
		Thread runner = new Thread(){
			public void run(){
				
				//for now, export the entire trajectory
				Preferences root = Preferences.userRoot();
				final Preferences node = root.node("/edu/sdsc/sirius/config");
				String path = node.get("installDir", null);

				if (path == null){
					return;
				}
				
				if (start < 2){
					reset();
				}
				else{
					skip(start);
				}
				
				String temp = path + File.separator + "temp";
				
				int width = 0;
				int height = 0;
				
				callable.displayWaitScreen();
				Vector filenames = new Vector();
				
				ImageWriter writer = null;
				ImageWriteParam params = null;
				
				Iterator it = ImageIO.getImageWritersBySuffix("jpg");
				while (it.hasNext()){
					writer = (ImageWriter)it.next();
					params = writer.getDefaultWriteParam();
					params.setCompressionMode(ImageWriteParam.MODE_EXPLICIT);
					params.setCompressionQuality(0.95f);
					
					break;
				}
				
				boolean init = true;
				while (true){
					
					if (!init) step(true);
					
					if (currentFrame <= start){
						if (init){
							init = false;
						}
						else{
							//this is the end
							break;
						}
					}
					else{
						if (end > -1 && currentFrame > end){
							break;//end of requested fragment
						}
					}

					
//					System.out.println("currentFrame = " + currentFrame);
					//export the current view
					try{
						callable.getStructureViewer().getGeometryViewer().requestImage(0, 0, 0, 0, 96);
						//now wait for the image
						BufferedImage image = null;
						while (true){
							image = callable.getStructureViewer().getGeometryViewer().getImage();
							if (image != null) break;
							Thread.sleep(5);
						}
						String fname = temp + File.separator + "frame" + currentFrame + ".jpg";
						
						
//						ImageIO.write(image, "jpg", new File(fname));
						FileOutputStream fout = new FileOutputStream( new File(fname) );

						// Turn it into an ImageOutputStream
						ImageOutputStream ios = ImageIO.createImageOutputStream( fout );

						// Plug this stream into the ImageWriter
						writer.setOutput( ios );

						// Write the image
						writer.write( null, new IIOImage(image, null, null), params );

						// Dont forget to close the file!
						fout.close();
						
						filenames.add(fname);
						width = image.getWidth();
						height = image.getHeight();
						Thread.sleep(2);
					}
					catch (Exception ex){
// 						callable.displayExceptionMessage("Exception exporting video", ex);
						callable.displayExceptionMessage(M_Exceptionexporting, ex);
						return;
					}
					
				}
				
				//set of files has been saved. now convert it to video
				boolean result = JpegImagesToMovie.encode(width, height, framerate, filenames, "out.mov");
				
				
				writer.dispose();
				//remove temp files
				for (int i = 0; i < filenames.size(); i++){
					File f = new File((String)filenames.get(i));
					f.delete();
				}
				
				
				if (!result){
// 					callable.displayErrorMessage("Unable to export video");
					callable.displayErrorMessage(M_Unabletoexportvide);
					callable.removeWaitScreen();
					(new File("out.mov")).delete();
					return;
				}

				//copy the file to user-specified location
				FileTransfer ft = new FileTransfer();
				ft.copy(new File("out.mov"), new File(filename));
				
				(new File("out.mov")).delete();
				callable.removeWaitScreen();
				
			}
		};
		runner.start();
		
		
		
	}
	
	public boolean stopPOV = false;//enabled if cancel is hit
	
	public void processCancelEvent(){
		stopPOV = true;
	}
	
	public void exportPOV(int s, int e, String dname){

		if (e < s){
// 			callable.displayErrorMessage("Incorrect range: first frame is after the last one");
			callable.displayErrorMessage(M_Incorrectrangefirs);
			return;
		}
		
		if (s < 1) s = 1;

		final int start = s;
		final int end = e;
		final String dirname = dname;
		
		
		Thread runner = new Thread(){
			public void run(){
				
				boolean init = true;
				while (true){
					
					if (stopPOV){
						reset();
						stopPOV = false;
						break;
					}
					
					if (!init) step(true);
					
					if (currentFrame <= start){
						if (init){
							init = false;
						}
						else{
							//this is the end
							break;
						}
					}
					else{
						if (end > -1 && currentFrame > end){
							break;//end of requested fragment
						}
					}

					
//					System.out.println("currentFrame = " + currentFrame);
					//export the current view
					try{
						
						String fname = dirname + File.separator + "frame" + currentFrame + ".pov";
						RayTraceUtil.getPOVContent(callable.getStructureViewer(), callable, 0, 0, -1, false, fname);
						
						Thread.sleep(2);
					}
					catch (Exception ex){
// 						callable.displayExceptionMessage("Exception exporting video snapshots", ex);
						callable.displayExceptionMessage(M_Exceptionexporting_1, ex);
						return;
					}
					
				}
				
				//remove the cancel dialog
				if (cc != null){
					cc.setVisible(false);
				}
			}
		};
		runner.start();
		
		cc.setVisible(true);
		
		
	}

	
	public void readUpdatedCoordFileList(File[] files){
		
		long totalSize = 0;
		for (int i = 0; i < files.length; i++){
			totalSize += files[i].length();
		}
		
		if (totalSize > 20000000){
// 			if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), "The selected trajectory is over 20 MBytes. Would you like to load it using memory buffering?", 
			if (JOptionPane.showConfirmDialog(callable.getApplicationFrame(), M_Theselectedtraject_2, 
// 					"Loading confirmation", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
					M_Loadingconfirmatio, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION){
				buffer = true;
			}
		}

		
		if (buffer){
			//this is a multifile case
			currentFrameSet = new Vector();
			chargeSet = new Vector();
			
			Thread runner = new Thread(){
				public void run(){
					readFirstFrame();//call this method to wait for the input data to arrive
				}
			};
			runner.start();

			fileLabel.setEnabled(true);
			
			//get the file name
			int index2 = files[0].toString().lastIndexOf(File.separator);
			if (index2 > 0){
				fileLabelValue.setText(files[0].toString().substring(index2+1));
			}
			else{
				fileLabelValue.setText(files[0].toString());
			}

			currentRMSDFrames = new Vector();
			
			fileObjects = files;

			if (files[0].toString().endsWith("dcd")){
				Thread runner2 = new Thread(){
					public void run(){
						if (controller == null) controller = new DCDController();
						controller.setStop(false);
						controller.readFiles();
					}
				};
				runner2.start();
			}
			else{
				Thread runner2 = new Thread(){
					public void run(){
						if (controller == null) controller = new MDController();
						controller.setStop(false);
						controller.readFiles();
					}
				};
				runner2.start();
			}
		}
		else{
			fileObjects = files;
			Thread runner2 = new Thread(){
				public void run(){
					if (fileObjects[0].toString().endsWith("dcd")){
						//non-buffered dcd reading
						readDCDFile();
					}
					else{
						readMDFile();
					}
				}
			};
			runner2.start();
		}
		
		
	}


	
	private synchronized void openEnergyPanel(){
		
		if (!energyAvailable){
			menuDataShowEnergy.setSelected(false);
			return;
		}
		
		if (energyPanel == null){
			energyPanel = new EnergyPanel(callable, this, currentDataFrames);
//			energyPanel.updateGraph(currentFrame);//in case the panel is open while the data is being played
		}
		else{
			energyPanel.setVisible(true);
			energyPanel.updateMarker(currentFrame);
		}
	}
	
	public synchronized void closeEnergyPanel(boolean updateMenu){
		
		if (energyPanel != null){
			energyPanel.closePanel();
			if (updateMenu) menuDataShowEnergy.setSelected(false);
			energyPanel = null;
		}
		
	}
	
	private synchronized void openTempPanel(){
		
		if (!energyAvailable){
			menuDataShowTemp.setSelected(false);
			return;
		}
		
		if (tempPanel == null){
			tempPanel = new TemperaturePanel(callable, this, currentDataFrames);
		}
		else{
			tempPanel.setVisible(true);
			tempPanel.updateMarker(currentFrame);
		}
	}
	
	public synchronized void closeTempPanel(boolean updateMenu){
		
		if (tempPanel != null){
			tempPanel.closePanel();
			if (updateMenu) menuDataShowTemp.setSelected(false);
			tempPanel = null;
		}
		
	}

	
	private void openRMSDPanel(){
		
		if (loadingCompleted || currentRMSDFrames.size() > 1){
			if (!rmsdAvailable){
				return;
			}
		}
		else{
			while (true){
				if (loadingCompleted || currentRMSDFrames.size() > 1){
					if (rmsdAvailable){
						break;
					}
					else{
						return;
					}
				}
				try{
					Thread.sleep(10);
				}
				catch (InterruptedException e){}
			}
		}
		
		if (!rmsdAvailable){
			menuDataShowRMSD.setSelected(false);
			return;
		}
		
		if (rmsdGraphPanel == null){
			rmsdGraphPanel = new RMSDPanel(callable, this);
//			energyPanel.updateGraph(currentFrame);//in case the panel is open while the data is being played
		}
		else{
			rmsdGraphPanel.setVisible(true);
			rmsdGraphPanel.updateMarker(currentFrame);
		}
		
		computeRMSD = true;
		rmsd.setEnabled(true);
		this.rmsdLabelValue.setText("0.000");
	}
	
	public synchronized void closeRMSDPanel(boolean updateMenu){
		
		if (rmsdGraphPanel != null){
			rmsdGraphPanel.closePanel();
			if (updateMenu) menuDataShowRMSD.setSelected(false);
			rmsdGraphPanel = null;
		}
		
	}
	
	public EnergyPanel getEnergyPanel(){
		return energyPanel;
	}

	public RMSDPanel getRMSDPanel(){
		return rmsdGraphPanel;
	}
	
	public boolean isLoadingCompleted(){
		return loadingCompleted;
	}
	
	public Vector getRMSDFrames(){
		return currentRMSDFrames;
	}
	
	public Vector getDataFrames(){
		return currentDataFrames;
	}
	
	public void readUpdatedOutFileList(File[] files){
		try{
			readOutFiles(files);
		}
		catch (Exception e){
			
		}
	}
	
	/**
	 * This method processes selections from the rmsd dialog
	 * @param reference
	 * @param set
	 * @param file - file object if reference is another file (null otherwise)
	 * @param atomset - name of atom set used to compute rmsd (null is another set option is chosen)
	 */
	public void computeRMSD(RMSData rms){
		
		if (fileObjects == null || fileObjects.length == 0){
// 			callable.displayErrorMessage("No data available to compute RMSD. Load a trajectory file and try again.");
			callable.displayErrorMessage(M_Nodataavailabletoc);
			return;
		}
		
		final int ref = rms.reference;
		final int set = rms.extent;
		final String setName = rms.setName;
		final File file = rms.referenceFile;
		final Vector trajectories = rms.trajectories;
		final boolean internal = rms.internal;//whether this RMSD is computed for a loaded trajectory
		final boolean selection = rms.selection;
		
		rmsdBeingUpdated = true;
		
		Thread runner = new Thread(){
			public void run(){
				currentRMSDFrames = new Vector();
				double[] refCoordinates = null;
				
				//check the files
				int atomCount = currentParameterSet.atomCount;
				
				double min = 1000000000;
				int minFrame = -1;
				if (ref == MDRMSDDialog.LOWEST_FRAME){
					//precalculate coordinates of the reference
					//first, locate the lowest energy frame
					for (int i = 0; i < currentDataFrames.size(); i++){
						double[] data = (double[])currentDataFrames.get(i);
						double e = data[5];//take into account the potential energy of the system
						if (e < min){
							min = e;
							minFrame = i;
						}
					}
					
					if (currentFrameSet.size() < minFrame){
// 						callable.displayErrorMessage("The lowest energy frame has not been loaded yet. Please wait until loading is completed and try again");
						callable.displayErrorMessage(M_Thelowestenergyfra);
						rmsdBeingUpdated = false;
						pending = false;
						return;
					}
					
					//get the structure of that frame
					double[] referenceOriginal = (double[])currentFrameSet.get(minFrame);
					refCoordinates = new double[referenceOriginal.length];
					for (int i = 0; i < refCoordinates.length; i++){
						refCoordinates[i] = referenceOriginal[i];
					}
					
					if (refCoordinates.length != currentParameterSet.atomCount*3){
// 						callable.displayErrorMessage("Selected reference has different atom count from the currently loaded data. Select another reference and try again.");
						callable.displayErrorMessage(M_Selectedreferenceh);
						rmsdBeingUpdated = false;
						pending = false;
						return;
					}
				}
				else if (ref == MDRMSDDialog.ANOTHER_STRUCTURE){
					//populate reference with another structure atoms
					//whether the file is pdb, rst, inpcrd or mdcrd, we only need to get coordinates of the atoms from
					//the first available frame
					
					//IMPORTANT: check to make sure the reference has the same atom count as the loaded structure!
					
					refCoordinates = MDUtils.getCoordinates(file);
					
					if (refCoordinates == null || refCoordinates.length == 0){
// 						callable.displayErrorMessage("Reference file contains no data.");
						callable.displayErrorMessage(M_Referencefileconta);
						rmsdBeingUpdated = false;
						pending = false;
						return;
					}
					
					if (refCoordinates.length != currentParameterSet.atomCount*3){
// 						callable.displayErrorMessage("Selected reference has different atom count from the currently loaded data. Select another reference and try again.");
						callable.displayErrorMessage(M_Selectedreferenceh);
						rmsdBeingUpdated = false;
						pending = false;
						return;
					}
					
				}
				
				
				//take care of the rmsd mask
				//depending on the selected option, this will indicate which coordinates should be taken into account and
				//which should not
				
				updateRMSDMask(set, setName, selection);
				
				int factor = 0;
				if (currentParameterSet.box > 0) factor = 3;//three more values per frame for box parameters
				int itemCount = currentParameterSet.atomCount*3 + factor;//total number of values for each frame in the file
				int limitNoSolvent = (currentParameterSet.solventStartAtom-1)*3 + factor;//number of values that should be read if no solvent loaded
				boolean solventPresent = false;

				currentRMSDFrames = new Vector();
				
				double[] data = null;
				int size = -1;//size of the data array
				if (loadSolvent){
					data = new double[itemCount];//initialization of the first set of coordinates
					size = itemCount;
				}
				else{
					if (currentParameterSet.solventStartResidue > 1){
						solventPresent = true;
						data = new double[limitNoSolvent];//initialization of the first set of coordinates
						size = limitNoSolvent;
					}
					else{
						//there is no solvent anyway
						data = new double[itemCount];
						size = itemCount;
					}
				}

				double[] reference = new double[size];//double[] array with reference coordinates that will be used for rmsd calculation
				
				if (ref == MDRMSDDialog.ANOTHER_STRUCTURE){
					for (int i = 0; i < size; i++){
						reference[i] = refCoordinates[i];
					}

				}
				
				pending = true;
				
				Thread status = new Thread(){
					public void run(){
						int i = 0;
						while (pending){
							try{
								Thread.sleep(100);
								if (i == symbols.length) i = 0;
								if (symbols[i].equals("--")){
// 									Status.output(Status.LEVEL_ERROR, symbols[i++] + "Calculating RMSD...");
									Status.output(Status.LEVEL_ERROR, symbols[i++] + M_CalculatingRMSD);
								}
								else{
									Status.output(Status.LEVEL_ERROR, symbols[i++] + " Calculating RMSD...");
								}
								
							}
							catch (InterruptedException e){}
						}
						
						Status.output(Status.LEVEL_REMARK, "");
					}
				};
				status.start();
				
				
				if (dataType == COORD_DCD){
					//it's a binary case
					int counter = 0;//how many frames were read
					try{
						for (int i = 0; i < fileObjects.length; i++){
							File file = fileObjects[i];
							DCDHeader currentHeader = (DCDHeader)dcdHeaders.get(file);
							MappedByteBuffer byteBuffer = getAuxByteBuffer(file);
							
							int offset = currentHeader.headerSize;
							byteBuffer.position(offset);
							
							for (int f = 1; f <= currentHeader.frameCount; f++){

								int dataCount = 0;
								int k = 0;
								
								if (currentHeader.qcryst > 0){
									int v = byteBuffer.getInt();
									int reads = v/8;
									for (int vv = 0; vv < reads; vv++){
										byteBuffer.getDouble();
									}
									int vvv = byteBuffer.getInt();
								}
								
								//first, read all X's for this frame
								int a = byteBuffer.getInt();
								for (int j = 0; j < currentParameterSet.atomCount; j++){
									float c = byteBuffer.getFloat();
									if (loadSolvent || !solventPresent){
										data[dataCount] = (double)c;
										dataCount += 3;//fast forward to the next X
										k++;
									}
									else{
										//check if there is solvent
										if (solventPresent && k < limitNoSolvent){
											data[dataCount] = (double)c;
											dataCount += 3;
											k++;
										}
									}
								}
								int aa = byteBuffer.getInt();
								
								dataCount = 1;
								
								k = 0;
								//read Y records
								byteBuffer.getInt();
								for (int j = 0; j < currentParameterSet.atomCount; j++){
									float c = byteBuffer.getFloat();
									if (loadSolvent || !solventPresent){
										data[dataCount] = (double)c;
										dataCount += 3;//fast forward to the next Y
										k++;
									}
									else{
										//check if there is solvent
										if (solventPresent && k < limitNoSolvent){
											data[dataCount] = (double)c;
											dataCount += 3;
											k++;
										}
									}
								}
								byteBuffer.getInt();
								
								//read Z records
								k = 0;
								dataCount = 2;
								byteBuffer.getInt();
								for (int j = 0; j < currentParameterSet.atomCount; j++){
									float c = byteBuffer.getFloat();
									if (loadSolvent || !solventPresent){
										data[dataCount] = (double)c;
										dataCount += 3;//fast forward to the next Z
										k++;
									}
									else{
										//check if there is solvent
										if (solventPresent && k < limitNoSolvent){
											data[dataCount] = (double)c;
											dataCount += 3;
											k++;
										}
									}
								}
								byteBuffer.getInt();
								
								if (currentHeader.qcg > 0){
									int bbb = byteBuffer.getInt();
									for (int j = 0; j < currentParameterSet.atomCount; j++){
										byteBuffer.getFloat();
									}
									int aaa = byteBuffer.getInt();
								}

								
								//finished populating the current frame of coordinates
								
								counter++;
								
								if (counter == 1 && ref == MDRMSDDialog.FIRST_FRAME){
									//record the first frame and do not use it to compute rmsd
									for (int n = 0; n < size; n++){
										reference[n] = data[n];
									}
									currentRMSDFrames.add(new Double(0.0));
									dataCount = 0;
									continue;
								}
								
								//if this is not the first frame, calculate the rmsd
								//using the reference array and record it in a second array
								double sum = 0;
								int rfactor = 0;
								if (currentParameterSet.box > 0) rfactor = 3;

								if (set != MDRMSDDialog.USE_ALL_ATOMS && rmsdMask != null){
									for (int m = 0; m < reference.length - rfactor; m++){
										if (rmsdMask[m]) sum += ((reference[m] - data[m])*(reference[m] - data[m]));
									}
								}
								else{
									for (int m = 0; m < reference.length - 3; m++){
										sum += ((reference[m] - data[m])*(reference[m] - data[m]));
									}
								}
								
								double result = Math.sqrt(sum/currentParameterSet.atomCount);
								Double res = new Double(result);
								currentRMSDFrames.add(res);
								
								dataCount = 0;
								k = 0;


								if (loadSolvent || !solventPresent){
									data = new double[itemCount];
								}
								else{
									data = new double[limitNoSolvent];
								}
								
							}
							
						}
					}
					catch (Exception e){
						e.printStackTrace();
					}
					
//					System.out.println("Size of rmsd frames = " + currentRMSDFrames.size());
					
				}
				else if (dataType == COORD_MDCRD){
					//amber format
					int counter = 0;//how many frames were read
					try{
					
						for (int i = 0; i < fileObjects.length; i++){
							BufferedReader reader = null;
							
							if (fileObjects[i].toString().endsWith("gz")){
								reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(fileObjects[i]))));
							}
							else{
								reader = new BufferedReader(new InputStreamReader(new FileInputStream(fileObjects[i])));
							}
							
							String line = reader.readLine();//may or may not have data
							
							int k = 0;//counter of read blocks of coordinates
							int dataCount = 0;

							while ((line = reader.readLine()) != null){
								try{
									for (int j = 0; j < 10; j++){
										if (loadSolvent || !solventPresent){
											data[dataCount] = Double.parseDouble(line.substring(j*8, (j+1)*8).trim());
											dataCount++;
										}
										else{
											//check if there is solvent
											if (solventPresent && k < limitNoSolvent){
												data[dataCount] = Double.parseDouble(line.substring(j*8, (j+1)*8).trim());
												dataCount++;
											}
										}
										k++;
										if (k == itemCount){
											counter++;
											if (counter == 1 && ref == MDRMSDDialog.FIRST_FRAME){
												//record the first frame and do not use it to compute rmsd
												for (int n = 0; n < size; n++){
													reference[n] = data[n];
												}
												currentRMSDFrames.add(new Double(0.0));
												k = 0;
												dataCount = 0;
												continue;
											}
											
											//if this is not the first frame, calculate the rmsd
											//using the reference array and record it in a second array
											double sum = 0;
											int rfactor = 0;
											if (currentParameterSet.box > 0) rfactor = 3;

											if (set != MDRMSDDialog.USE_ALL_ATOMS && rmsdMask != null){
												for (int m = 0; m < reference.length - rfactor; m++){
													if (rmsdMask[m]) sum += ((reference[m] - data[m])*(reference[m] - data[m]));
												}
											}
											else{
												for (int m = 0; m < reference.length - 3; m++){
													sum += ((reference[m] - data[m])*(reference[m] - data[m]));
												}
											}
											
											double result = Math.sqrt(sum/currentParameterSet.atomCount);
											Double res = new Double(result);
											currentRMSDFrames.add(res);
											
											dataCount = 0;
											k = 0;
											
										}
										
									}
									
								}
								catch (StringIndexOutOfBoundsException e){
									continue;
								}
								catch (ArrayIndexOutOfBoundsException e){
									e.printStackTrace();
									continue;
								}
								catch (Exception e){
									e.printStackTrace();
									continue;
								}
							}			
						}
					}
					catch (Exception e){
						e.printStackTrace();
					}
					
					//end of amber format (MD) processing
				}
				else if (dataType == COORD_PDB){
					
					BufferedReader reader = null;
					int counter = 0;
					
					String line = null;
					for (int k = 0; k < fileObjects.length; k++){
						reader = new BufferedReader(getReader(fileObjects[k]));
						
						try{
							int lineCount = 0;
							data = new double[itemCount];
							int dataCount = 0;
							while ((line = reader.readLine()) != null){
								if (line.startsWith("ATOM") || line.startsWith("HETATM")){
									//read coordinates
									data[dataCount++] = Double.parseDouble( line.substring(30,38).trim());
									data[dataCount++] = Double.parseDouble( line.substring(38,46).trim());
									data[dataCount++] = Double.parseDouble( line.substring(46,54).trim());
									lineCount++;
								}
								
								if (line.startsWith("END")){
									
									counter++;
									
									if (counter == 1 && ref == MDRMSDDialog.FIRST_FRAME){
										//record the first frame and do not use it to compute rmsd
										for (int n = 0; n < size; n++){
											reference[n] = data[n];
										}
										currentRMSDFrames.add(new Double(0.0));
										k = 0;
										dataCount = 0;
										continue;
									}
									
									//if this is not the first frame, calculate the rmsd
									//using the reference array and record it in a second array
									double sum = 0;
									int rfactor = 0;
									if (currentParameterSet.box > 0) rfactor = 3;

									if (set != MDRMSDDialog.USE_ALL_ATOMS && rmsdMask != null){
										for (int m = 0; m < reference.length - rfactor; m++){
											if (rmsdMask[m]) sum += ((reference[m] - data[m])*(reference[m] - data[m]));
										}
									}
									else{
										for (int m = 0; m < reference.length - 3; m++){
											sum += ((reference[m] - data[m])*(reference[m] - data[m]));
										}
									}
									
									double result = Math.sqrt(sum/currentParameterSet.atomCount);
									Double res = new Double(result);
									currentRMSDFrames.add(res);
									
									dataCount = 0;
									data = new double[itemCount];
									lineCount = 0;
									
									continue;
								}
									
							
								if (lineCount == 500){
									lineCount = 0;
									Thread.sleep(1);
								}
							}
							
						}	
						catch (Exception e){
							e.printStackTrace();
							continue;
						}
					}

					
					
					
					//end of concatenated PDB processing
					
					
				}
				else{
// 					callable.displayErrorMessage("Unknown file format. Unable to compute RMSD");
					callable.displayErrorMessage(M_UnknownfileformatU);
					return;
				}
				
				
				rmsdBeingUpdated = false;
				
				pending = false;

				rmsd.setEnabled(true);
				rmsdLabelValue.setText("0.000");
				Thread runner = new Thread(){
					public void run(){
						if (rmsdGraphPanel != null){
							rmsdGraphPanel.setVisible(true);
						}
						else{
							rmsdGraphPanel = new RMSDPanel(callable, thisObject);
						}
						rmsdGraphPanel.updateGraph(set, setName);
					}
				};
				runner.start();

			}
		};
		runner.start();
	}
	
	/**
	 * This method takes input parameters, gets the remaining ones from the loaded trajectory
	 * and uses mm_pbsa to calculate energy values
	 * @param input
	 */
	public void computeEnergy(PBSAInput input){
		
		//get the parameters
		String desolvComplexPrmtop = input.desolvComplexPrmtop;
		String desolvProteinPrmtop = input.desolvProteinPrmtop;
		String desolvLigandPrmtop = input.desolvLigandPrmtop;
		boolean binding = input.binding;
		String outdir = input.outdir;
		int snapshots = input.snapshotCount;
		
		Vector ligandAtoms = input.ligand;
		
		//get the remaining parameters: names of mdcrd files and the solvated complex prmtop file
		//atom count before the solvent starts, plus total number of frames loaded
		
		//get the input mdcrd files
		Vector trajectories = new Vector();
		for (int i = 0; i < fileObjects.length; i++){
			trajectories.add(fileObjects[i]);
		}
		
		//solvated complex prmtop file
		String solvatedComplexPrmtop = currentParameterSet.sourceFile;
		
		//total atom count
		int totalAtomCount = currentParameterSet.atomCount;
		
		//non-solvent atom count
		int soluteAtomCount = currentParameterSet.atomCount;
		
		System.out.println("soluteAtomCount = " + soluteAtomCount);
		
		callable.displayWaitScreen();
		
		//total number of frames loaded (should work for both buffered and non-buffered cases)

		int frames = countFrames();
		
		int frequency = frames/snapshots;
		
		//for binding energy, get the count of non-ligand atoms
		ParameterSet proteinParameterSet = MDUtils.readParameterFile(new File(desolvProteinPrmtop));
		int proteinAtomCount = proteinParameterSet.atomCount;
		
		ParameterSet ligandParameterSet = MDUtils.readParameterFile(new File(desolvLigandPrmtop));
		int ligandAtomCount = ligandParameterSet.atomCount;
		
		try{
			//now create the output directory
			File outputDir = new File(outdir);
			if (outputDir.exists() && !outputDir.isDirectory()){
// 				callable.displayErrorMessage("Selected output directory is a file and it already exists.");
				callable.displayErrorMessage(M_Selectedoutputdire);
				return;
			}
			
			if (!outputDir.exists()){
				boolean result = outputDir.mkdir();
				if (!result){
// 					callable.displayErrorMessage("Unable to create temporary directory " + outdir);
					callable.displayErrorMessage(M_Unabletocreatetemp_1 + outdir);
					return;
				}
			}
			
			System.out.println("proteinAtomCount = " + proteinAtomCount);
			
			//let's print input files
			if (binding){
				//complex stability calculation
				
				int ligandStartAtom = proteinAtomCount + 1;
				int ligandStopAtom = ligandStartAtom + ligandAtomCount - 1;
				
				PrintWriter printer = new PrintWriter(new FileWriter(outdir + File.separator + "extract.in"));
				
				printer.println("@GENERAL");
				printer.println("PREFIX                snapshot");
				printer.println("PATH                  " + outdir);
				printer.println("#");
				printer.println("COMPLEX               1");
				printer.println("RECEPTOR              1");
				printer.println("LIGAND                1");
				printer.println("#");
				printer.println("COMPT                 " + desolvComplexPrmtop);
				printer.println("RECPT                 " + desolvProteinPrmtop);
				printer.println("LIGPT                 " + desolvLigandPrmtop);
				printer.println("#");
				printer.println("GC                    1");
				printer.println("AS                    0");
				printer.println("DC                    0");
				printer.println("#");
				printer.println("MM                    0");
				printer.println("GB                    0");
				printer.println("PB                    0");
				printer.println("MS                    0");
				printer.println("#");
				printer.println("NM                    0");
				printer.println("@MAKECRD");
				printer.println("BOX                   YES");
				printer.println("NTOTAL                " + totalAtomCount);
				printer.println("NSTART                1");
				printer.println("NSTOP                 " + frames);
				printer.println("NFREQ                 " + frequency);
				printer.println("#");
				printer.println("NUMBER_LIG_GROUPS     1");
				printer.println("LSTART                " + ligandStartAtom);
				printer.println("LSTOP                 " + ligandStopAtom);
				printer.println("NUMBER_REC_GROUPS     1");
				printer.println("RSTART                1");
				printer.println("RSTOP                 " + proteinAtomCount);
				printer.println("@TRAJECTORY");
				for (int i = 0; i < fileObjects.length; i++){
					printer.println("TRAJECTORY            " + fileObjects[i].toString());
				}
				printer.println("@PROGRAMS");
				printer.flush();
				printer.close();
				
				
				//now write up the binding energy input file
				printer = new PrintWriter(new FileWriter(outdir + File.separator + "binding.in"));

				printer.println("@GENERAL");
				printer.println("PREFIX                snapshot");
				printer.println("PATH                  " + outdir);
				printer.println("#");
				printer.println("COMPLEX               1");
				printer.println("RECEPTOR              0");
				printer.println("LIGAND                0");
				printer.println("#");
				printer.println("COMPT                 " + desolvComplexPrmtop);
				printer.println("RECPT                 " + desolvProteinPrmtop);
				printer.println("LIGPT                 " + desolvLigandPrmtop);
				printer.println("#");
				printer.println("GC                    0");
				printer.println("AS                    0");
				printer.println("DC                    0");
				printer.println("#");
				printer.println("MM                    1");
				printer.println("GB                    1");
				printer.println("PB                    1");
				printer.println("MS                    1");
				printer.println("#");
				printer.println("NM                    0");
				
				printer.println("@PB");
				printer.println("PROC                  2");
				printer.println("REFE                  0");
				printer.println("INDI                  1.0");
				printer.println("EXDI                  80.0");
				printer.println("SCALE                 2");
				printer.println("LINIT                 1000");
				printer.println("PRBRAD                1.4");
				printer.println("ISTRNG                0.0");
				printer.println("RADIOPT               0");
				printer.println("NPOPT                 1");
				printer.println("CAVITY_SURFTEN        0.0072");
				printer.println("CAVITY_OFFSET         0.00");
				printer.println("#");
				printer.println("SURFTEN               0.0072");
				printer.println("SURFOFF               0.00");
				
				printer.println("@MM");
				printer.println("DIELC                 1.0");
				
				printer.println("@GB");
				printer.println("IGB                   2");
				printer.println("GBSA                  1");
				printer.println("SALTCON               0.00");
				printer.println("EXTDIEL               80.0");
				printer.println("INTDIEL               1.0");
				printer.println("#");
				printer.println("SURFTEN               0.0072");
				printer.println("SURFOFF               0.00");

				printer.println("@MS");
				printer.println("PROBE                 0.0");
				printer.println("@PROGRAMS");
				printer.flush();
				printer.close();

				
				
			}
			else{
				//simple stability calculation without a separate ligand
				PrintWriter printer = new PrintWriter(new FileWriter(outdir + File.separator + "extract.in"));
				
				printer.println("@GENERAL");
				printer.println("PREFIX                snapshot");
				printer.println("PATH                  " + outdir);
				printer.println("#");
				printer.println("COMPLEX               1");
				printer.println("RECEPTOR              0");
				printer.println("LIGAND                0");
				printer.println("#");
				printer.println("COMPT                 " + desolvComplexPrmtop);
				printer.println("RECPT                 XXX");
				printer.println("LIGPT                 XXX");
				printer.println("#");
				printer.println("GC                    1");
				printer.println("AS                    0");
				printer.println("DC                    0");
				printer.println("#");
				printer.println("MM                    0");
				printer.println("GB                    0");
				printer.println("PB                    0");
				printer.println("MS                    0");
				printer.println("#");
				printer.println("NM                    0");
				printer.println("@MAKECRD");
				printer.println("BOX                   YES");
				printer.println("NTOTAL                " + totalAtomCount);
				printer.println("NSTART                1");
				printer.println("NSTOP                 " + frames);
				printer.println("NFREQ                 " + frequency);
				printer.println("#");
				printer.println("NUMBER_LIG_GROUPS     0");
				printer.println("LSTART                0");
				printer.println("LSTOP                 0");
				printer.println("NUMBER_REC_GROUPS     1");
				printer.println("RSTART                1");
				printer.println("RSTOP                 " + soluteAtomCount);

				printer.println("@TRAJECTORY");
				for (int i = 0; i < fileObjects.length; i++){
					printer.println("TRAJECTORY            " + fileObjects[i].toString());
				}
				printer.println("@PROGRAMS");
				printer.flush();
				printer.close();
				
				//now write up the binding energy input file
				printer = new PrintWriter(new FileWriter(outdir + File.separator + "binding.in"));

				printer.println("@GENERAL");
				printer.println("PREFIX                snapshot");
				printer.println("PATH                  " + outdir);
				printer.println("#");
				printer.println("COMPLEX               1");
				printer.println("RECEPTOR              0");
				printer.println("LIGAND                0");
				printer.println("#");
				printer.println("COMPT                 " + desolvComplexPrmtop);
				printer.println("RECPT                 XXX");
				printer.println("LIGPT                 XXX");
				printer.println("#");
				printer.println("GC                    0");
				printer.println("AS                    0");
				printer.println("DC                    0");
				printer.println("#");
				printer.println("MM                    1");
				printer.println("GB                    1");
				printer.println("PB                    1");
				printer.println("MS                    1");
				printer.println("#");
				printer.println("NM                    0");
				
				printer.println("@PB");
				printer.println("PROC                  2");
				printer.println("REFE                  0");
				printer.println("INDI                  1.0");
				printer.println("EXDI                  80.0");
				printer.println("SCALE                 2");
				printer.println("LINIT                 1000");
				printer.println("PRBRAD                1.4");
				printer.println("ISTRNG                0.0");
				printer.println("RADIOPT               0");
				printer.println("NPOPT                 1");
				printer.println("CAVITY_SURFTEN        0.0072");
				printer.println("CAVITY_OFFSET         0.00");
				printer.println("#");
				printer.println("SURFTEN               0.0072");
				printer.println("SURFOFF               0.00");

				printer.println("@MM");
				printer.println("DIELC                 1.0");

				printer.println("@GB");
				printer.println("IGB                   2");
				printer.println("GBSA                  1");
				printer.println("SALTCON               0.00");
				printer.println("EXTDIEL               80.0");
				printer.println("INTDIEL               1.0");
				printer.println("#");
				printer.println("SURFTEN               0.0072");
				printer.println("SURFOFF               0.00");

				printer.println("@MS");
				printer.println("PROBE                 0.0");
				printer.println("@PROGRAMS");
				printer.flush();
				printer.close();

			}
			
			callable.removeWaitScreen();

			
			//now, that the input files are ready, run the mm_pbsa.pl script
			//first, extract the snapshots
			
			//locate the script
			File f = new File("/opt/amber");
			String command = null;
			if (f.exists()){
				//we are on redwood, and should use /opt/amber/exe/mm_pbsa.pl
				command = "/opt/amber/exe/mm_pbsa.pl " + outdir + File.separator + "extract.in > " + outdir + File.separator + "snaps.log";
			}
			else{
				//we are on abicluster, and should use /data/amber9/exe/mm_pbsa.pl
				command = "/data/amber9/exe/mm_pbsa.pl " + outdir + File.separator + "extract.in > " + outdir + File.separator + "snaps.log";
			}
			
			
			String blank = (String)JOptionPane.showInputDialog(parent, "Run this command in a shell and click OK when completed", "mm_pbsa command line", 
					JOptionPane.INFORMATION_MESSAGE, null, null, command);

			
			//next, run the actual energy calculation on abicluster (64-bit Linux)
			blank = (String)JOptionPane.showInputDialog(parent, "Run this command in a shell on a 64-bit Linux system and click OK when completed", "mm_pbsa command line", 
					JOptionPane.INFORMATION_MESSAGE, null, null, "cd " + outdir + "; /data/amber9/exe/mm_pbsa.pl " + 
					outdir + File.separator + "binding.in > " + outdir + File.separator + "energy.log");
			
			//once this is completed, the resulting energy is printed to snapshot_statistics.out in the outdir directory
			//read the content of the file and display
			StringBuffer buffer = new StringBuffer();
			BufferedReader reader = new BufferedReader(new FileReader(outdir + File.separator + "snapshot_statistics.out"));
			String line = null;
			while ((line = reader.readLine()) != null){
				buffer.append(line);
				buffer.append("\n");
			}
			
//			System.out.println(buffer);

// 			callable.displayTextMessage("Energy calculation results", buffer.toString());
			callable.displayTextMessage(M_Energycalculationr, buffer.toString());
		
		}
		catch (Exception ex){
			callable.removeWaitScreen();
			ex.printStackTrace();
		}
		
	}
	
	private int countFrames(){
		
		//amber format
		int counter = 0;//how many frames were read
		try{
		
			for (int i = 0; i < fileObjects.length; i++){
				BufferedReader reader = null;
				
				
				if (fileObjects[i].toString().endsWith("gz")){
					reader = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(fileObjects[i]))));
				}
				else{
					reader = new BufferedReader(new InputStreamReader(new FileInputStream(fileObjects[i])));
				}
				
				String line = reader.readLine();//may or may not have data
				
				int k = 0;//counter of read blocks of coordinates

				int factor = 0;
				if (currentParameterSet.box > 0) factor = 3;//three more values per frame for box parameters
				int itemCount = currentParameterSet.atomCount*3 + factor;//total number of values for each frame in the file
				int limitNoSolvent = (currentParameterSet.solventStartAtom-1)*3 + factor;//number of values that should be read if no solvent loaded
				boolean solventPresent = false;

				if (currentParameterSet.solventStartResidue > 1){
					solventPresent = true;
				}
				
				while ((line = reader.readLine()) != null){
					try{
						for (int j = 0; j < 10; j++){
							k++;
							if (k == itemCount){
								counter++;
								k = 0;
							}
						}
						
					}
					catch (StringIndexOutOfBoundsException e){
						continue;
					}
					catch (ArrayIndexOutOfBoundsException e){
						e.printStackTrace();
						continue;
					}
					catch (Exception e){
						e.printStackTrace();
						continue;
					}
				}			
			}
		}
		catch (Exception e){
			e.printStackTrace();
		}

		return counter;
	}
	
	public void ptrajComputeRMSD(RMSData rms){
		
		final int ref = rms.reference;
		final int set = rms.extent;
		final String setName = rms.setName;
		final File file = rms.referenceFile;
		final Vector trajectories = rms.trajectories;
		final String parameterFile = rms.parameterFile;
		final boolean internal = rms.internal;
		final boolean selection = rms.selection;

		if (internal){
			if (fileObjects == null || fileObjects.length == 0 ){
// 				callable.displayErrorMessage("No loaded data available to compute RMSD. Load a trajectory file and try again.");
				callable.displayErrorMessage(M_Noloadeddataavaila);
				return;
			}
		}
		else{
			if ( trajectories == null || trajectories.size() == 0 ){
// 				callable.displayErrorMessage("No trajectory files available to compute RMSD. Load a trajectory file and try again.");
				callable.displayErrorMessage(M_Notrajectoryfilesa);
				return;
			}
		}
		
		rmsdBeingUpdated = true;
		
		Thread runner = new Thread(){
			public void run(){
				
				try{
				
					currentRMSDFrames = new Vector();
					double[] refCoordinates = null;
					
					String home = System.getProperty("user.home");
					
					String input = home + File.separator + ".rmsd.in";
					String inputMain = home + File.separator + ".rmsd_main.in";
					
					//we have the reference file
					//now write up the ptraj input file
					PrintWriter printer = new PrintWriter(new FileWriter(inputMain));//input for the actual rmsd calculation
					if (internal){
						for (int i = 0; i < fileObjects.length; i++){
							File ff = fileObjects[i];
							printer.println("trajin " + ff.toString());
						}
					}
					else{
						for (int i = 0; i < trajectories.size(); i++){
							printer.println("trajin " + ((File)trajectories.get(i)).toString());
						}
					}
					
					printer.println("strip :WAT");
					printer.println("strip :Na+");
					printer.println("strip :TIP3");
					printer.println("strip :SOD");
					printer.println("strip :CLA");
					if (file != null){
						printer.println("reference " + file);
						printer.print("rms reference out " + home + File.separator + ".rmsd.dat");
					}
					else{
						printer.print("rms first out " + home + File.separator + ".rmsd.dat");
					}
					
					//now enter mask depending on what atom set is selected
					String mask = null;
					if (set == MDRMSDDialog.USE_ALL_ATOMS){
						mask = "*";
					}
					else if (set == MDRMSDDialog.USE_CA_ATOMS){
						mask = "@CA";
					}
					else {
						mask = "@CA,N,C";
					}

					
					//check whether any residues are selected
					if (selection){
						Structure structure = (Structure)callable.getStructureViewer().getLoadedStructures().get(0);//assuming that one structure is loaded
						StructureStyles styles = structure.getStructureMap().getStructureStyles();
						if (structure != null){
							//let's compose a mask of residue numbers, in case there are (dis)contiguous ranges
							String template = "";
							boolean started = false;
							boolean selecting = false;//current residue is within a selection
							int blockCount = 0;
							Vector residues = structure.getStructureMap().getResidues();
							Residue res = null;
							for (int i = 0; i < residues.size(); i++){
								res = (Residue)residues.get(i);
								System.out.println(res.getResidueId() + res.getCompoundCode() + ": selection = " + styles.isSelected(res));
								if (styles.isSelected(res)){
									if (!selecting){
										if (started){
											//this is not the first block
											template += ",";//to separate from the previous block
										}
										
										template += ":";
										template += res.getResidueId();
										selecting = true;
										blockCount++;
									}
									else{
										blockCount++;
									}
								}
								else{
									if (selecting){
										//end the current range
										if (blockCount > 1){
											template += "-";
											template += (res.getResidueId() - 1);//the previous residue was in fact the last selected one
										}
										selecting = false;
										template += mask;
										
										if (!started) started = true;
										blockCount = 0;
										selecting = false;
									}
								}
							}
							
							if (selecting){
								//selection went until the last residue
								//include the last range
								if (blockCount > 1){
									template += "-";
									template += (res.getResidueId());
								}
								selecting = false;
								template += mask;
								
							}
							
							mask = template;

						}
						
					}
					
					printer.println(" " + mask + " time 2.0");
					
					printer.println("go");
					printer.flush();
					printer.close();
					
					if (ref == MDRMSDDialog.LOWEST_FRAME){
						
						//here, we combine the two commands in one line (generation of the reference pdb and rmsd calculation)
						double min = 1000000000;
						int minFrame = -1;
						int fileIndex = -1;
						//precalculate coordinates of the reference
						//first, locate the lowest energy frame
						for (int i = 0; i < currentDataFrames.size(); i++){
							double[] data = (double[])currentDataFrames.get(i);
							double e = data[5];//take into account the potential energy of the system
							if (e < min){
								min = e;
								minFrame = i;
								fileIndex = (int)data[6];
							}
						}
						
						File mdfile = fileObjects[fileIndex];
						
						int frameOffset = ((Integer)frameOffsets.get(fileIndex)).intValue();
//						System.out.println("frame offset for the file = " + frameOffset);
						
						int relativeIndex = minFrame - frameOffset + 1;//to account for 1-based frame count, as opposed to 0-based vector indices
						
						if (currentFrameSet.size() < minFrame){
							//use ptraj to get the frame in question from the trajectory files
							printer = new PrintWriter(new FileWriter(input));
							printer.println("trajin " + mdfile.toString() + " " + relativeIndex + " " + relativeIndex);
							printer.println("trajout " + home + File.separator + ".rmsd.pdb pdb");
							printer.flush();
							printer.close();
							
							
							//now let's run ptraj to get the pdb reference file out of the trajectory
							//followed by the actual RMSD calculation
							try{
								
								String blank = (String)JOptionPane.showInputDialog(parent, "Run this command in a shell and click OK when completed", "ptraj command line", 
										JOptionPane.INFORMATION_MESSAGE, null, null, ptrajPath + " " + prmtop + " " + input +
										"; mv " + home + File.separator + ".rmsd.pdb." + relativeIndex + " " + home + File.separator + ".rmsd.pdb; " +
										ptrajPath + " " + parameterFile + " " + inputMain);
								
								if (blank == null) return;
							}
							catch (Exception exx){
								rmsdBeingUpdated = false;
								callable.removeWaitScreen();
// 								callable.displayExceptionMessage("Exception saving the RMSD reference structure", exx);
								callable.displayExceptionMessage(M_Exceptionsavingthe, exx);
								return;
							}
							
						}
						else{
							//get the structure of that frame and save it as a pdb file
							//use the existing structure object to update its coordinates and save as a pdb file
							double[] frame = (double[])currentFrameSet.get(minFrame);
							
							//save the current coordinates of the structure object
							double[] temp = new double[structure.getStructureMap().getAtomCount()*3];
							int counter = 0;
							for (int i = 0; i < structure.getStructureMap().getAtomCount(); i++){
								Atom a = structure.getStructureMap().getAtom(i);
								temp[counter] = a.coordinate[0];
								a.coordinate[0] = frame[counter++];
								temp[counter] = a.coordinate[1];
								a.coordinate[1] = frame[counter++];
								temp[counter] = a.coordinate[2];
								a.coordinate[2] = frame[counter++];
							}
							
							//save the structure
							IOHandler.savePdb(structure, file.toString(), callable, null, false, true);
							
							//once the file is saved, restore original coordinates of the structure
							counter = 0;
							for (int i = 0; i < structure.getStructureMap().getAtomCount(); i++){
								Atom a = structure.getStructureMap().getAtom(i);
								a.coordinate[0] = temp[counter++];
								a.coordinate[1] = temp[counter++];
								a.coordinate[2] = temp[counter++];
							}
							
							String blank = (String)JOptionPane.showInputDialog(parent, "Run this command in a shell and click OK when completed", "ptraj command line", 
									JOptionPane.INFORMATION_MESSAGE, null, null, ptrajPath + " " + parameterFile + " " + inputMain);
							if (blank == null) return;
							
						}
					}
					else if (ref == MDRMSDDialog.ANOTHER_STRUCTURE){
						//populate reference with another structure atoms
						//whether the file is pdb, rst, inpcrd or mdcrd, we only need to get coordinates of the atoms from
						//the first available frame
						
						//IMPORTANT: check to make sure the reference has the same atom count as the loaded structure!
						
						refCoordinates = MDUtils.getCoordinates(file);
						
						if (refCoordinates == null || refCoordinates.length == 0){
// 							callable.displayErrorMessage("Reference file contains no data.");
							callable.displayErrorMessage(M_Referencefileconta);
							rmsdBeingUpdated = false;
							pending = false;
							return;
						}
						
						if (refCoordinates.length != currentParameterSet.atomCount*3){
// 							callable.displayErrorMessage("Selected reference has different atom count from the currently loaded data. Select another reference and try again.");
							callable.displayErrorMessage(M_Selectedreferenceh);
							rmsdBeingUpdated = false;
							pending = false;
							return;
						}
						
						String blank = (String)JOptionPane.showInputDialog(parent, "Run this command in a shell and click OK when completed", "ptraj command line", 
								JOptionPane.INFORMATION_MESSAGE, null, null, ptrajPath + " " + parameterFile + " " + inputMain);

						if (blank == null) return;
					}
					else{		
						
						String blank = (String)JOptionPane.showInputDialog(parent, "Run this command in a shell and click OK when completed", "ptraj command line", 
								JOptionPane.INFORMATION_MESSAGE, null, null, ptrajPath + " " + parameterFile + " " + inputMain);
						
						if (blank == null) return;
					}
					
					
					try{
				        
						//now let's parse the output file and pass the data to the display panel
						String output = home + File.separator + ".rmsd.dat";
						File out = new File(output);
						if (out.exists()){
							BufferedReader reader = new BufferedReader(new FileReader(out));
							String line = null;
							while ((line = reader.readLine()) != null){
								String record = line.trim();
								String value = record.substring(record.indexOf(" "));
								currentRMSDFrames.add(new Double(value));
							}
							
							reader.close();
						}
						else{
							rmsdBeingUpdated = false;
							callable.removeWaitScreen();
							callable.displayErrorMessage("Ptraj failed to calculate RMSD");
							return;
						}
						
					}
					catch (Exception ex){
						rmsdBeingUpdated = false;
						ex.printStackTrace();
						callable.displayExceptionMessage("Exception running ptraj for rmsd calculation", ex);
						return;
					}
					
					
					rmsdBeingUpdated = false;
					
					callable.removeWaitScreen();
					rmsd.setEnabled(true);
					rmsdLabelValue.setText("0.000");
					Thread runner = new Thread(){
						public void run(){
							if (rmsdGraphPanel != null){
								rmsdGraphPanel.setVisible(true);
							}
							else{
								rmsdGraphPanel = new RMSDPanel(callable, thisObject);
							}
							rmsdGraphPanel.updateGraph(set, setName);
						}
					};
					runner.start();

				
				}
				catch (Exception exx){
					rmsdBeingUpdated = false;
					exx.printStackTrace();
					callable.displayExceptionMessage("Exception running ptraj rmsd", exx);
				}
				
			}
		};
		runner.start();
	}
	
	
	private boolean pending = false;
	

	private Border createTitledBorder(String title){
		
		Border border1 = BorderFactory.createEmptyBorder(0,0,0,0);//left offset of the boxes in the box
		TitledBorder border2 = BorderFactory.createTitledBorder(new EtchedBorder(), " " + title + " ", TitledBorder.TRAILING, TitledBorder.DEFAULT_POSITION);
		border2.setTitleColor(Color.black);
// 		border2.setTitleFont(new Font("Dialog", 0, 12));
		border2.setTitleFont(new Font(M_Dialog, 0, 12));
		Border border = BorderFactory.createCompoundBorder(border1, border2);

		return border;
	}
	
	public String getParameterFile(){
		return prmtop;
	}
	
	/**
	 * This class is run in a separate thread and it makes sure that the frame buffer is filled.
	 * The reading method is started when the file is first read, as well as when play or step functions are activated
	 * 
	 * @author Sasha Buzko
	 *
	 */
	private class MDController implements Controller {
		
		private boolean stop = false;
		private boolean resetController = false;
		
		public void stop(){
			stop = true;
		}
		
		public void setStop(boolean stop){
			this.stop = stop;
		}
		
		public void reset(){
			resetController = true;
		}
		
		public int getType(){
			return MDPanel.CONTROLLER_AMBER;
		}
		
		public void readFiles(){
			
			if (currentParameterSet == null){
// 				callable.displayErrorMessage("Parameter file must be loaded before the MD trajectory file");
				callable.displayErrorMessage(M_Parameterfilemustb);
				return;
			}
			
			int factor = 0;
			if (currentParameterSet.box > 0) factor = 3;//three more values per frame for box parameters
			int itemCount = currentParameterSet.atomCount*3 + factor;//total number of values for each frame in the file
			int limitNoSolvent = (currentParameterSet.solventStartAtom-1)*3;//number of values that should be read if no solvent loaded
			boolean solventPresent = false;
			
			fileMap = new Vector();
			
			while (true){
				
				if (stop){
					break;
				}
				
				try{
					Thread.sleep(10);
					InputStreamReader reader = null;
					File file = null;//file where the reading should begin
					int index = -1;//position of the frame within the file that we are looking for: 1-based

					//counter is the total numbering in the entire run: e.g. counter = 60 means that we need to fill
					//frame 60, which may in fact come as frame 10 in file 2
					
					
					int counter = currentFrame;//at the beginning currentFrame = 1
					if (counter == 0) counter = 1;//in case it's the very beginning, and the first frame hasn't been loaded yet
					int fileCounter = 0;//zero-based count of input files
					
					boolean process = false;
					
					if (currentFrameSet == null || currentFrameSet.size() == 0){
						process = true;
					}
					else{
						// check whether there is sufficient frame buffer
						int max = 0;
						int min = Math.max(0, currentFrame - 5);
						if (loadingCompleted){
							max = Math.min(currentFrameSet.size(), currentFrame+frameBufferSize-1);
							for (int i = min; i < max; i++){
								if (currentFrameSet.get(i) == null){//start checking from the next frame
									counter = i;
									process = true;
									break;
								}
							}
						}
						else{//loading is not done yet
							max = currentFrame+frameBufferSize-1;
							for (int i = min; i < max; i++){
								if (currentFrameSet.size() == i || currentFrameSet.get(i) == null){
									counter = i;
									process = true;
									break;
								}
							}
						}
					}
					
					if (!process){
						continue;
					}
					
//					counter++;//1-based count
					
//					System.out.println("Need to process starting at " + counter);//1-based count
					
					//since we are here, the frame(s) need to be filled
					if (fileMap != null && fileMap.size() > counter){
						file = (File)fileMap.get(counter-1);
						reader = getReader(file);
					}
					
					if (reader == null){
						
						//it hasn't been read yet
						//most likely, this is the first pass when the entire data set has not loaded yet
						//so the current frame hasn't been loaded
						//check the last one
						int lastIndex = -1;
						try{
							lastIndex = ((Integer)frameReference.get(counter-2)).intValue();//decrement by two to get to the previous 1-based frame
						}
						catch (Exception e){
//							e.printStackTrace();
						}
						if (lastIndex == -1){
							//most likely, this is the first frame in the loading sequence (entire run), so load everything from the start
							fileCounter = 0;
							file = fileObjects[fileCounter];
							reader = getReader(file);
							index = 1;
						}
						else{
							//there WAS a previous frame
							//check frame count of the last frame's file, just to make sure we haven't started the new one
							//if the last frame's index == frame count, then we need to open next file and reset frame index to 1
							File lastFile = (File)fileMap.get(counter-2);
							int lastFrameCount = ((Integer)frameCounts.get(lastFile)).intValue();
							if (lastIndex == lastFrameCount){
								//we start over
								index = 1;
								
								//figure out which reader we pick
								for (int i = 0; i < fileObjects.length; i++){
									if (fileObjects[i] == lastFile){
										fileCounter = i+1;
										break;
									}
								}
								file = fileObjects[fileCounter];
								reader = getReader(file);
							}
							else{
								//we continue in the previously read file
								index = lastIndex + 1;
								//figure out which reader we pick
								for (int i = 0; i < fileObjects.length; i++){
									if (fileObjects[i] == lastFile){
										fileCounter = i;
										break;
									}
								}
								file = fileObjects[fileCounter];
								reader = getReader(file);
							}
						}
					}
					else{
						//reader is not null, so this is a pass over data that have already been read before
						//just get the index out of the hash and proceed
						index = ((Integer)frameReference.get(counter)).intValue();
						//figure out which reader we pick
						for (int i = 0; i < fileObjects.length; i++){
							if (fileObjects[i] == file){
								fileCounter = i;
								break;
							}
						}
					}
					
//					System.out.println("fileCounter = " + fileCounter);
					
//					System.out.println("index = " + index);
					//now we have the file reader and the 1-based index of the empty frame
					//get the data and fill in
					
					//the information we have is a starting point for data import
					//if necessary, we'll go over to the next files
					//reference hashes will be populated if necessary
					while (true){
						try{
//							System.err.println("checking for reset");
							if (resetController){
								resetController = false;
								break;
							}
							
							BufferedReader bufferedReader = new BufferedReader(reader);
							try{
								String line = bufferedReader.readLine();//may or may not have data
								double[] data = null;
								if (loadSolvent){
									data = new double[itemCount];//initialization of the first set of coordinates
								}
								else{
									if (currentParameterSet.solventStartResidue > 1){
										solventPresent = true;
										data = new double[limitNoSolvent];//initialization of the first set of coordinates
									}
									else{
										//there is no solvent anyway
										data = new double[itemCount];
									}
								}
								
								int lineCount = 0;
								int i = 0;//counter of read blocks of coordinates
								int dataCount = 0;
								int recordIndex = 0;

								boolean out = false;
								while ((line = bufferedReader.readLine()) != null){
									try{
										boolean terminate = false;
										for (int j = 0; j < 10; j++){
											if (loadSolvent || !solventPresent){
												data[dataCount] = Double.parseDouble(line.substring(j*8, (j+1)*8).trim());
												dataCount++;
											}
											else{
												//check if there is solvent
												if (solventPresent && i < limitNoSolvent){
													data[dataCount] = Double.parseDouble(line.substring(j*8, (j+1)*8).trim());
													dataCount++;
												}
												else{
													line.substring(j*8, (j+1)*8);//to make sure exception is thrown over blank fields and they are not counted
												}
											}
											i++;
											if (i == itemCount){
//												System.out.println("i = " + i);
												recordIndex++;
//												System.err.println("recordIndex = " + recordIndex);
												//check whether we need to skip this record or read it
												if (index > recordIndex){
													//we skip
													dataCount = 0;
													i = 0;
													continue;
												}
												
//												System.out.println("currentFrameSet = " + currentFrameSet + ", counter = " + counter);
												//the data should be added at counter-1 (to account for 0-based vector layout)
												//if there is nothing at that index, append data
												if (currentFrameSet.size() >= counter){
													currentFrameSet.set(counter-1, data);
												}
												else{
													currentFrameSet.add(data);
//													System.out.println("Added frame to size = " + currentFrameSet.size());
													frameReference.add(new Integer(recordIndex));
													fileMap.add(file);
												}
												
//												System.out.println("currentFrameSet = " + currentFrameSet.size());
												
												//update the frame count
// 												if (!loadingCompleted) framesLabelValue.setText("Loading (" + currentFrameSet.size() + ")");
												if (!loadingCompleted) framesLabelValue.setText(M_Loading_3 + currentFrameSet.size() + ")");
												
												if (loadSolvent || !solventPresent){
													data = new double[itemCount];
												}
												else{
													data = new double[limitNoSolvent];
												}
												
												if (currentFrameSet.size() == 1){
													//wait until the loading is done, then proceed with loading frames
													while (true){
														Thread.sleep(5);
														if (loadedFirstFrame) break;
													}
												}
												
												dataCount = 0;
												i = 0;
												
												counter++;
												
												//add a reference to the file reader
												
												//here check whether we need to go any further
												while (true){
													try{
														boolean outside = false;
														Thread.sleep(1);
														
														if (resetController){
//															System.out.println("reset controller after having loaded " + currentFrameSet.size() + " frames");
															outside = true;
															terminate = true;
															out = true;
															break;
														}
														
														//in case there is general stop event
														if (stop){
															outside = true;
															terminate = true;
															out = true;
															resetController = true;
															break;
														}
														
														int start = currentFrame - 5;
														if (start < 0) start = 0;
														
/*														if (currentFrame > 1){
															//check the back frames first
															for (int k = start; k <= currentFrame; k++){
																if (currentFrameSet.get(k) == null){
																	outside = true;
																	out = true;
																	terminate = true;
																	System.out.println("need to fill back frames");
																	break;
																}
															}
														}
*/														
														int limit = currentFrame + frameBufferSize - 1;
														for (int k = currentFrame; k < limit; k++){
															if (currentFrameSet.size() <= k || currentFrameSet.get(k) == null){
																outside = true;
																break;
															}
														}
														
														if (outside) break;
													
													}
													catch (InterruptedException e){
//														e.printStackTrace();
														break;
													}
													catch (Exception ex){
														ex.printStackTrace();
														break;
													}
												}
											}
											
											if (terminate){
												break;
											}
										}
										
										if (lineCount == 500){
											lineCount = 0;
											Thread.sleep(1);
										}
										
										if (out){
											
											break;
										}
									}
									catch (StringIndexOutOfBoundsException e){
//										e.printStackTrace();
										continue;
									}
									catch (ArrayIndexOutOfBoundsException e){
										e.printStackTrace();
										continue;
									}
									catch (Exception e){
										e.printStackTrace();
										continue;
									}
									
									lineCount++;
								}
								
								frameCounts.put(file, new Integer(recordIndex));
//								System.out.println("adding " + recordIndex + " to frameCounts");

								if (!out){
									//record the frame count
									reader.close();
									
									//finished reading one file. check if it's sufficient
									fileCounter++;
									if (fileCounter == fileObjects.length){
										loadingCompleted = true;
										framesLabelValue.setText(new Integer(currentFrameSet.size()).toString());
										break;
									}
									file = fileObjects[fileCounter];
									reader = getReader(file);
									index = 1;
								}
							}
							catch (Exception ee){
								ee.printStackTrace();
								break;
							}
						}
						catch (Exception e){
							e.printStackTrace();
						}
					}
					
					
				}
				catch (Exception e){
//					System.out.println("e = " + e);
//					e.printStackTrace();
				}
				
			}
			
		}
		
	}
	
	private class DCDController implements Controller {

		private boolean stop = false;
		private boolean resetController = false;
		
		private Vector streams = new Vector();
		
		public void stop(){
			stop = true;
		}
		
		public int getType(){
			return MDPanel.CONTROLLER_CHARMM;
		}
		
		public void setStop(boolean stop){
			this.stop = stop;
		}
		
		public void reset(){
			resetController = true;
		}
		
		public void readFiles(){
			
			if (currentParameterSet == null){
// 				callable.displayErrorMessage("Parameter file must be loaded before the DCD trajectory file");
				callable.displayErrorMessage(M_Parameterfilemustb_2);
				return;
			}
			
			
			//read the header of the first file
			try{
				
				DCDHeader referenceHeader = null;
				totalFrames = 0;
				dcdHeaders = new HashMap();
				for (int i = 0; i < fileObjects.length; i++){
					DCDHeader header = MDUtils.getDCDHeader(fileObjects[i]);
					dcdHeaders.put(fileObjects[i], header);
					totalFrames += header.frameCount;
					if (i == 0) referenceHeader = header;
				}
				
				if (referenceHeader.qcryst != 0){
					currentParameterSet.box = 1;
				}
				
				
				if (referenceHeader.atomCount != currentParameterSet.atomCount){
// 					callable.displayErrorMessage("Selected DCD file(s) doesn't match the loaded PSF/PDB file.");
					callable.displayErrorMessage(M_SelectedDCDfilesdo_1);
					return;
				}
			}
			catch (Exception e){
				e.printStackTrace();
				return;
			}

			
			int factor = 0;
			if (currentParameterSet.box > 0) factor = 3;//three more values per frame for box parameters
//			System.out.println("currentParameterSet box = " + currentParameterSet.box);
			
			int itemCount = currentParameterSet.atomCount*3 + factor;//total number of values for each frame in the file
			int limitNoSolvent = (currentParameterSet.solventStartAtom-1)*3 + factor;//number of values that should be read if no solvent loaded
			boolean solventPresent = false;
			
			fileMap = new Vector();//frame index -> File
			
			while (true){
				
				if (stop){
					break;
				}
				
				//counter indicates which frame (1-based) needs to be filled first, i.e. the first null frame
				
				try{
					Thread.sleep(5);
					
					MappedByteBuffer byteBuffer = null;
					File file = null;
					int index = -1;//position of the frame within the file

					int counter = currentFrame;//at the beginning currentFrame = 1
					int fileCounter = 0;
					
					boolean process = false;
					
					if (currentFrameSet == null || currentFrameSet.size() == 0){
						process = true;
					}
					else{
						// check whether there is sufficient frame buffer
						int limit = 0;
						if (loadingCompleted){
							limit = Math.min(currentFrameSet.size(), currentFrame+frameBufferSize-1);
							for (int i = counter; i < limit; i++){
								if (currentFrameSet.get(i) == null){//start checking from the next frame
									counter = i + 1;//counter is 1-based
									process = true;
									break;
								}
							}
						}
						else{//loading is not done yet
							limit = currentFrame+frameBufferSize-1;
							for (int i = counter; i < limit; i++){
								if (currentFrameSet.size() == i || currentFrameSet.get(i) == null){
									counter = i + 1;
									process = true;
									break;
								}
							}
						}
					}
					
					if (!process){
						continue;
					}
					
					if (counter == 0) counter = 1;
					
//					System.out.println("Need to update at counter = " + counter);
					
					//since we are here, the frame needs to be filled
					if (fileMap != null && fileMap.size() > counter){
						file = (File)fileMap.get(counter);
						byteBuffer = getByteBuffer(file);
					}
					
					if (byteBuffer == null){
						
						//it hasn't been read yet
						//most likely, this is the first pass when the entire data set has not loaded yet
						//so the current frame hasn't been loaded
						//check the last one
						int lastIndex = -1;
						try{
							lastIndex = ((Integer)frameReference.get(counter-2)).intValue();//decrement by two to get to the previous 1-based frame
						}
						catch (Exception e){
//							e.printStackTrace();
						}
						
//						System.out.println("lastIndex = " + lastIndex);
						
						
						if (lastIndex == -1){
							//most likely, this is the first frame in the loading sequence (entire run), so load everything from the start
							fileCounter = 0;
							file = fileObjects[fileCounter];
							byteBuffer = getByteBuffer(file);
//							System.out.println("index set to 1");
							index = 1;
						}
						else{
							//there WAS a previous frame
							//check frame count of the last frame's file, just to make sure we haven't started the new one
							//if the last frame's index == frame count, then we need to open next file and reset frame index to 1
							File lastFile = (File)fileMap.get(counter-2);
							int lastFrameCount = ((DCDHeader)dcdHeaders.get(lastFile)).frameCount;
							if (lastIndex == lastFrameCount){
								//we start over
								index = 1;
								
								//figure out which reader we pick
								for (int i = 0; i < fileObjects.length; i++){
									if (fileObjects[i] == lastFile){
										fileCounter = i+1;
										break;
									}
								}
								file = fileObjects[fileCounter];
								byteBuffer = getByteBuffer(file);
							}
							else{
								//we continue in the previously read file
								index = lastIndex + 1;
								//figure out which reader we pick
								for (int i = 0; i < fileObjects.length; i++){
									if (fileObjects[i] == lastFile){
										fileCounter = i;
										break;
									}
								}
								file = fileObjects[fileCounter];
								byteBuffer = getByteBuffer(file);
							}
							
//							System.out.println("index = " + index);
						}
					}
					else{
						//buffer is not null, so this is a pass over data that have already been read before
						//just get the index out of the hash and proceed
						index = ((Integer)frameReference.get(counter)).intValue();
						//figure out which reader we pick
						for (int i = 0; i < fileObjects.length; i++){
							if (fileObjects[i] == file){
								fileCounter = i;
								break;
							}
						}
					}
					
					boolean e = MDUtils.isDCDBigEndian(file);
					if (e){
						byteBuffer.order(ByteOrder.BIG_ENDIAN);//just in case, since Java is big endian by default
					}
					else{
						byteBuffer.order(ByteOrder.LITTLE_ENDIAN);
					}
					
					DCDHeader h = MDUtils.getDCDHeader(file);
					int headerSize = h.headerSize;
					if (dcdHeaders == null) dcdHeaders = new HashMap();
					dcdHeaders.put(file, h);
					
//					System.out.println("index = " + index + ", header size = " + headerSize);
					//now we have the byteBuffer and the index of the empty frame
					//get the data and fill in
					
//					System.out.println("index = " + index);
					
					//the information we have is a starting point for data import
					//if necessary, we'll go over to the next files
					//reference hashes will be populated if necessary
					while (true){
						try{

							if (resetController){
								resetController = false;
								break;
							}
							
							try{
								double[] data = null;
								float[] charges = null;
								if (h.qcg > 0){
									//there are charges
									charges = new float[currentParameterSet.atomCount];//initialization of the first set of coordinates
								}

								if (loadSolvent){
									data = new double[itemCount];//initialization of the first set of coordinates
								}
								else{
									if (currentParameterSet.solventStartResidue > 1){
										solventPresent = true;
										data = new double[limitNoSolvent];//initialization of the first set of coordinates
									}
									else{
										//there is no solvent anyway
										data = new double[itemCount];
									}
								}
									
								//calculate offset for the buffer to start at: header + three blocks of X, Y, Z 4 bytes for each atom + 3 pairs
								//of enclosing 4 byte markers
								DCDHeader currentHeader = (DCDHeader)dcdHeaders.get(file);
//								System.out.println("qcg = " + currentHeader.qcg);
								
								int recordIndex = index;
								
//								System.out.println("starting reading from index = " + index);
								
								
								int correction = 0;//correction factor
								if (currentHeader.qcryst > 0){
									correction += 56;
								}
								
								if (currentHeader.qcg > 0){
									correction += (8 + currentParameterSet.atomCount*4);
								}
								int offset = currentHeader.headerSize + (index - 1)*(24 + currentParameterSet.atomCount*4*3 + correction);
								byteBuffer.position(offset);

								boolean stopfor = false;
								for (int f = index; f <= currentHeader.frameCount; f++){
									
									int i = 0;
									
									if (stopfor) break;
									int dataCount = 0;
									
									//check for qcryst
									if (currentHeader.qcryst > 0){
										int v = byteBuffer.getInt();
//										System.out.println("reading qcryst: v = " + v);
										int reads = v/8;
										for (int vv = 0; vv < reads; vv++){
											byteBuffer.getDouble();
										}
										int vvv = byteBuffer.getInt();
									}
									
									//first, read all X's for this frame
									int a = byteBuffer.getInt();
									for (int j = 0; j < currentParameterSet.atomCount; j++){
										float c = byteBuffer.getFloat();
										if (loadSolvent || !solventPresent){
											data[dataCount] = (double)c;
											dataCount += 3;//fast forward to the next X
											i++;
										}
										else{
											//check if there is solvent
											if (solventPresent && i < limitNoSolvent){
												data[dataCount] = (double)c;
												dataCount += 3;
												i++;
											}
										}
									}
									int aa = byteBuffer.getInt();
									
									dataCount = 1;
									
									i = 0;
									//read Y records
									byteBuffer.getInt();
									for (int j = 0; j < currentParameterSet.atomCount; j++){
										float c = byteBuffer.getFloat();
										if (loadSolvent || !solventPresent){
											data[dataCount] = (double)c;
											dataCount += 3;//fast forward to the next Y
											i++;
										}
										else{
											//check if there is solvent
											if (solventPresent && i < limitNoSolvent){
												data[dataCount] = (double)c;
												dataCount += 3;
												i++;
											}
										}
									}
									byteBuffer.getInt();
//									System.out.println("recorded " + i + " y values");
									
									//read Z records
									i = 0;
									dataCount = 2;
									byteBuffer.getInt();
									for (int j = 0; j < currentParameterSet.atomCount; j++){
										float c = byteBuffer.getFloat();
										if (loadSolvent || !solventPresent){
											data[dataCount] = (double)c;
											dataCount += 3;//fast forward to the next Z
											i++;
										}
										else{
											//check if there is solvent
											if (solventPresent && i < limitNoSolvent){
												data[dataCount] = (double)c;
												dataCount += 3;
												i++;
											}
										}
									}
									byteBuffer.getInt();
									
									i = 0;
									if (currentHeader.qcg > 0){
										int bbb = byteBuffer.getInt();
//										System.out.println("reading qcg at " + bbb);
										for (int j = 0; j < currentParameterSet.atomCount; j++){
											charges[i] = byteBuffer.getFloat();
											i++;
										}
										int aaa = byteBuffer.getInt();
//										System.out.println("aaa = " + aaa);
									}
									
//									System.out.println("recorded " + i + " z values");

									if (currentFrameSet.size() >= counter){
										currentFrameSet.set(counter-1, data);
										if (charges != null) chargeSet.set(counter-1, charges);
									}
									else{
										currentFrameSet.add(data);
										if (charges != null) chargeSet.add(charges);
										frameReference.add(new Integer(recordIndex));
										fileMap.add(file);
									}
									
									if (currentFrameSet.size() == 1){
										//wait for the first frame loader to finish
										while (true){
											try{
												Thread.sleep(5);
												if (loadedFirstFrame) break;
											}
											catch (InterruptedException ex){
												break;
											}
										}
										
									}
//									System.out.println("loaded frame " + f + ", data size = " + data.length + ", set size = " + currentFrameSet.size());
									
//									System.out.println("########################");
									
									//update the frame count
// 									if (!loadingCompleted) framesLabelValue.setText("Loading (" + counter + ")");
									if (!loadingCompleted) framesLabelValue.setText(M_Loading_3 + counter + ")");
									counter++;
									
									if (loadSolvent || !solventPresent){
										data = new double[itemCount];
									}
									else{
										data = new double[limitNoSolvent];
									}
		
									recordIndex++;
									
									//check if we need to go any further or the frame buffer is sufficient
									while (true){
		
										try{
											boolean outside = false;
											Thread.sleep(2);
											
											if (resetController){
												outside = true;
												stopfor = true;
												break;
											}
											
											//in case there is general stop event
											if (stop){
												outside = true;
												stopfor = true;
												resetController = true;
												break;
											}
											
											int limit = currentFrame + frameBufferSize - 1;
											int start = currentFrame - 1;
											for (int k = start; k < limit; k++){
												if (currentFrameSet.size() <= k || currentFrameSet.get(k) == null){
													outside = true;
													break;
												}
											}
		//									if (outside) System.err.println("Processing further: limit = " + limit + ", null at " + 
		//											counter + " with current frame = " + currentFrame);
											
											if (outside) break;
										
										}
										catch (InterruptedException exx){
											exx.printStackTrace();
											break;
										}
										catch (Exception ex){
											ex.printStackTrace();
											break;
										}
									}
									
								}
								
								if (!stopfor){
									fileCounter++;
									if (fileCounter == fileObjects.length){
										loadingCompleted = true;
//										System.out.println("Loading completed");
										framesLabelValue.setText(new Integer(currentFrameSet.size()).toString());
										
//										System.out.println("total frames = " + currentFrameSet.size());
										break;
									}
									file = fileObjects[fileCounter];
									DCDHeader hh = MDUtils.getDCDHeader(file);
									dcdHeaders.put(file, hh);
									byteBuffer = getByteBuffer(file);

									index = 1;
									recordIndex = 1;
								}
							}
							catch (Exception ee){
								ee.printStackTrace();
//								resetController = true;
//								stop = true;
								continue;
//								break;
							}
						}
						catch (Exception ex){
//							ex.printStackTrace();
						}
					}
				}
				catch (Exception w){
//					w.printStackTrace();
				}
			}
		}
	}
	
	private InputStreamReader getReader(File file){
		if (file.toString().endsWith("gz")){
			try{
				return new InputStreamReader(new GZIPInputStream(new FileInputStream(file)));
			}
			catch (Exception ex){
				ex.printStackTrace();
				return null;
			}
		}
		else{
			try{
				return new java.io.FileReader(file);
			}
			catch (Exception ex){
				ex.printStackTrace();
				return null;
			}
		}

	}
	
	private MappedByteBuffer getByteBuffer(File file){
		try{
			FileInputStream fis = new FileInputStream(file);
			FileChannel channel = null;
			if (byteChannels.containsKey(file)){
				channel = (FileChannel)byteChannels.get(file);
				MappedByteBuffer buffer = (MappedByteBuffer)byteBuffers.get(channel);
				buffer.rewind();
				return buffer;
			}
			else{
				channel = fis.getChannel();
				byteChannels.put(file, channel);
				MappedByteBuffer buffer = channel.map(FileChannel.MapMode.READ_ONLY, 0, channel.size());
				boolean ee = MDUtils.isDCDBigEndian(file);
				if (ee){
					buffer.order(ByteOrder.BIG_ENDIAN);//just in case, since Java is big endian by default
				}
				else{
					buffer.order(ByteOrder.LITTLE_ENDIAN);
				}
				byteBuffers.put(channel, buffer);
				return buffer;
			}
			
		}
		catch (Exception e){
			e.printStackTrace();
			return null;
		}
	}
	
	private MappedByteBuffer getAuxByteBuffer(File file){
		try{
			FileInputStream fis = new FileInputStream(file);
			FileChannel channel = null;
			if (auxByteChannels.containsKey(file)){
				channel = (FileChannel)auxByteChannels.get(file);
				MappedByteBuffer buffer = (MappedByteBuffer)auxByteBuffers.get(channel);
				buffer.rewind();
				return buffer;
			}
			else{
				channel = fis.getChannel();
				auxByteChannels.put(file, channel);
				MappedByteBuffer buffer = channel.map(FileChannel.MapMode.READ_ONLY, 0, channel.size());
				boolean ee = MDUtils.isDCDBigEndian(file);
				if (ee){
					buffer.order(ByteOrder.BIG_ENDIAN);//just in case, since Java is big endian by default
				}
				else{
					buffer.order(ByteOrder.LITTLE_ENDIAN);
				}
				auxByteBuffers.put(channel, buffer);
				return buffer;
			}
			
		}
		catch (Exception e){
			e.printStackTrace();
			return null;
		}
	}

}
